enum PBTYPE  // Pushbutton Type
{
  PB_SwitchAnything  = 0,
  PB_SwitchHand      = 1,
  PB_LockKeep        = 2,
  PB_LockRemove      = 3,
  PB_LastLockRotate  = 4,
  PB_LastLockDelete  = 5,
  PB_AlcoveAnything  = 6,
  PB_AlcoveObject    = 7,
  PB_AlcoveNotObject = 8,
  PB_GiftFromGod     = 9
};



class ACTUATOR_PressurePad:DB3
{
private:
public:
  ACTUATOR_PressurePad();
  ~ACTUATOR_PressurePad(void);
  void Clear(void);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int Edit(LOCATIONREL locr, RN RNpressurePad);
  bool localAction(void)     {return DB3::localAction();};
  void localAction(bool b)   {DB3::localAction(b);};
  int  delay(void)           {return DB3::delay();};
  void delay(int d)          {DB3::delay(d);};
  bool onceOnly(void)        {return DB3::onceOnly();};
  void onceOnly(bool b)      {DB3::onceOnly(b);};
  bool audible(void)         {return DB3::audible();};
  void audible(bool b)       {DB3::audible(b);};
  int  targetX(void)         {return DB3::targetX();};
  void targetX(int x)        {DB3::targetX(x);};
  int  targetY(void)         {return DB3::targetY();};
  void targetY(int y)        {DB3::targetY(y);};
  int  targetPos(void)       {return DB3::targetPos();};
  void targetPos(int p)      {DB3::targetPos(p);};
  int  graphic(void)         {return DB3::graphicOrdinal();};
  void graphic(int x)        {DB3::graphicOrdinal(x);};
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL /*locr*/);
  void neededObject(MODIFIEDOBJECTTYPE o) {DB3::value(o.Integer());};
  int  value(void)           {return DB3::value();};
  void value(int v)          {DB3::value(v);};
  int  actuatorType(void)    {return DB3::actuatorType();};
  void actuatorType(int t)   {DB3::actuatorType(t);};
  ACTUATORACTION action(void)  {return DB3::action();};
  void action(ACTUATORACTION a){DB3::action(a);};
  bool normallyClosed(void)    {return DB3::normallyClosed();};
  void normallyClosed(bool b)  {DB3::normallyClosed(b);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString ShortName(void);
  CString GraphicName(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_MonsterGenerator:DB3
{
private:
public:
  ACTUATOR_MonsterGenerator();
  ~ACTUATOR_MonsterGenerator(void);
  void Clear(void);
  int Edit(LOCATIONREL locr, RN RNmonsterGenerator);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int numMonster(void){return delay();};
  void numMonster(int n){delay(n);};
  int hitPointMultiplier(void){return DB3::hitPointMultiplier();};
  void hitPointMultiplier(int h){DB3::hitPointMultiplier(h);};
  MONSTERTYPE monsterType(void){return DB3::value()&0x1f;};
  void monsterType(MONSTERTYPE mt){DB3::value((mt.Integer()&0x1f)|(DB3::value()&0xe0));};
  i32 alternateGraphics(void){return (DB3::value()&0xe0)>>5;};
  void alternateGraphics(i32 a){DB3::value(((a&0x7)<<5)|(DB3::value()&0x1f));};
  bool audible(void){return DB3::audible();};
  void audible(bool b){DB3::audible(b);};
  bool onceOnly(void){return DB3::onceOnly();};
  void onceOnly(bool b){DB3::onceOnly(b);};
  int disableTime(void){return DB3::disableTime();};
  void disableTime(int t){DB3::disableTime(t);};
  bool invisible(void){return DB3::normallyClosed();};
  void invisible(bool b){DB3::normallyClosed(b);};
  bool drawAsSize4(void){return DB3::drawAsSize4();};
  void drawAsSize4(bool b){DB3::drawAsSize4(b);};
  int floorGraphicOrdinal(void){return DB3::graphicOrdinal();};
  void floorGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_PushButton:DB3
{
private:
public:
  ACTUATOR_PushButton(ACTUATORCLASS);
  ~ACTUATOR_PushButton(void);
  void Clear(void);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int  targetX(void)           {return DB3::targetX();};
  void targetX(int x)          {DB3::targetX(x);};
  int  targetY(void)           {return DB3::targetY();};
  void targetY(int y)          {DB3::targetY(y);};
  int  targetPos(void)         {return DB3::targetPos();};
  void targetPos(int p)        {DB3::targetPos(p);};
  int Edit(LOCATIONREL locr); 
  ACTUATORACTION action(void)  {return DB3::action();};
  void action(ACTUATORACTION a){DB3::action(a);};
  bool normallyClosed(void)    {return DB3::normallyClosed();};
  void normallyClosed(bool b)  {DB3::normallyClosed(b);};
  bool onceOnly(void)          {return DB3::onceOnly();};
  void onceOnly(bool b)        {DB3::onceOnly(b);};
  int  delay(void)             {return DB3::delay();};
  void delay(int d)            {DB3::delay(d);};
  int  actuatorType(void)      {return DB3::actuatorType();};
  void actuatorType(int t)     {DB3::actuatorType(t);};
  bool audible(void)           {return DB3::audible();};
  void audible(bool b)         {DB3::audible(b);};
  int wallGraphicOrdinal(void){return DB3::graphicOrdinal();}
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  bool localAction(void) {return DB3::localAction();};
  void localAction(bool b){DB3::localAction(b);};
  i16 localActionType(void) {return DB3::w6_4_15();};
  void localActionType(int i) {DB3::w6_4_15(i);};
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL /*locr*/);
  void neededObject(MODIFIEDOBJECTTYPE n){DB3::value(n.Integer());};
  int GiftType(void){return DB3::value();};
  void GiftType(int n){DB3::value(n);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_Disabled:DB3
{
private:
public:
  ACTUATOR_Disabled();
  ~ACTUATOR_Disabled(void);
  void Clear(void);
  int Edit(LOCATIONREL locr); 
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int wallGraphicOrdinal(void){return DB3::graphicOrdinal();}
  int floorGraphicOrdinal(void){return DB3::graphicOrdinal();}
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  void floorGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  bool localAction(void) {return DB3::localAction();};
  void localAction(bool l){DB3::localAction(l);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_ObjectHolder:DB3
{
private:
public:
  ACTUATOR_ObjectHolder();
  ~ACTUATOR_ObjectHolder(void);
  void Clear(void);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int  targetX(void)           {return DB3::targetX();};
  void targetX(int x)          {DB3::targetX(x);};
  int  targetY(void)           {return DB3::targetY();};
  void targetY(int y)          {DB3::targetY(y);};
  int  targetPos(void)         {return DB3::targetPos();};
  void targetPos(int p)        {DB3::targetPos(p);};
  int Edit(LOCATIONREL locr); 
  ACTUATORACTION action(void)  {return DB3::action();};
  void action(ACTUATORACTION a){DB3::action(a);};
  bool normallyClosed(void)    {return DB3::normallyClosed();};
  void normallyClosed(bool b)  {DB3::normallyClosed(b);};
  bool onceOnly(void)          {return DB3::onceOnly();};
  void onceOnly(bool b)        {DB3::onceOnly(b);};
  int  delay(void)             {return DB3::delay();};
  void delay(int d)            {DB3::delay(d);};
  int  type(void)              {return DB3::actuatorType();};
  void type(int t)             {DB3::actuatorType(t);};
  bool audible(void)           {return DB3::audible();};
  void audible(bool b)         {DB3::audible(b);};
  int wallGraphicOrdinal(void){return DB3::graphicOrdinal();}
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL /*locr*/);
  void neededObject(MODIFIEDOBJECTTYPE n){DB3::value(n.Integer());};
  int localActionType(void) {return DB3::w6_4_15();};
  void localActionType(int i) {DB3::w6_4_15(i);};
  bool localAction(void) {return DB3::localAction();};
  void localAction(bool b) {DB3::localAction(b);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_SwapObject:DB3
{
private:
public:
  ACTUATOR_SwapObject();
  ~ACTUATOR_SwapObject(void);
  void Clear(void);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  int  targetX(void)           {return DB3::targetX();};
  void targetX(int x)          {DB3::targetX(x);};
  int  targetY(void)           {return DB3::targetY();};
  void targetY(int y)          {DB3::targetY(y);};
  int  targetPos(void)         {return DB3::targetPos();};
  void targetPos(int p)        {DB3::targetPos(p);};
  int Edit(LOCATIONREL locr); 
  ACTUATORACTION action(void)  {return DB3::action();};
  void action(ACTUATORACTION a){DB3::action(a);};
  bool onceOnly(void)          {return DB3::onceOnly();};
  void onceOnly(bool b)        {DB3::onceOnly(b);};
  int  delay(void)             {return DB3::delay();};
  void delay(int d)            {DB3::delay(d);};
  int  type(void)              {return DB3::actuatorType();};
  void type(int t)             {DB3::actuatorType(t);};
  bool audible(void)           {return DB3::audible();};
  void audible(bool b)         {DB3::audible(b);};
  int wallGraphicOrdinal(void){return DB3::graphicOrdinal();}
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL /*locr*/);
  void neededObject(MODIFIEDOBJECTTYPE n){DB3::value(n.Integer());};
  int localActionType(void) {return DB3::w6_4_15();};
  void localActionType(int i) {DB3::w6_4_15(i);};
  bool localAction(void) {return DB3::localAction();};
  void localAction(bool b) {DB3::localAction(b);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_Launcher:DB3
{
private:
public:
  ACTUATOR_Launcher();
  ~ACTUATOR_Launcher(void);
  void Clear(void);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int Edit(LOCATIONREL locr);
  int wallGraphicOrdinal(void){return DB3::graphicOrdinal();}
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  int energyRemaining(void){return DB3::energyRemaining();};
  void energyRemaining(int e){DB3::energyRemaining(e);};
  int missileType(void){return DB3::value();};
  void missileType(int t){DB3::value(t);};
  int launcherType(void){return DB3::actuatorType();};
  void launcherType(int t){DB3::actuatorType(t);};
  bool onceOnly(void){return DB3::onceOnly();};
  void onceOnly(bool o){DB3::onceOnly(o);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_AndOr:DB3
{
private:
public:
  ACTUATOR_AndOr(void);
  ~ACTUATOR_AndOr(void);
  void Clear(void);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  int Edit(LOCATIONREL locr, RN RNandOr);
  int  delay(void)             {return DB3::delay();};
  void delay(int d)            {DB3::delay(d);};
  bool normallyClosed(void)    {return DB3::normallyClosed();};
  void normallyClosed(bool b)  {DB3::normallyClosed(b);};
  bool onceOnly(void)          {return DB3::onceOnly();};
  void onceOnly(bool b)        {DB3::onceOnly(b);};
  int  initialValue(void)      {return DB3::initialValue();};
  void initialValue(int v)     {DB3::initialValue(v);};
  int  finalValue(void)        {return DB3::finalValue();};
  void finalValue(int v)       {DB3::finalValue(v);};
  ACTUATORACTION action(void)  {return DB3::action();};
  void action(ACTUATORACTION a){DB3::action(a);};
  int  targetPos(void)         {return DB3::targetPos();};
  void targetPos(int p)        {DB3::targetPos(p);};
  int  targetX(void)           {return DB3::targetX();};
  void targetX(int x)          {DB3::targetX(x);};
  int  targetY(void)           {return DB3::targetY();};
  void targetY(int y)          {DB3::targetY(y);};
  int wallGraphicOrdinal(void)  {return DB3::graphicOrdinal();};
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  bool localAction(void) {return DB3::localAction();};
  void localAction(bool b) {DB3::localAction(b);};
  int localActionType(void) {return DB3::w6_4_15();};
  void localActionType(int i) {DB3::w6_4_15(i);};
  ui8  Edge(void){return DB3::andOrEdge();};
  void Edge(int e){DB3::andOrEdge(e);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_SkillIncreaser:DB3
{
private:
public:
  ACTUATOR_SkillIncreaser();
  ~ACTUATOR_SkillIncreaser(void);
  void Clear(void);
  int Edit();
};

class ACTUATOR_Rotate:DB3
{
private:
public:
  ACTUATOR_Rotate();
  ~ACTUATOR_Rotate(void);
  void Clear(void);
  int Edit();
};

// Portrait
//        |------------------------------------------------------|
// word 0 |15      link                                         0|
//        |------------------------------------------------------|
// word 2 |15 champion               7|6  Type=127              0|
//        |------------------------------------------------------|
// word 4 |15 graphic 12|11 st 9|8 i 8|7 m 6|5 Toggle responses 0|
//        |------------------------------------------------------|
// word 6 |15 14|13 pos 12|11 Set Responses 6|5 Clear responses 0|
//        |------------------------------------------------------|
//  Notes:
//    i=1 means to inhibit disable of chained Portraits
//    st bit 0 is inactive (cannot revive a champion)
//       bit 1 Hide champion portrait
//       bit 2 Hide graphic
//    responses bits 0-1 active
//                   2-3 show portrait
//                   4-5 show graphic
//              value 0 nothing
//                    1 Set
//                    2 Clear
//                    3 Toggle
//    m message sent when disabled 0 = none
//                                 1 = Set
//                                 2 = Clear
//                                 3 = Toggle

class ACTUATOR_Portrait:DB3
{
private:
public:
  ACTUATOR_Portrait();
  ~ACTUATOR_Portrait(void);
  CString CheckTarget(LOCATIONREL locr, char isTarget[64][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[64][32][32]);
  void Clear(void);
  int Edit(LOCATIONREL locr, RN RNportrait);
  int characterNumber(void){return DB3::value();};
  void characterNumber(int c){DB3::value(c);};
  int graphic(void){return DB3::graphicOrdinal();};
  void graphic(int g){DB3::graphicOrdinal(g);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  ui16 BlockDisables(void){return DB3::BlockDisables();};
  void BlockDisables(ui16 v){DB3::BlockDisables(v);};
  ui16 SetResponses(void){return DB3::SetResponses();};
  void SetResponses(ui16 v){DB3::SetResponses(v);};
  ui16 ClearResponses(void){return DB3::ClearResponses();};
  void ClearResponses(ui16 v){DB3::ClearResponses(v);};
  ui16 ToggleResponses(void){return DB3::ToggleResponses();};
  void ToggleResponses(ui16 v){DB3::ToggleResponses(v);};
  ui16 DisableMessage(void){return DB3::DisableMessage();};
  void DisableMessage(ui16 v){DB3::DisableMessage(v);};
  ui16 State(void){return DB3::State();};
  void State(ui16 v){DB3::State(v);};
  ui16 Position(void){return DB3::Position();};
  void Position(ui16 v){DB3::Position(v);};
  void ClearUnusedPor(void){DB3::ClearUnusedPor();};
  bool MightBeActiveAtRuntime(void);
  void Dump(FILE *f);
};

class ACTUATOR_DSA:DB3
{
public:
  ACTUATOR_DSA();
  ~ACTUATOR_DSA(void);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTarget(LOCATIONREL locr,
                      char isTarget[16][32][32]);
  void Clear(void);
  int Edit(LOCATIONREL locr, RN RNDSA);
  ui8 State(void){return DB3::DSAstate();};
  void State(ui8 s){DB3::DSAstate(s);};;
  ui8 DSAselector(void){return DB3::DSAselector();};
  void DSAselector(ui8 s){DB3::DSAselector(s);};
  ui32 ParameterA(void){return DB3::ParameterA();};
  void ParameterA(ui32 a){DB3::ParameterA(a);};
  bool AisInteger(void){return DB3::AisInteger();};
  void AisInteger(bool b){DB3::AisInteger(b);};
  ui32 ParameterB(void){return DB3::ParameterB();};
  void ParameterB(ui32 b){DB3::ParameterB(b);};
  bool BisInteger(void){return DB3::BisInteger();};
  void BisInteger(bool b){DB3::BisInteger(b);};
  i16 graphicOrdinal(void){return 0;};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString ShortName(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
  void SwapTargetLevel(int L1, int L2);
};

class ACTUATOR_ObjectLauncher:DB3
{
private:
public:
  ACTUATOR_ObjectLauncher();
  ~ACTUATOR_ObjectLauncher(void);
  void Clear(void);
  int Edit();
  int targetX(void) {return DB3::targetX();};
  int targetY(void) {return DB3::targetY();};
};

class ACTUATOR_EndGame:DB3
{
private:
public:
  ACTUATOR_EndGame();
  ~ACTUATOR_EndGame(void);
  void Clear(void);
  int Edit(LOCATIONREL locr, RN RNEndGame);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  //int targetX(void) {return DB3::targetX();};
  //int targetY(void) {return DB3::targetY();};
  //int targetPos(void) {return DB3::targetPos();};
  //bool localAction(void){return DB3::localAction();};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  int graphic(void){return DB3::graphicOrdinal();};
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};

class ACTUATOR_Counter:DB3
{
private:
public:
  ACTUATOR_Counter(void);
  ~ACTUATOR_Counter(void);
  void Clear(void);
  int Edit(LOCATIONREL locr);
  CString CheckTarget(LOCATIONREL locr, char isTarget[16][32][32]);
  CString CheckTrigger(LOCATIONREL locr, char isTarget[16][32][32]);
  bool localAction(void)        {return DB3::localAction();};
  void localAction(bool b)      {DB3::localAction(b);};
  int localActionType(void) {return DB3::w6_4_15();};
  void localActionType(int i) {DB3::w6_4_15(i);};
  int  delay(void)              {return DB3::delay();};
  void delay(int d)             {DB3::delay(d);};
  bool onceOnly(void)           {return DB3::onceOnly();};
  void onceOnly(bool b)         {DB3::onceOnly(b);};
  bool normallyClosed(void)     {return DB3::normallyClosed();};
  void normallyClosed(bool b)   {DB3::normallyClosed(b);};
  void audible(bool b)          {DB3::audible(b);};
  int  targetX(void)            {return DB3::targetX();};
  void targetX(int x)           {DB3::targetX(x);};
  int  targetY(void)            {return DB3::targetY();};
  void targetY(int y)           {DB3::targetY(y);};
  int  targetPos(void)          {return DB3::targetPos();};
  void targetPos(int p)         {DB3::targetPos(p);};
  int  counterValue(void)       {return DB3::value();};
  void counterValue(int n)      {DB3::value(n);};
  ACTUATORACTION action(void)   {return DB3::action();};
  void action(ACTUATORACTION a) {DB3::action(a);};
  int wallGraphicOrdinal(void)  {return DB3::graphicOrdinal();};
  void wallGraphicOrdinal(int g){DB3::graphicOrdinal(g);};
  LOCATIONREL GetNthTarget(LOCATIONREL locr, int n);
  CString Name(void);
  CString GraphicName(LOCATIONREL locr);
  MODIFIEDOBJECTTYPE neededObject(LOCATIONREL locr);
  void Dump(FILE *f);
};
