// AdvancedSearch.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "AdvancedSearch.h"
#include "Misc.h"
#include "ShowLocations.h"
#include "actuator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// AdvancedSearch dialog


AdvancedSearch::AdvancedSearch(CWnd* pParent /*=NULL*/)
	: CDialog(AdvancedSearch::IDD, pParent)
{
	//{{AFX_DATA_INIT(AdvancedSearch)
	m_actuator = FALSE;
	m_broken = FALSE;
	m_clothes = FALSE;
	m_cursed = FALSE;
	m_important = FALSE;
	m_invisible = FALSE;
	m_miscellaneous = FALSE;
	m_monsters = FALSE;
	m_poisoned = FALSE;
	m_potions = FALSE;
	m_scrolls = FALSE;
	m_size4 = FALSE;
	m_teleporter = FALSE;
	m_unique = FALSE;
	m_weapons = FALSE;
	m_chests = FALSE;
	m_objectID = _T("");
	m_portraitNumber = 0;
	m_objectCount = 0;
	m_DSA = 0;
	//}}AFX_DATA_INIT
}


void AdvancedSearch::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
  if (!pDX->m_bSaveAndValidate)
  {
    if (m_objectList.m_hWnd != NULL)
    {
      m_objectCount = m_objectList.GetCount();
    };
  };
	//{{AFX_DATA_MAP(AdvancedSearch)
	DDX_Control(pDX, IDC_ObjectList, m_objectList);
	DDX_Check(pDX, IDC_Actuator, m_actuator);
	DDX_Check(pDX, IDC_Broken, m_broken);
	DDX_Check(pDX, IDC_Clothes, m_clothes);
	DDX_Check(pDX, IDC_Cursed, m_cursed);
	DDX_Check(pDX, IDC_Important, m_important);
	DDX_Check(pDX, IDC_Invisible, m_invisible);
	DDX_Check(pDX, IDC_Miscellaneous, m_miscellaneous);
	DDX_Check(pDX, IDC_Monsters, m_monsters);
	DDX_Check(pDX, IDC_Poisoned, m_poisoned);
	DDX_Check(pDX, IDC_Potions, m_potions);
	DDX_Check(pDX, IDC_Scrolls, m_scrolls);
	DDX_Check(pDX, IDC_Size4, m_size4);
	DDX_Check(pDX, IDC_Teleporter, m_teleporter);
	DDX_Check(pDX, IDC_Unique, m_unique);
	DDX_Check(pDX, IDC_Weapons, m_weapons);
	DDX_Check(pDX, IDC_Chests, m_chests);
	DDX_Text(pDX, IDC_ObjectID, m_objectID);
	DDX_Text(pDX, IDC_PortraitNum, m_portraitNumber);
	DDV_MinMaxUInt(pDX, m_portraitNumber, 0, 254);
	DDX_Text(pDX, IDC_ObjectCount, m_objectCount);
	DDX_Text(pDX, IDC_DSA, m_DSA);
	DDV_MinMaxUInt(pDX, m_DSA, 0, 255);
	//}}AFX_DATA_MAP

}


BEGIN_MESSAGE_MAP(AdvancedSearch, CDialog)
	//{{AFX_MSG_MAP(AdvancedSearch)
	ON_BN_CLICKED(IDC_ListAll, OnListAll)
	ON_BN_CLICKED(IDC_ShowObjectLocations, OnShowObjectLocations)
	ON_BN_CLICKED(IDC_ClassInclude, OnClassInclude)
	ON_BN_CLICKED(IDC_ClassRemove, OnClassRemove)
	ON_BN_CLICKED(IDC_FlagsInclude, OnFlagsInclude)
	ON_BN_CLICKED(IDC_FlagsRemove, OnFlagsRemove)
	ON_BN_CLICKED(IDC_ObjectIDInclude, OnObjectIDInclude)
	ON_BN_CLICKED(IDC_IncludePortraitNum, OnIncludePortraitNum)
	ON_BN_CLICKED(IDC_IncludeDSA, OnIncludeDSA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void AdvancedSearch::AddObject(const RN obj, const LOCATIONREL& locr, CString name)
{
  int indx;
  indx = m_objectList.AddString(name);
  m_objectList.SetItemData(indx,(obj.ConvertToInteger()<<16) + (locr.Integer() & 0xffff));
}

void AdvancedSearch::AddOneToList(const RN obj, const LOCATIONREL& locr)
{
  DBTYPE dbType;
  ROOMTYPE rt;
  dbType = obj.dbType();
  rt = RoomType(locr);
  switch (dbType)
  {
  case dbMISC:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbCLOTHING:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbPOTION:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbMONSTER:
    AddObject(obj,locr,obj.Name(rt));
    AddAllToList(pDoc->GetRecordAddressDB4(obj)->possession(), locr);
    break;
  case dbWEAPON:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbCHEST:
    AddObject(obj,locr,obj.Name(rt));
    AddAllToList(pDoc->GetRecordAddressDB9(obj)->contents(), locr);
    break;
  case dbSCROLL:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbTELEPORTER:
    AddObject(obj,locr,obj.Name(rt));
    break;
  case dbACTUATOR:
    AddObject(obj,locr,obj.Name(rt));
    break;
  default: break;
  };
}


void AdvancedSearch::AddAllToList(const RN firstObj, const LOCATIONREL& locr)
{
  RN obj = firstObj;
  for (;obj!=RNeof; obj=pDoc->GetDBRecordLink(obj))
  {
    AddOneToList(obj, locr);
  };
}


/////////////////////////////////////////////////////////////////////////////
// AdvancedSearch message handlers

void AdvancedSearch::OnListAll() 
{
	// TODO: Add your control notification handler code here
  LOCATIONREL locr;
  RN obj;
  CProgressCtrl progress;
  RECT prect = {100,100,600,160};
  int prevLevel;
  progress.Create(WS_CAPTION|WS_VISIBLE|WS_CHILD,prect,this,12);
  progress.SetWindowText("Analyzing Clones");
  progress.SetRange(0,(ui16)pDoc->NumLevel());
  m_objectList.ResetContent();
  prevLevel = 0;
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    if (locr.l() != prevLevel) progress.SetPos(locr.l());
    prevLevel = locr.l();
    obj = pDoc->FindFirstObject(locr);
    AddAllToList(obj, locr);
  };
  UpdateData(false);
}


void AdvancedSearch::OnShowObjectLocations() 
{
	// TODO: Add your control notification handler code here
  int indx;
  int num;
  LOCATIONREL locr;
  OBJECTLIST objectList;
  num = m_objectList.GetCount();
  if (num == 0) return;
  for (indx=0; indx<num; indx++)
  {
    locr.Integer(m_objectList.GetItemData(indx));
    objectList.Insert(RNnul, locr);
  };
  {
    ShowLocations dlg(&objectList);
    dlg.DoModal();
  };
}


bool AdvancedSearch::IsInClass(const RN obj)
{
  DBTYPE dbType;
  dbType = obj.dbType();
  switch (dbType)
  {
  case dbMISC:       return m_miscellaneous!=0;
  case dbWEAPON:     return m_weapons!=0;
  case dbACTUATOR:   return m_actuator!=0;
  case dbCLOTHING:   return m_clothes!=0;
  case dbTELEPORTER: return m_teleporter!=0;
  case dbPOTION:     return m_potions!=0;
  case dbMONSTER:    return m_monsters!=0;
  case dbCHEST:      return m_chests!=0;
  case dbSCROLL:     return m_scrolls!=0;
  };
  return false;
}

bool AdvancedSearch::HasFlag(const RN obj)
{
  DBTYPE dbType;
  dbType = obj.dbType();
  switch (dbType)
  {
  case dbMISC:       
    {
      DB10 *pMisc;
      pMisc = pDoc->GetRecordAddressDB10(obj);
      if (pMisc->cursed() && m_cursed) return true;
      if (pMisc->important() && m_important) return true;
      return false;
    };
  case dbWEAPON:
    {
      DB5 *pWeapon;
      pWeapon = pDoc->GetRecordAddressDB5(obj);
      if (pWeapon->broken()    && m_broken)    return true;
      if (pWeapon->cursed()    && m_cursed)    return true;
      if (pWeapon->important() && m_important) return true;
      if (pWeapon->poisoned()  && m_poisoned)  return true;
      return false;
    };
  case dbACTUATOR:   
    return false;
  case dbCLOTHING:
    {
      DB6 *pClothes;
      pClothes = pDoc->GetRecordAddressDB6(obj);
      if (pClothes->broken() && m_broken) return true;
      if (pClothes->cursed() && m_cursed) return true;
      if (pClothes->important() && m_important) return true;
      return false;
    };
  case dbTELEPORTER:
    return false;
  case dbPOTION:
    {
      DB8 *pPotion;
      pPotion = pDoc->GetRecordAddressDB8(obj);
      if (pPotion->important() && m_important) return true;
      return false;
    };
  case dbMONSTER:    
    {
      DB4 *pMonster;
      pMonster = pDoc->GetRecordAddressDB4(obj);
      if (pMonster->DrawAsSize4() && m_size4) return true;
      if (pMonster->Invisible() && m_invisible) return true;
      if (pMonster->Poisoned() && m_poisoned) return true;
      if (pMonster->Unique() && m_unique) return true;
      return false;
    };
  case dbCHEST:      
    return false;
  case dbSCROLL:
    return false;
  };
  return false;
}

void AdvancedSearch::OnClassInclude() 
{
	// TODO: Add your control notification handler code here
	int indx;
  int num, n;
  RN obj;
  UpdateData(true);
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (!IsInClass(obj))
    {
      m_objectList.DeleteString(indx);
    };
  };
	
  UpdateData(false);
}


void AdvancedSearch::OnClassRemove() 
{
	// TODO: Add your control notification handler code here
	int indx;
  int num, n;
  RN obj;
  UpdateData(true);
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (IsInClass(obj))
    {
      m_objectList.DeleteString(indx);
    };
  };
  UpdateData(false);
}

void AdvancedSearch::OnFlagsInclude() 
{
	// TODO: Add your control notification handler code here
	
	int indx;
  int num, n;
  RN obj;
  UpdateData(true);
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (!HasFlag(obj))
    {
      m_objectList.DeleteString(indx);
    };
  };
  UpdateData(false);
}

void AdvancedSearch::OnFlagsRemove() 
{
	// TODO: Add your control notification handler code here
	int indx;
  int num, n;
  RN obj;
  UpdateData(true);
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (HasFlag(obj))
    {
      m_objectList.DeleteString(indx);
    };
  };
  UpdateData(false);
	
}

void AdvancedSearch::OnObjectIDInclude() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  int objID;
  int indx, n, num;
  n = m_objectID.GetLength();
  if (    (n > 2)
       && (m_objectID[0] == '0')
       && ((m_objectID[1] == 'x') || (m_objectID[1] == 'X')))
  {
    sscanf(m_objectID,"%x", & objID);
  }
  else
  {
    sscanf(m_objectID, "%d", &objID);
  };
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    if (objID != (n>>16))
    {
      m_objectList.DeleteString(indx);
    };
  };	
  UpdateData(false);
}

void AdvancedSearch::OnIncludePortraitNum() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  int indx, n, num;
  RN obj;
  DB3 *pActuator;
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (obj.dbType() == dbACTUATOR)
    {
      pActuator = pDoc->GetRecordAddressDB3(obj);
      if (pActuator->actuatorClass(roomSTONE) == AC_PORTRAIT)
      {
        if ((unsigned)pActuator->Cast2AC_Portrait(roomSTONE)->characterNumber() == m_portraitNumber)
        {
          continue;
        };
      };
    };
    m_objectList.DeleteString(indx);
  };		
  UpdateData(false);
}

void AdvancedSearch::OnIncludeDSA() 
{
	// TODO: Add your control notification handler code here
	
  UpdateData(true);
  int indx, n, num;
  RN obj;
  DB3 *pActuator;
  LOCATIONREL locr;
  num = m_objectList.GetCount();
  for (indx=num-1; indx>=0; indx--)
  {
    n = m_objectList.GetItemData(indx);
    obj.ConstructFromInteger(n>>16);
    if (obj.dbType() == dbACTUATOR)
    {
      pActuator = pDoc->GetRecordAddressDB3(obj);
      locr.Integer(m_objectList.GetItemData(indx));
      if (pActuator->actuatorClass(roomSTONE) == AC_DSA)
      {
        ACTUATOR_DSA *pDSArec;
        int dsaLevelIndex;
        unsigned int dsaIndex;
        pDSArec = pActuator->Cast2AC_DSA(roomSTONE); //Room type not important
        dsaLevelIndex = pDSArec->DSAselector();
        dsaIndex = pDoc->getDSA(locr.l(), dsaLevelIndex);
        if (dsaIndex == m_DSA)
        {
          continue;
        };
      };
    };
    m_objectList.DeleteString(indx);
  };		
  UpdateData(false);
}
