// CSBuildDoc.cpp : implementation of the CCSBuildDoc class
//

#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "misc.h"

#include "CSBuildDoc.h"

extern CString encipheredDataFile;
extern CROSSREF crossref;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void BinaryWrite(CArchive& ar, void *buf, int len);

extern i32 dbEntrySizes[16];
extern char *gameInfo;

CCSBuildDoc *pDoc;

/////////////////////////////////////////////////////////////////////////////
// CCSBuildDoc

IMPLEMENT_DYNCREATE(CCSBuildDoc, CDocument)

BEGIN_MESSAGE_MAP(CCSBuildDoc, CDocument)
	//{{AFX_MSG_MAP(CCSBuildDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCSBuildDoc construction/destruction

CCSBuildDoc::CCSBuildDoc()
{
	// TODO: add one-time construction code here
  int i;
  m_validDungeon      = false;
  m_ExtendedFeaturesText = RNnul;
  m_expandedBuffer    = NULL;
  pDoc                = this;
  m_Item16            = NULL;
  m_Timers            = NULL;
  m_timerQue          = NULL;
  m_dungeonDatIndex   = NULL;
  m_pLevelDescriptors = NULL;
  m_objectLevelIndex  = NULL;
  m_objectColumnIndex = NULL;
  m_objectList        = NULL;
  m_indirectTextIndex = NULL;
  m_compressedText    = NULL;
  m_sizeOfCompressedText = 0;
  m_cellFlagArray     = NULL;
  m_pppdPointer10450  = NULL;
  for (i=0; i<16; i++) m_DBEntrySize[i] = (ui16)dbEntrySizes[i];
  for (i=0; i<256; i++) m_DSAIndex[i] = NULL;
  m_dataTypeMap       = NULL;
  m_dataIndexMap      = NULL;
  m_dataMapLength     = 0;
  m_dungeonFormat     = false;
  m_compressed        = false;
  m_littleEndian      = false;
  m_PCFormattedBlock1 = false;
  m_targetMode        = false;
  m_bigActuators      = false;
  m_editingOptions    = EDIT_OPT_DefaultOptions;
}

void CCSBuildDoc::FreeAllMemory(void)
{
  int i;
  if (m_Item16 != NULL) free(m_Item16);
  m_Item16 = NULL;
  if (m_Timers != NULL) free(m_Timers);
  m_Timers = NULL;
  if (m_timerQue != NULL) free(m_timerQue);
  m_timerQue = NULL;
  if (m_dungeonDatIndex != NULL) free(m_dungeonDatIndex);
  m_dungeonDatIndex = NULL;
  if (m_pLevelDescriptors != NULL) free(m_pLevelDescriptors);
  m_pLevelDescriptors = NULL;
  if (m_objectLevelIndex != NULL) free(m_objectLevelIndex);
  m_objectLevelIndex = NULL;
  if (m_objectColumnIndex != NULL) free(m_objectColumnIndex);
  m_objectColumnIndex    = NULL;
  if (m_objectList       != NULL) free(m_objectList);
  m_objectList          = NULL;
  if (m_indirectTextIndex   != NULL) free(m_indirectTextIndex);
  m_indirectTextIndex      = NULL;
  if (m_compressedText   != NULL) free(m_compressedText);
  m_compressedText      = NULL;
  m_sizeOfCompressedText = 0;
  if (m_cellFlagArray != NULL) free(m_cellFlagArray);
  m_cellFlagArray = NULL;
  if (m_pppdPointer10450 != NULL) free(m_pppdPointer10450);
  m_pppdPointer10450 = NULL;
  if (m_dataTypeMap != NULL) free(m_dataTypeMap);
  m_dataTypeMap = NULL;
  if (m_dataIndexMap != NULL) free(m_dataIndexMap);
  m_dataIndexMap = NULL;
  for (i=0; i<256; i++)
  {
    if (m_DSAIndex[i] != NULL) delete m_DSAIndex[i];
    m_DSAIndex[i] = NULL;
  };
  m_cellUndoList.Clear();
  if (gameInfo != NULL) free (gameInfo);
  gameInfo = NULL;
}

CCSBuildDoc::~CCSBuildDoc()
{
  FreeAllMemory();
}

BOOL CCSBuildDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
  FreeAllMemory();
  pDoc->LoadDungeon(NULL);
  m_currentDisplayLevel = 0;
  m_validDungeon= true;
  m_dungeonFormat = true;
  m_editingOptions = EDIT_OPT_DefaultOptions;
  m_spellFilterLocation.l(-1);
  CDocument::SetModifiedFlag(false);
  crossref.Clear();
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCSBuildDoc serialization

void CCSBuildDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
    try
    {
      m_littleEndian = false;
      StoreDungeon(ar);
    }
    catch (int)
    {
      AfxThrowArchiveException(CArchiveException::badIndex, "");
    };
	}
	else
	{
		// TODO: add loading code here
    try
    {
      ui32 *pRec;
      FreeAllMemory();
      MarkInvalid();
      crossref.Clear();
      m_littleEndian = false;
      if (LoadDungeon(&ar) == false)
      {
        Error("Error reading big-endian...will try little-endian");
        m_littleEndian = true;
        if (LoadDungeon(&ar) == false)
        {
          DIE("That file cannot be loaded as big- or little-endian");
        };
      };
      MarkValid();
      if (expool.Locate((EDT_Database<<24) + (EDBT_DeleteDuplicateTimers <<16),&pRec) < 0)
      {
        MessageBox(NULL,"You have not decided whether or not to have the\n"
                        "runtime engine discard duplicate timer entries.\n"
                        "See Edit/Global/Databases", "Warning",MB_OK);
      };
      m_currentDisplayLevel = 0;
    } 
    catch (int)
    {
      AfxThrowArchiveException (CArchiveException::badIndex, "");
    };
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCSBuildDoc diagnostics

#ifdef _DEBUG
void CCSBuildDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCSBuildDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCSBuildDoc commands


RN CCSBuildDoc::CharacterPossession(int character, int location)
{
  ASSERT(character < m_NumCharacter);
  if (character >= m_NumCharacter) return RNeof;
  return m_Characters[character].possessions[location];
}

void CCSBuildDoc::CharacterPossession(int character, 
                                      int location,
                                      RN  possession)
{
  ASSERT(character < m_NumCharacter);
  if (character >= m_NumCharacter) return;
  m_Characters[character].possessions[location] = possession;
}

RN *CCSBuildDoc::pCharacterPossession(int character, int location)
{
  ASSERT(character < m_NumCharacter);
  if (character >= m_NumCharacter) return NULL;
  return &m_Characters[character].possessions[location];
}

void CCSBuildDoc::SetDBSize(int dbNum, int size)
{
  m_dungeonDatIndex->DBSize(dbNum, (ui16)size);
  SetModifiedFlag();
}

int CCSBuildDoc::GetDBSize(int dbNum)
{
  return m_dungeonDatIndex->DBSize(dbNum);
}

int CCSBuildDoc::LastRow(int level)
{
  return m_pLevelDescriptors[level].LastRow();
}

int CCSBuildDoc::LastColumn(int level)
{
  return m_pLevelDescriptors[level].LastColumn();
}

int CCSBuildDoc::CellOffset(int level)
{
  int i;
  static int count = 0;
  count++;
  int result = m_pLevelDescriptors[0].CellOffset();
  for (i=1; i<=level; i++)
  {
    result += (m_pLevelDescriptors[i].CellOffset() 
               - m_pLevelDescriptors[i-1].CellOffset())&0xffff;
  };
  return result;
}


void BackupError(const char *file, char *msg)
{
  char *m;
  m = (char *)malloc(strlen(file) + strlen(msg) + 1000,MALLOC053);
  if (m == NULL) return;
  sprintf(m,"Cannot bacup old data file because\n%s\n%s\n\n"
            "If you want a backup then you had better copy\n"
            "the old data file manually before you answer\n"
            "this message",msg, file);
  MessageBox(NULL,m,"Backup Error",MB_OK);
  free(m);
}

bool AskAboutDoingIt(CString msg)
{
  CString MSG;
  int r;
  MSG.Format("You are attempting to save a game\n"
             "in 'dungeon' format.  The game must\n"
             "must be cleaned up.\n\n%s", msg);
  r = MessageBox(NULL,MSG,"Warning",MB_OKCANCEL|MB_TOPMOST);
  if (r == IDOK) return true;
  return false;
}

bool CCSBuildDoc::CheckCharacterPossessions(bool DOIT)
{
  CString msg;
  RN possession;
  int n, i;
  possession = RNnul;
  msg = "One or more characters has items\n"
        "in his possession.  We must remove\n"
        "these before saving.";
  for (n=0; n<m_NumCharacter; n++)
  {
    for (i=0; i<30; i++)
    {
      possession = m_Characters[n].possessions[i];
      if (possession != RNnul)
      {
        if (!DOIT) return AskAboutDoingIt(msg);
        ASSERT(GetDBRecordLink(possession) == RNeof);
        possession.Delete(); // And any contents if Chest.
        m_Characters[n].possessions[i] = RNnul;
        SetModifiedFlag();
      }
    };
  };
  return true;
}

void CCSBuildDoc::SetModifiedFlag(void)
{
  if (m_bModified) return;
  CDocument::SetModifiedFlag(true);
}

bool CCSBuildDoc::CheckObjectInHand(bool DOIT)
{
  CString msg;
  msg = "The cursor contains an object.\n"
        "We must remove it before saving the game.";
  if (m_objectInHand != RNnul)
  {
    if (!DOIT) return AskAboutDoingIt(msg);
    m_objectInHand.Delete();
    m_objectInHand = RNnul;
  };
  return true;
}

bool CCSBuildDoc::CheckMissilesInFlight(bool DOIT)
{
  TIMER *pTimer;
  int i;
  LOCATIONREL locr;
  LOCATIONABS loca;
  CString msg;
  msg = "There are one or more missiles flying\n"
        "about in this dungeon.  We have to delete\n"
        "them before saving the game.";
  for (i=0; i<pDoc->MaxTimers(); i++)
  {
    pTimer = &m_Timers[i];
    locr.l((pTimer->time >> 24) & 0xff);
    locr.x(pTimer->missileX());
    locr.y(pTimer->missileY());
    locr.p(pTimer->missilePos());
    switch (pTimer->timerFunction)
    {
    case 48:
    case 49: //Missile Timer
      if (!DOIT) return AskAboutDoingIt(msg);
      {
        RN missileObj;
        missileObj = pTimer->timerObj6();
        RemoveObjectFromRoom(locr,missileObj,false, true);
        missileObj.Delete();
        DeleteTimer(pTimer);
      };
      break;
    default:
      break;
    };
  };
  return true;
}

BOOL CCSBuildDoc::DoSave(LPCTSTR lpszPathName, BOOL bReplace)
{
  if (encipheredDataFile != "")
  {
    int ans;
    ans = AreYouSure("Are you certain that you want to\n"
                     "write an encrypted file?  You will\n"
                     "NEVER be able to edit this file again.\n"
                     "\n"
                     "Should we proceed?");
    if (ans == IDNO) return false;
  };
  return CDocument::DoSave(lpszPathName, bReplace);
}

BOOL CCSBuildDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	// TODO: Add your specialized code here and/or call the base class
	// Our plan is to backup the old file before saving.
  FILE *f;
  if (m_dungeonFormat)
  {
    bool DOIT = false;  
    int i;
    for (i=0; i<2; i++)
    {
      if (!CheckCharacterPossessions(DOIT)) break;
      if (!CheckObjectInHand(DOIT)) break;
      if (!CheckMissilesInFlight(DOIT)) break;
      DOIT = true;
    };
    if (!DOIT) return 0;
  };
  if ((f=fopen(lpszPathName,"r")) != NULL)
  {
    char *fname;
    int i,j;
    fclose(f);
    fname = (char *)malloc(2*strlen(lpszPathName) + 20,MALLOC002);
    if (fname == NULL) DIE("Cannot allocate memory");
    strcpy(fname, lpszPathName);
    for (i=strlen(fname)-1; i>=0; i--)
    {
      if (fname[i] == '.') break;
    };
    if (fname[i] == '.')
    {
      int numBackup;
      strcpy(fname+i+1,"bak0");
      i += 4;
      // Determine how many backups already exist.
      numBackup = 0;
      for (j=0; j<9; j++)
      {
        if (j == 0)
        {
          fname[i] = 0;
        }
        else
        {
          fname[i] = (char)('0' + j);
        };
        f = fopen(fname, "r");
        if (f==NULL) break;
        numBackup = j+1;
        fclose(f);
      };
      if (numBackup == 9)
      {
        // .bak8 exists.  We nned to delete it
        if (remove(fname) != 0)
        {
          BackupError(fname,"Cannot remove old backup file");
          free(fname);
        	return CDocument::OnSaveDocument(lpszPathName);
        };
        numBackup--;
      };
      for (int k=numBackup; k>0; k--)
      {
        strcpy(fname+i+5, fname); // remember the new name
        fname[i] -= 1;
        if (k == 1) fname[i] = 0;
        if (rename(fname, fname+i+5) != 0)
        {
          BackupError(fname,"Cannot rename old backup file");
          free(fname);
        	return CDocument::OnSaveDocument(lpszPathName);
        };
      };
      fname[i] = 0;
      if (rename(lpszPathName, fname) != 0)
      {
        BackupError(lpszPathName,"Cannot rename old data file");
        free(fname);
      	return CDocument::OnSaveDocument(lpszPathName);
      };
    };
    free(fname);
  }
	return CDocument::OnSaveDocument(lpszPathName);
}

RN CCSBuildDoc::FindFirstObject(int level, int col, int row) const
{
  CELLFLAG *pCF;
  i32 i, index, levIndex;
  pCF = m_pppdPointer10450[level][col];
  if (col < 0) return RNeof;
  if (col > m_pLevelDescriptors[level].LastColumn()) return RNeof;
  if (row < 0) return RNeof;
  if (row > m_pLevelDescriptors[level].LastRow()) return RNeof;
  if ((pCF[row] & 16) == 0) return RNeof; // Nothing here!
  levIndex = m_objectLevelIndex[level]; // First column in level
  index = m_objectColumnIndex[levIndex + col];
  for (i=0; i<row; i++)
  {
    if ((pCF[i] & 16) != 0) index++;
  };
  return m_objectList[index];
}

RN CCSBuildDoc::FindFirstObject(const LOCATIONREL locr) const
{
  return FindFirstObject(locr.l(), locr.x(), locr.y());
}

RN CCSBuildDoc::GetDBRecordLink(RN recName) const
{
  // recDesc(bits 10-13) = database number
  // recDesc(bits 0-9)   = record number within database
  DBCOMMON *dbA0;
  ASSERT(recName != RNnul);
  ASSERT(recName != RNeof);
  dbA0 = GetCommonAddress(recName);
  return dbA0->link();
}

bool CCSBuildDoc::IsDBIndexOK(int indirectIndex)
{
  ASSERT((indirectIndex!=0)&&(indirectIndex<m_dataMapLength));
  return db.IsDBIndexOK(DBTYPE(m_dataTypeMap[indirectIndex]&15),
                        m_dataIndexMap[indirectIndex]);
}

DBCOMMON *CCSBuildDoc::GetCommonAddress(RN recDesc) const
{
  // recDesc(bits 10-13) = database number
  // recDesc(bits 0-9)   = record number within database
  // Some folks call to get the address before checking
  // to see if the object exists at all!
  if ((recDesc == RNnul) || (recDesc == RNeof))
  {
    DIE("GetRecordAddress(nul or eof)");
    return NULL;
  };
  return db.GetCommonAddress(recDesc);
}

DBCOMMON *CCSBuildDoc::GetCommonAddress(
                        DBTYPE dbType, int dbIndex) const
{
  return db.GetCommonAddress(dbType, dbIndex);
}

DB0 *CCSBuildDoc::GetRecordAddressDB0(RN object)
{
  ASSERT(object.dbType() == dbDOOR);
  return (DB0 *) GetCommonAddress(object);
}

DB1 *CCSBuildDoc::GetRecordAddressDB1(RN object)
{
  ASSERT(object.dbType() == dbTELEPORTER);
  return (DB1 *) GetCommonAddress(object);
}

DB2 *CCSBuildDoc::GetRecordAddressDB2(RN object)
{
  ASSERT(object.dbType() == dbTEXT);
  return (DB2 *) GetCommonAddress(object);
}

DB2 *CCSBuildDoc::GetRecordAddressDB2(int dbIndex)
{
  return (DB2 *) db.GetCommonAddress(dbTEXT, dbIndex);
}

DB3 *CCSBuildDoc::GetRecordAddressDB3(RN object)
{
  ASSERT(object.dbType() == dbACTUATOR);
  return (DB3 *) GetCommonAddress(object);
}

DB3 *CCSBuildDoc::GetRecordAddressDB3(int dbIndex)
{
  return (DB3 *) db.GetCommonAddress(dbACTUATOR, dbIndex);
}


DB4 *CCSBuildDoc::GetRecordAddressDB4(RN object)
{
  ASSERT(object.dbType() == dbMONSTER);
  return (DB4 *) GetCommonAddress(object);
}

DB5 *CCSBuildDoc::GetRecordAddressDB5(RN object)
{
  ASSERT(object.dbType() == dbWEAPON);
  return (DB5 *) GetCommonAddress(object);
}

DB6 *CCSBuildDoc::GetRecordAddressDB6(RN object)
{
  ASSERT(object.dbType() == dbCLOTHING);
  return (DB6 *) GetCommonAddress(object);
}

DB7 *CCSBuildDoc::GetRecordAddressDB7(RN object)
{
  ASSERT(object.dbType() == dbSCROLL);
  return (DB7 *) GetCommonAddress(object);
}

DB8 *CCSBuildDoc::GetRecordAddressDB8(RN object)
{
  ASSERT(object.dbType() == dbPOTION);
  return (DB8 *) GetCommonAddress(object);
}

DB9 *CCSBuildDoc::GetRecordAddressDB9(RN object)
{
  ASSERT(object.dbType() == dbCHEST);
  return (DB9 *) GetCommonAddress(object);
}

DB10 *CCSBuildDoc::GetRecordAddressDB10(RN object)
{
  ASSERT(object.dbType() == dbMISC);
  return (DB10 *) GetCommonAddress(object);
}

DB14 *CCSBuildDoc::GetRecordAddressDB14(RN object)
{
  ASSERT(object.dbType() == dbMISSILE);
  return (DB14 *) GetCommonAddress(object);
}

DB15 *CCSBuildDoc::GetRecordAddressDB15(RN object)
{
  ASSERT(object.dbType() == dbCLOUD);
  return (DB15 *) GetCommonAddress(object);
}

int CCSBuildDoc::OffsetX(int level)
{
  return m_pLevelDescriptors[level].offsetX;
}

void CCSBuildDoc::OffsetX(int level, int v)
{
  if (m_pLevelDescriptors[level].OffsetX() != v)
  {
    m_pLevelDescriptors[level].OffsetX(v);
    SetModifiedFlag();
  };
}

int CCSBuildDoc::OffsetY(int level)
{
  return m_pLevelDescriptors[level].offsetY;
}

void CCSBuildDoc::OffsetY(int level, int v)
{
  if (m_pLevelDescriptors[level].OffsetY() != v)
  {
    m_pLevelDescriptors[level].OffsetY(v);
    SetModifiedFlag();
  };
}

int CCSBuildDoc::NumWallDecorations(int level)
{
  return m_pLevelDescriptors[level].NumWallDecoration();
}

int CCSBuildDoc::NumDoorDecorations(int level)
{
  return m_pLevelDescriptors[level].NumDoorDecorations();
}

int CCSBuildDoc::NumFloorDecorations(int level)
{
  return m_pLevelDescriptors[level].NumFloorDecorations();
}

int CCSBuildDoc::NumRandomWallDecorations(int level)
{
  return m_pLevelDescriptors[level].NumRandomWallDecorations();
}

int CCSBuildDoc::NumRandomFloorDecorations(int level)
{
  return m_pLevelDescriptors[level].NumRandomFloorDecorations();
}

void CCSBuildDoc::NumRandomWallDecorations(int level, int num)
{
  m_pLevelDescriptors[level].NumRandomWallDecorations(num);
}

void CCSBuildDoc::NumRandomFloorDecorations(int level, int num)
{
  m_pLevelDescriptors[level].NumRandomFloorDecorations(num);
}

int CCSBuildDoc::NumMonsterType(int level)
{
  return m_pLevelDescriptors[level].numMonsterType();
}

WALLTYPE CCSBuildDoc::WallDecorationType(int level, int index)
{
  ui8 *pntr;
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  return (WALLTYPE)(pntr[index]);
}


bool CCSBuildDoc::IsValidWallDecorationOrdinal(
                     int level, int ordinal)
{
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    InternalError("Illegal Level");
    return false;
  };
  return (ordinal > 0) && (ordinal <= pDoc->NumWallDecorations(level));
}


bool CCSBuildDoc::IsLegalWallDecorationIndex(int level, int ordinal)
{
  WALLTYPE wt;
  ui8 *pntr;
  if (!IsValidWallDecorationOrdinal(level, ordinal)) return false;
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  return wt.IsLegal(pntr[ordinal-1]);
}

ORNATETYPE CCSBuildDoc::DoorDecorationType(int level, int index)
{
  ui8 *pntr;
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  pntr += NumFloorDecorations(level);
  return (ORNATETYPE)(pntr[index]);
}

MONSTERTYPE CCSBuildDoc::MonsterType(int level, int index)
{
  ui8 *pntr;
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  return (MONSTERTYPE)pntr[index];
}

FLOORTYPE CCSBuildDoc::FloorDecorationType(int level, int ordinal)
{
  ui8 *pntr;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    InternalError("Illegal Level");
    return FLOORTYPE(); //Defaults to none
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  return FLOORTYPE(pntr[ordinal-1]);
}

bool CCSBuildDoc::IsValidFloorDecorationOrdinal(
                     int level, int ordinal)
{
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    InternalError("Illegal Level");
    return false;
  };
  return (ordinal > 0) && (ordinal <= pDoc->NumFloorDecorations(level));
}

bool CCSBuildDoc::IsLegalFloorDecorationIndex(int level, int ordinal)
{
  FLOORTYPE ft;
  ui8 *pntr;
  if (!IsValidFloorDecorationOrdinal(level, ordinal)) return false;
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  return ft.IsLegal(pntr[ordinal-1]);
}


bool CCSBuildDoc::IsValidMonsterType(int level, MONSTERTYPE mt)
{
  ui8 *pntr;
  int i;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    InternalError("Illegal Level");
    return false;
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  for (i=0; i<NumMonsterType(level); i++)
  {
    MONSTERTYPE mti(pntr[i]);
    if (mt == mti) return true;
  };
  return false;
}

FLOORTYPE CCSBuildDoc::FloorDecorationType(
                            LEVELINFO *levelInfo, int ordianl)
{
  return FloorDecorationType(levelInfo->level, ordianl);
}

void CCSBuildDoc::RotateDecoration(int level,int offset,int index)
{
  int n = 0, i;
  CELLFLAG *pCF, temp;
  n += NumMonsterType(level);
  n += NumWallDecorations(level);
  n += NumFloorDecorations(level);
  n += NumDoorDecorations(level);
  if (offset+index >= n)
  {
    InternalError("Illegal Decoration Rotation");
    return;
  };
  pCF = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)+1];
  pCF += offset;
  temp = pCF[index];
  for (i=index; i>0; i--)
  {
    pCF[i] = pCF[i-1];
  };
  pCF[0] = temp;
  SetModifiedFlag();
}

void CCSBuildDoc::FindNextObject(SEARCHPKT *pkt)
{
  ASSERT (pkt->object != RNeof);
  if (pkt->object == RNeof) return;
  if (pkt->object == RNnul)
  {
    pkt->level = -1;
    pkt->row = 99;
    pkt->col = 99;
  }
  else
  { 
    do
    {
      pkt->object = this->GetDBRecordLink(pkt->object);
      if (  (pkt->object != RNeof)
          &&((1<<pkt->object.dbType()) & pkt->mask)) return;
    } while (pkt->object != RNeof);
  };
  for (;;) 
  { // A new cell must be searched
    pkt->row++;
    if ((pkt->row > 31) || (pkt->row > LastRow(pkt->level)))
    {
      pkt->row = 0;
      pkt->col++;
    };
    if ((pkt->col > 31) || (pkt->col > LastColumn(pkt->level)))
    {
      pkt->col=0;
      pkt->level++;
    };
    if (pkt->level >= NumLevel())
    {
      pkt->object = RNeof;
      return;
    };
    pkt->object = FindFirstObject(pkt->level, pkt->col, pkt->row);
    if (pkt->object == RNeof) continue; 
    if ((1<<pkt->object.dbType()) & pkt->mask) return;
    do
    {
      pkt->object = this->GetDBRecordLink(pkt->object);
      if (  (pkt->object != RNeof)
          &&((1<<pkt->object.dbType()) & pkt->mask)) return;
    } while (pkt->object != RNeof);
  };
}

int CCSBuildDoc::DoorType(int level, int index)
{

  if (index == 0) return m_pLevelDescriptors[level].Door1Type();
  else return m_pLevelDescriptors[level].Door2Type();
}

void CCSBuildDoc::DoorType(int level, int index, int type)
{

  if (index == 0) m_pLevelDescriptors[level].Door1Type(type);
  else m_pLevelDescriptors[level].Door2Type(type);
}

void CCSBuildDoc::PartyX(int x)
{
  if (m_partyX != x)
  {
    m_partyX = (ui16)x;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::PartyY(int y)
{
  if (m_partyY != y)
  {
    m_partyY = (ui16)y;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::PartyFacing(int facing)
{
  if (m_partyFacing != facing)
  {
    m_partyFacing=(ui16)facing;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::PartyLevel(int level)
{
  if (m_partyLevel != level)
  {
    m_partyLevel=(ui16)level;
    SetModifiedFlag();
  };
}

void CCSBuildDoc::SpellFilterLocation(const LOCATIONREL& locr)
{
  if ( (locr.l() >= 0) || (m_spellFilterLocation.l() >= 0) )
  {
    if (  (locr.l() != m_spellFilterLocation.l())
        ||(locr.x() != m_spellFilterLocation.x())
        ||(locr.y() != m_spellFilterLocation.y())
      )
    {
      m_spellFilterLocation = locr;
      SetModifiedFlag();
    };
  };
}

LOCATIONREL CCSBuildDoc::SpellFilterLocation(void) const
{
  return m_spellFilterLocation;
}

void CCSBuildDoc::MonsterAttackFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERATTACKFILTER;
  oldLocr = MonsterAttackFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::MonsterAttackFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERATTACKFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}

void CCSBuildDoc::PartyAttackFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_PARTYATTACKFILTER;
  oldLocr = PartyAttackFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::PartyAttackFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_PARTYATTACKFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}

void CCSBuildDoc::FeedingFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_FEEDINGFILTER;
  oldLocr = FeedingFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

void CCSBuildDoc::AdjustSkillsFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_ADJUSTSKILLSFILTER;
  oldLocr = AdjustSkillsFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

void CCSBuildDoc::DeleteMonsterFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_DELETEMONSTERFILTER;
  oldLocr = AdjustSkillsFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::FeedingFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_FEEDINGFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}


LOCATIONREL CCSBuildDoc::AdjustSkillsFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_ADJUSTSKILLSFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}

LOCATIONREL CCSBuildDoc::DeleteMonsterFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_DELETEMONSTERFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}









void CCSBuildDoc::IndirectActionLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_INDIRECTACTION;
  oldLocr = IndirectActionLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::IndirectActionLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_INDIRECTACTION;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}










void CCSBuildDoc::ViewingFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_VIEWINGFILTER;
  oldLocr = ViewingFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::ViewingFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_VIEWINGFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}

void CCSBuildDoc::SoundFilterLocation(const LOCATIONREL& locr)
{
  LOCATIONREL oldLocr;
  ui32 key, intLoc, *pRecord;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_SOUNDFILTER;
  oldLocr = ViewingFilterLocation();
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = locr.Integer();
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = locr.Integer();
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::SoundFilterLocation(void) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_SOUNDFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1) locr.Integer(*pRecord);
  return locr;
}


void CCSBuildDoc::MonsterMoveFilterLocation(
                        const LOCATIONREL& locr,
                        bool  sameLevel,
                        unsigned int maxDistance)
{
  LOCATIONREL oldLocr;
  bool oldSameLevel;
  unsigned int oldMaxDistance;
  ui32 key, intLoc, *pRecord, newVal;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERMOVEFILTER;
  oldLocr = MonsterMoveFilterLocation(&oldSameLevel, &oldMaxDistance);
  if (  (locr.l()    != oldLocr.l())
      ||(locr.x()    != oldLocr.x())
      ||(locr.y()    != oldLocr.y())
      ||(maxDistance != oldMaxDistance)
      ||(sameLevel   != oldSameLevel)
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      newVal =   locr.Integer() 
               | (sameLevel?(1<<18):0) 
               | (maxDistance<<19);
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = newVal;
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = newVal;
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::MonsterMoveFilterLocation(
                     bool *sameLevel,
                     unsigned int *maxDistance) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERMOVEFILTER;
  size = expool.Locate(key,&pRecord);
  if (size >= 1)
  {
    locr.Integer((*pRecord) & 0x3ffff);
    *sameLevel = (*pRecord & 0x40000) != 0;
    *maxDistance = ((*pRecord) >> 19) & 0x1f;
  }
  else
  {
    *sameLevel = false;
    *maxDistance = 0;
  };
  return locr;
}

void CCSBuildDoc::MonsterMoveFilterLocation(
                        const LOCATIONREL& locr,
                        bool  sameLevel,
                        unsigned int maxDistance,
                        int level)
{
  LOCATIONREL oldLocr;
  bool oldSameLevel;
  unsigned int oldMaxDistance;
  ui32 key, intLoc, *pRecord, newVal;
  i32 size;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERMOVEFILTER + (((level & 0xff)+1) << 8);
  oldLocr = MonsterMoveFilterLocation(&oldSameLevel, &oldMaxDistance, level);
  if (  (locr.l() != oldLocr.l())
      ||(locr.x() != oldLocr.x())
      ||(locr.y() != oldLocr.y())
     )
  {
    if (locr.l() == -1)
    {
      expool.Read(key,NULL,0); // Delete the record
    }
    else
    {
      newVal =   locr.Integer() 
               | (sameLevel?(1<<18):0) 
               | (maxDistance<<19);
      size = expool.Locate(key, &pRecord);
      if (size > 0) 
      { //Found a valid record
        *pRecord = newVal;
      }
      else
      {
        if (size == 0) expool.Read(key, NULL, 0); //Delete it
        intLoc = newVal;
        expool.Write(key, &intLoc, 1);
      };
    };
  };
}

LOCATIONREL CCSBuildDoc::MonsterMoveFilterLocation(
                     bool *sameLevel,
                     unsigned int *maxDistance,
                     int level) const
{
  ui32 key;
  ui32 *pRecord;
  i32 size;
  LOCATIONREL locr;
  key = (EDT_SpecialLocations << 24) + ESL_MONSTERMOVEFILTER + (((level & 0xff)+1) << 8);
  size = expool.Locate(key,&pRecord);
  if (size >= 1)
  {
    locr.Integer((*pRecord) & 0x3ffff);
    *sameLevel = (*pRecord & 0x40000) != 0;
    *maxDistance = ((*pRecord) >> 19) & 0x1f;
  }
  else
  {
    *sameLevel = false;
    *maxDistance = 0;
  };
  return locr;
}

TIMER *CCSBuildDoc::Timer(int index)
{
  return m_Timers + m_timerQue[index];
}

void CCSBuildDoc::EnlargeDataMap(void)
{
  int newDML;
  if (m_dataMapLength > 64000)
  {
    DIE("More than 64000 objects");
  };
  newDML = (m_dataMapLength/32)*32 + 33;
  m_dataTypeMap = (ui8 *)realloc(m_dataTypeMap, newDML, MALLOC036);
  m_dataIndexMap = (ui16 *)realloc(m_dataIndexMap, 2*newDML, MALLOC037);
  if ((m_dataTypeMap==NULL)||(m_dataIndexMap==NULL))
  {
    DIE("Cannot Allocate Memory");
  };
  m_dataIndexMap[m_dataMapLength] = 0xffff;
  m_dataMapLength++;
}

ui16 CCSBuildDoc::AllocateIndirectIndex(DBTYPE dbType, int dbIndex)
{
  DBTYPE dbt;
  int i;
  int emptyIndirectIndex = -1;
  ASSERT(dbIndex < db.NumEntry(dbType));
  for (i=1; i<m_dataMapLength; i++)
  {
    if (m_dataIndexMap[i] == dbIndex)
    {
      if ((m_dataTypeMap[i]&15) == dbType)
      {
        return (ui16)i;
      };
    };
    if (emptyIndirectIndex == -1)
    {
      if (m_dataIndexMap[i] == RNnul)
      {
        emptyIndirectIndex = i;
      }
      else
      {
        dbt = DBTYPE(m_dataTypeMap[i] & 15);
        if (m_dataIndexMap[i] >= db.NumEntry(dbt)) continue;
        if (db.GetCommonAddress(dbt, m_dataIndexMap[i])->link()==RNnul)
        {
          emptyIndirectIndex = i;
        };
      };
    };
  };
  if (emptyIndirectIndex == -1)
  {
    emptyIndirectIndex = m_dataMapLength;
    EnlargeDataMap();
  };
  m_dataTypeMap[emptyIndirectIndex] = (ui8)dbType;
  m_dataIndexMap[emptyIndirectIndex] = (ui16)dbIndex;
  return (ui16)emptyIndirectIndex;
}

void CCSBuildDoc::ReleaseObjectIndirectIndex(int objectIndirectIndex)
{
  m_dataIndexMap[objectIndirectIndex] = RNnul;
}

DBTYPE CCSBuildDoc::DataType(int indirectIndex)
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  return DBTYPE(m_dataTypeMap[indirectIndex] & 15);
}

bool CCSBuildDoc::IsIndirectIndexOK(int indirectIndex) const
{
  return (indirectIndex!=0)&&(indirectIndex<m_dataMapLength);
}

void CCSBuildDoc::ClearReferenceAndCloneFlags(void)
{
  int i;
  for (i=0; i<m_dataMapLength; i++)
  {
    m_dataTypeMap[i] &= ~(0x80|0x40);
  };
}

ui8 CCSBuildDoc::DataPosition(int indirectIndex) 
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  return (ui8)((m_dataTypeMap[indirectIndex]>>4)&3);
}

ui16 CCSBuildDoc::DataDBIndex(int indirectIndex)
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  return m_dataIndexMap[indirectIndex];
}

void CCSBuildDoc::DataPosition(int indirectIndex,int pos) 
{ 
  ASSERT(IsIndirectIndexOK(indirectIndex));
  m_dataTypeMap[indirectIndex] &= 0xcf;
  m_dataTypeMap[indirectIndex] |= (pos & 3) << 4;
  MODIFY
}

bool CCSBuildDoc::IsIndirectIndexReferenced(int indirectIndex) const
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  return (m_dataTypeMap[indirectIndex] & 0x40) !=0;
}

bool CCSBuildDoc::IsIndirectIndexCloned(int indirectIndex) const
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  return (m_dataTypeMap[indirectIndex] & 0x80) !=0;
}

void CCSBuildDoc::MarkIndirectIndexReferenced(int indirectIndex)
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  m_dataTypeMap[indirectIndex] |= 0x40;
}

void CCSBuildDoc::MarkIndirectIndexCloned(int indirectIndex)
{
  ASSERT(IsIndirectIndexOK(indirectIndex));
  m_dataTypeMap[indirectIndex] |= 0x80;
}

int CCSBuildDoc::FindTimerPosition(i32 timerIndex)
{ // Find position of timer entry in timer queue.
  int i;
  for (i=0; i<m_MaxTimers; i++)
  {
    if (m_timerQue[i] == timerIndex) return i;
  };
  Strange("Attempt to delete non-existent timer");
  return 0;
}




void CCSBuildDoc::DeleteTimer(TIMER *pTimer)
{
  unsigned int timerIndex = pTimer-m_Timers;
  if (timerIndex >= (unsigned)m_MaxTimers)
  {
    DIE("Illegal Timer Index");
  };
  i32 QPos;
  m_Timers[timerIndex].timerFunction = timerFunction0;
  SetModifiedFlag();
  if (timerIndex < (unsigned)m_NextAvailTimer)
  {
    m_NextAvailTimer = (ui16)timerIndex;
  };
  m_numTimer--;
  if (m_numTimer != 0)
  {
    QPos = FindTimerPosition(timerIndex);
    if (QPos != m_numTimer) // If it was not the last entry
    {
      m_timerQue[QPos] = m_timerQue[m_numTimer];
        // Move last entry into vacated position.
      RepositionTimerEntry(QPos);
    };
  };
}


void CCSBuildDoc::RepositionTimerEntry(i32 timerQPosition)
{ // Current position of timer in queue.
  //dReg D0, D4, D5, D6, D7;
  TIMER *pOrigTimer, *pNextTimer;
  bool swap;
  int origIndex;
  int thisIndex;
  int nextIndex;
  thisIndex = timerQPosition;
  if(m_numTimer == 1) return;
  origIndex = m_timerQue[thisIndex];
  pOrigTimer = &m_Timers[origIndex]; // New entry to insert
  swap = false;
  while (thisIndex != 0) //Attempt to find entry
  { // Starting at middle word keep dividing the
    // que in half and moving the new entry down
    // as long as it is smaller than the one already
    // there.  Set local_2 if any such swap occurs.
    nextIndex = (thisIndex-1)/2; // Locate middle item???
    pNextTimer = &m_Timers[m_timerQue[nextIndex]];
    if (!TestTimerLess(pOrigTimer, pNextTimer)) // Is new smaller
    {
      break;
    };
    m_timerQue[thisIndex] = m_timerQue[nextIndex];
    thisIndex = nextIndex; //The new empty spot
    swap = true; //we made a swap
  };
  if (!swap)
  {
    while (thisIndex <= (m_numTimer-2)/2)
    {
      nextIndex = 2*thisIndex + 1;
      if (nextIndex+1 < m_numTimer)
      {
        if (TestTimerLess(&m_Timers[m_timerQue[nextIndex+1]],
                          &m_Timers[m_timerQue[nextIndex]]))
        {
          nextIndex++;
        };
      };
      if (!TestTimerLess(&m_Timers[m_timerQue[nextIndex]], 
                         pOrigTimer))
      {
        break;
      };
      m_timerQue[thisIndex] = m_timerQue[nextIndex];
      thisIndex = nextIndex;
    }; //while
  };
  m_timerQue[thisIndex] = (ui16)origIndex;
}

int CCSBuildDoc::SetTimer(TIMER *pNewTimer) //
{
  TIMER *pTimer, *pNextTimer, *pt;
  int nextAvail;
  if (m_numTimer == m_MaxTimers)
  {
    DIE("No empty Timer entries");
  };
  if (   (pNewTimer->timerFunction >= timerFunction5) 
      && (pNewTimer->timerFunction <= timerFunction10))
  {
    NotImplemented();
    /*
    for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
    {
      if (   (ptA2->timerFunction >= timerFunction5)
          && (ptA2->timerFunction <= timerFunction10)  )
      {
        if (pNewTimer->timerTime != ptA2->timerTime) continue;
        if (pNewTimer->timerWord6() != ptA2->timerWord6()) continue;
        if (ptA2->timerFunction == timerFunction6)
        {
          if (ptA2->timerUByte8 != pNewTimer->timerUByte8) continue;
        };
        ptA2->timerUByte9 = pNewTimer->timerUByte9;
        //TraceTimer(ptA2, D7W, "Byte9");
        ASSERTTimer(CheckTimers());
        return D7W;//goto tag010224;
      };
      if (ptA2->timerFunction != timerFunction1) continue;
      if (pNewTimer->timerTime != ptA2->timerTime) continue;
      if (pNewTimer->timerWord6() != ptA2->timerWord6()) continue;
      if (pNewTimer->timerUByte9 == 2)
      {
        D0W = sw(1 - ptA2->timerUByte9);
        pNewTimer->timerUByte9 = D0B;
        //TraceTimer(pNewTimer,0,"Byte9");
      };
      DeleteTimer(D7W);
      //TraceTimer(ptA2,D7W,"Delete");
      break;

    }; //for (D7W, A2)
    */
  }
  else
  {
    if (pNewTimer->timerFunction == timerFunction1)
    {
      NotImplemented();
      /*
      for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
      {
        if (pNewTimer->timerTime != ptA2->timerTime) continue;
        if (pNewTimer->timerWord6() != ptA2->timerWord6()) continue;
        if (ptA2->timerFunction == timerFunction10)
        {
          if (ptA2->timerUByte9 != 2)
          {
            ASSERTTimer(CheckTimers());
            TraceTimer(ptA2,D7W,"Unchanged");
            return D7W;
          };
          ptA2->timerUByte9 = ub(1 - pNewTimer->timerUByte9);
          TraceTimer(ptA2,D7W,"byte9");
          ASSERTTimer(CheckTimers());
          return D7W;
        };
        if (ptA2->timerFunction != timerFunction1) continue;
        ptA2->timerUByte9 = pNewTimer->timerUByte9;
        TraceTimer(ptA2, D7W, "Byte");
        ASSERTTimer(CheckTimers());
        return D7W;
  
      }; // for (D7W, uA2)
    */
    }
    else if (pNewTimer->timerFunction == timerFunction2)
    {
      NotImplemented();
      /*
      for (D7W=0, ptA2=d.Timers; D7W<d.MaxTimers; D7W++, ptA2++)
      {
        if (pNewTimer->timerWord6() != ptA2->timerWord6()) continue;
        D0L = (pNewTimer->timerTime>>24)&0xff;
        D1L = (ptA2->timerTime>>24)&0xff;
        if (D1L != D0L) continue;
        if (ptA2->timerFunction != timerFunction1)
        {
          if (ptA2->timerFunction != timerFunction10) continue;
        };
        DeleteTimer(D7W);
        TraceTimer(ptA2,D7W,"Delete");
      }; // for (D7W, A2)
    */
    };
  };
  pTimer = pNewTimer;
  nextAvail = m_NextAvailTimer;
  ASSERT(m_NextAvailTimer < m_MaxTimers);
  pNextTimer = &m_Timers[nextAvail];//Next available timer entry
  memcpy(pNextTimer, pTimer, 8); // Copy Timer to m_timers array.
tag0101dc:
  if (m_NextAvailTimer == m_MaxTimers) goto tag010204;
  m_NextAvailTimer++; //Try to find an empty entry for next time.
  pt = &m_Timers[m_NextAvailTimer];
  if (pt->timerFunction != timerFunction0) goto tag0101dc;
tag010204:
  m_timerQue[m_numTimer] = (i16)nextAvail;
  m_numTimer++;
  RepositionTimerEntry(m_numTimer-1);
  //TraceTimer(&d.Timers[D5W], D5W, "create");
  //ASSERTTimer(CheckTimers());
  return nextAvail;
}



bool CCSBuildDoc::TestTimerLess(TIMER *timer1, TIMER *timer2)
{
  // return 1 if *p1 < *p2
  unsigned int time1, time2;
  time1 = timer1->time & 0xffffff; //D2=*p1
  time2 = timer2->time & 0xffffff; //D1=*p2
  if (time1 < time2) return true; // *p1 < *p2
  if (time1 > time2) return false; // *p1 > *p2
  // Times are the same. Compare the first word.
  if (timer1->timerFunction > timer2->timerFunction) return true;
  if (timer1->timerFunction < timer2->timerFunction) return false;
  if (timer1->uByte5 > timer2->uByte5) return true;
  if (timer1->uByte5 < timer2->uByte5) return false;
  // Identical entries.  The smaller pointer comes first
  if (timer2 >= timer1) return true;
  return false;
}

void CCSBuildDoc::AddFloorDecoration(int level, FLOORTYPE ft)
{
  ui8 *pntr;
  int index;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  pntr += NumFloorDecorations(level);
  index = pntr - m_cellFlagArray;
  m_pLevelDescriptors[level].NumFloorDecorations(
            m_pLevelDescriptors[level].NumFloorDecorations() + 1);
  InsertByteIntoCellflagArray(index, ft.Integer());
}

void CCSBuildDoc::ReplaceFloorDecoration(int level, 
                                        FLOORTYPE ft,
                                        int ordinal)
{
  ui8 *pntr;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  if (ordinal > pDoc->NumFloorDecorations(level))
  {
    DIE("Illegal Floor Decoration Ordinal");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  pntr[ordinal-1] = ft.Integer();
  SetModifiedFlag();
}


void CCSBuildDoc::AddWallDecoration(int level, WALLTYPE wt)
{
  ui8 *pntr;
  int index;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  index = pntr - m_cellFlagArray;
  m_pLevelDescriptors[level].NumWallDecoration(
            m_pLevelDescriptors[level].NumWallDecoration() + 1);
  InsertByteIntoCellflagArray(index, wt.Integer());
}

void CCSBuildDoc::ReplaceWallDecoration(int level, 
                                        WALLTYPE wt,
                                        int index)
{
  ui8 *pntr;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  if (index >= pDoc->NumWallDecorations(level))
  {
    DIE("Illegal Wall Decoration Index");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr[index] = wt.Integer();
  SetModifiedFlag();
}


void CCSBuildDoc::AddDoorDecoration(int level, ORNATETYPE ot)
{
  ui8 *pntr;
  int index;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  pntr += NumFloorDecorations(level);
  pntr += NumDoorDecorations(level);
  index = pntr - m_cellFlagArray;
  m_pLevelDescriptors[level].NumDoorDecorations(
            m_pLevelDescriptors[level].NumDoorDecorations() + 1);
  InsertByteIntoCellflagArray(index, ot.Integer());
}

void CCSBuildDoc::ReplaceDoorDecoration(int level, 
                                        ORNATETYPE ot,
                                        int index)
{
  ui8 *pntr;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  if (index >= pDoc->NumDoorDecorations(level))
  {
    DIE("Illegal Door Decoration Index");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr += NumMonsterType(level);
  pntr += NumWallDecorations(level);
  pntr += NumFloorDecorations(level);
  pntr[index] = ot.Integer();
  SetModifiedFlag();
}

void CCSBuildDoc::AddMonsterType(int level, MONSTERTYPE mt)
{
  ui8 *pntr;
  int index;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  index = pntr - m_cellFlagArray;
  m_pLevelDescriptors[level].numMonsterType(
            m_pLevelDescriptors[level].numMonsterType() + 1);
  InsertByteIntoCellflagArray(index, mt.Integer());
}

void CCSBuildDoc::ReplaceMonsterType(int level, 
                                     MONSTERTYPE mt,
                                     int index)
{
  ui8 *pntr;
  if ( (level<0) || (level>=pDoc->NumLevel()))
  {
    DIE("Illegal Level");
  };
  if (index >= pDoc->NumMonsterType(level))
  {
    DIE("Illegal Monster Index");
  };
  pntr = &m_pppdPointer10450[level][LastColumn(level)][LastRow(level)];
  pntr += 1;
  pntr[index] = mt.Integer();
  SetModifiedFlag();
}



void CCSBuildDoc::InsertByteIntoCellflagArray(
                  int index, ui8 value)
{
  // Our plan.
  // 1) realloc the cellflag array
  // 2) update cellflagArraySize in dungeonDatIndex
  // 3) move the end of cellflags and insert the byte
  // 4) update the cellOffsets in the level descriptors
  // 5) recompute the m_pppd10450 structure.
  int oldsize, newsize, i, offset;
  oldsize = CellFlagArraySize();
  newsize = oldsize + 1;
  CellFlagArraySize(newsize);
  m_cellFlagArray = (ui8 *)realloc(m_cellFlagArray,
                                   newsize,
                                   MALLOC039);
  if (m_cellFlagArray == NULL)
  {
    DIE("Cannot allocate memory");
  };
  memmove(m_cellFlagArray+index+1,
          m_cellFlagArray+index,
          oldsize-index);
  m_cellFlagArray[index] = value;
  for (i=0; i<NumLevel(); i++)
  {
    offset = CellOffset(i);
    if (offset >= index)
    {
      m_pLevelDescriptors[i].CellOffset(offset+1);
    };
  };
  RecomputePppd10450();
}

void CCSBuildDoc::RecomputePppd10450(void)
{
  CELLFLAG *pCell;
  CELLFLAG **pColumnPointer;
  int i;
  pColumnPointer = (CELLFLAG **)m_pppdPointer10450 + NumLevel(); 
                 //Where first column pointer goes
  for (i=0; i<NumLevel(); i++)
  {
    m_pppdPointer10450[i] = pColumnPointer;
    pCell = m_cellFlagArray + CellOffset(i); // First cell in dungeon
    for (i32 column=0;
         column<= m_pLevelDescriptors[i].LastColumn();
         column++)
    {
      *(pColumnPointer++) = pCell;
      pCell += LastRow(i) + 1; //add one column of cells
    }; // for column
  };/// for i=1 to level
}

void CCSBuildDoc::AddObjectToList(RN newobj,
                                  RN *pList,
                                  RN after)
{ //after = RNnul = put at front of list.
  //after = RNeof = put at end of list
  //after = object = put after object
  DBCOMMON *pCommon;
  RN current, next;
  pCommon = GetCommonAddress(newobj);
  pCommon->link(RNeof);
  if (*pList == RNeof)
  {
    *pList = newobj;
    return;
  };
  if (after == RNnul)
  {
    pCommon->link(*pList);
    *pList = newobj;
    return;
  };
  if (after == RNeof)
  {
    for (next=*pList; next!=RNeof; next=GetDBRecordLink(next))
    {
      current=next;
    };
    GetCommonAddress(current)->link(newobj);
    return;
  };
  for (current=*pList; 
       !current.IsSameObjectAs(after); 
       current=GetDBRecordLink(current))
  {
    if (current == RNeof)
    {
      InternalError();
      return;
    };
  };
  pCommon->link(GetDBRecordLink(current));
  pCommon = GetCommonAddress(current);
  pCommon->link(newobj);
}


void CCSBuildDoc::DeleteObjectFromList(RN obj, 
                                       RN *pList, 
                                       bool discard,
                                       bool clearObjLink)
{
  DBCOMMON *pCommon;
  RN cur, prev;
  if (pList->IsSameObjectAs(obj))
  {
    pCommon = GetCommonAddress(obj);
    *pList = pCommon->link();
    if (clearObjLink) pCommon->link(RNeof);
    MODIFY
  }
  else
  {
    cur = *pList;
    while (!cur.IsSameObjectAs(obj))
    {
      if (cur == RNeof)
      {
        Strange("I have been asked to delete\n"
                "an object from a list it's not on");
        return;
      };
      prev = cur;
      cur = GetDBRecordLink(cur);
    };
    pCommon = GetCommonAddress(cur);
    cur = pCommon->link();
    pCommon = GetCommonAddress(prev);
    pCommon->link(cur);
    if (clearObjLink) GetCommonAddress(obj)->link(RNeof);
    MODIFY
  };
  if (discard)
  {
    obj.Delete();
  };
}

//*********************************************
unsigned int CCSBuildDoc::WCS(CArchive& ar)
{
  unsigned int temp;
  m_pWCSar = &ar;
  temp = m_WCSChecksum;
  m_WCSChecksum = 0xffff;
  return temp;
}

unsigned int CCSBuildDoc::RCS(CFile *f)
{
  unsigned int temp;
  m_pRCSCFile = f;
  temp = m_WCSChecksum;
  m_WCSChecksum = 0xffff;
  return temp;
}

void CCSBuildDoc::WCS(ui8 *buf, int n)
{
  int i;
  for (i=0; i<n; i++)
  {
    m_WCSChecksum *= (unsigned int)0xbb40e62d;
    m_WCSChecksum += 11 + buf[i];
  };
  BinaryWrite(*m_pWCSar, buf, n);
}

void CCSBuildDoc::RCS(ui8 *buf, int n)
{
  int i;
  m_pRCSCFile->Read(buf, n);
  for (i=0; i<n; i++)
  {
    m_WCSChecksum *= (unsigned int)0xbb40e62d;
    m_WCSChecksum += 11 + buf[i];
  };
}

void CCSBuildDoc::WCS(unsigned int *i, int n)
{
  WCS((ui8 *)i, 4*n);
}

void CCSBuildDoc::RCS(unsigned int *i, int n)
{
  RCS((ui8 *)i, 4*n);
}

void CCSBuildDoc::WCS(int *i, int n)
{
  WCS((ui8 *)i, 4*n);
}

void CCSBuildDoc::RCS(int *i, int n)
{
  RCS((ui8 *)i, 4*n);
}

void CCSBuildDoc::WCS(ui16 *i, int n)
{
  WCS((ui8 *)i, 2*n);
}

void CCSBuildDoc::RCS(ui16 *i, int n)
{
  RCS((ui8 *)i, 2*n);
}

void CCSBuildDoc::WCS(char *c, int n)
{
  WCS((ui8 *)c, n);
}

void CCSBuildDoc::RCS(char *c, int n)
{
  RCS((ui8 *)c, n);
}

void CCSBuildDoc::DeleteMonsterMovementTimers(
                   LOCATIONREL locr)
{ //Timer types 29 to 41
  TIMER *pTimer;
  int i;
  int level;
  int func;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  //D7W = P1;
  //D6W = P2;
  pTimer = m_Timers;
  for (i=0; i<m_MaxTimers; pTimer++,i++)
  {
    level = (pTimer->time >> 24) & 0xff;
    if (level != locr.l()) continue;
    func = pTimer->timerFunction;
    if (func < 29) continue;
    if (func > 41) continue;
    if (pTimer->uByte6 != locr.x()) continue;
    if (pTimer->uByte7 != locr.y()) continue;
    DeleteTimer(pTimer);
  };
}

unsigned int CCSBuildDoc::EditingOptions(void)
{
  return m_editingOptions;
}

void CCSBuildDoc::EditingOptions(unsigned int opt)
{
  if (opt != m_editingOptions) 
  {
    SetModifiedFlag();
  };
  m_editingOptions = opt;
}

ROOMTYPE CCSBuildDoc::GetLogicalRoomType(LOCATIONREL locr)
{
  ROOMTYPE rt;
  CELLFLAG cf;
  rt = GetRoomType(locr);
  if (rt != roomFALSEWALL) return rt;
  cf = GetCellFlag(locr);
  if ((cf & 0x04) != 0) return roomOPEN;
  return roomSTONE;
}

void CCSBuildDoc::DetermineActuatorRoomTypesList(
                      RN firstObj, ROOMTYPE rt, ROOMTYPE *result)
{
  RN obj;
  int index;
  for (obj=firstObj; obj!=RNeof; obj=GetDBRecordLink(obj))
  {
    if (obj.dbType() != dbACTUATOR) continue;
    index = obj.dbIndex();
    result[index] = rt;
  };
}

ROOMTYPE *CCSBuildDoc::DetermineActuatorRoomTypes(void)
{
  ROOMTYPE *result;
  LOCATIONREL locr;
  int n;
  n = db.NumEntry(dbACTUATOR);
  result = (ROOMTYPE *)malloc(n*sizeof(ROOMTYPE), MALLOC076);
  memset(result, 0xff, n*sizeof(ROOMTYPE));
  for (locr.First(); locr.l() >= 0; locr.Next())
  {
    DetermineActuatorRoomTypesList(
             FindFirstObject(locr), RoomType(locr), result);
  };
  return result;
}

bool CCSBuildDoc::VerifyLevelData(void)
{
  int level, totalColumns;
  unsigned int totalCells;
  int col, row;
  int numLevel;
  int nextObjectIndex = 0;
  CELLFLAG *pCell, *pNextCell;
  numLevel = NumLevel();
  totalColumns = 0;
  totalCells = 0;
  int occupiedCells; //#occupied cells in column
  if (m_objectLevelIndex[0] != 0)
  {
    if (numLevel != 0)
    {
      return false;
    };
  };
  if (m_pppdPointer10450[0] != (CELLFLAG **)m_pppdPointer10450 + numLevel)
  {
    if (numLevel != 0) 
    {
      return false;
    };
  };
  if (m_pppdPointer10450[0][0] != m_cellFlagArray)
  {
    if (numLevel != 0) 
    {
      return false;
    };
  };
  if (m_objectColumnIndex[0] != 0)
  {
    if (numLevel != 0)
    {
      return false;
    };
  };
  for (level=0; level<numLevel; level++)
  {
    if (CellOffset(level) 
           != m_pppdPointer10450[level][0] - m_cellFlagArray)
    {
      return false;
    };
    if (level != numLevel - 1)
    {
      if (m_pppdPointer10450[level+1] != m_pppdPointer10450[level] + LastColumn(level) + 1)
      {
        return false;
      };
      if (m_objectLevelIndex[level+1] != m_objectLevelIndex[level] + LastColumn(level) + 1)
      {
        return false;
      };
    };
    totalColumns += LastColumn(level) + 1;
    totalCells +=  (LastColumn(level) + 1) * (LastRow(level) + 1)
                  + NumMonsterType(level)
                  + NumWallDecorations(level)
                  + NumFloorDecorations(level)
                  + NumDoorDecorations(level);
    pCell = m_pppdPointer10450[level][0];
    for (col=0; col<=LastColumn(level); col++)
    {
      occupiedCells = 0;
      pCell = m_pppdPointer10450[level][col];
      for (row=0; row<=LastRow(level); row++, pCell++)
      {
        if (*pCell & 0x10) occupiedCells++;
      };
      nextObjectIndex =   m_objectColumnIndex[m_objectLevelIndex[level]+col]
                        + occupiedCells;
      if (col < LastColumn(level))
      {
        if (m_pppdPointer10450[level][col+1] != pCell)
        {
          return false;
        };
        if (nextObjectIndex != m_objectColumnIndex[m_objectLevelIndex[level]+col+1])
        {
          return false;
        };
      };
    };
    //Now see how many bytes of extra info.
    pNextCell = pCell + NumMonsterType(level)
                      + NumWallDecorations(level)
                      + NumFloorDecorations(level)
                      + NumDoorDecorations(level);
    if (level < numLevel-1)
    {
      if (pNextCell != m_pppdPointer10450[level+1][0])
      {
        return false;
      };
      if (nextObjectIndex != m_objectColumnIndex[m_objectLevelIndex[level+1]])
      {
        return false;
      };
    }
    else
    {
      if (pNextCell > m_pppdPointer10450[0][0] + CellFlagArraySize())
      {
        return false;
      };
      if (nextObjectIndex > m_dungeonDatIndex->ObjectListLength())
      {
        return false;
      };
    };
  };
  if (m_numColumnPointers != totalColumns)
  {
    return false;
  };
  if (totalCells != CellFlagArraySize())
  {
    return false;
  };
  return true;
}


EXTRACTED_LEVEL *CCSBuildDoc::RemoveLevel(int level)
{
  EXTRACTED_LEVEL *pEXL;
  CELLFLAG *pFirstCellRemoved, *pLastCellRemoved, *pNextCell;
  CELLFLAG *pEndOfCells, *pNewEndOfCells;
  CELLFLAG **ppCellflag;
  int i, c, row, numLevel;
  int remainingCellBytes, numCellBytesRemoved;
  int dstColIndex, srcColIndex;
  int colIndex;
  RN *pFirstObjectRemoved, *pLastObjectRemoved;
  RN *pNextObject, *pEndOfObjects, *pNewEndObject;
  int numCol, numRow, numLevelsFollowing;
  int remainingObjectLinks, numObjectLinksRemoved;
  if (!VerifyLevelData()) 
  {
    return NULL;
  };
  numLevelsFollowing = NumLevel() - level - 1;
  numCol = LastColumn(level) + 1;
  numRow = LastRow(level) + 1;
  numLevel = NumLevel(); //Because we use it so often.
  pFirstCellRemoved = m_pppdPointer10450[level][0];
  pFirstObjectRemoved = &m_objectList[m_objectColumnIndex[m_objectLevelIndex[level]]];
  pLastCellRemoved =   m_pppdPointer10450[level][LastColumn(level)]
                     + LastRow(level)
                     + NumMonsterType(level)
                     + NumWallDecorations(level)
                     + NumFloorDecorations(level)
                     + NumDoorDecorations(level);
  numCellBytesRemoved = pLastCellRemoved - pFirstCellRemoved + 1;
  pLastObjectRemoved = &m_objectList[m_objectColumnIndex[m_objectLevelIndex[level]+numCol-1]];
  for (row=0; row<numRow; row++)
  {
    if (m_pppdPointer10450[level][numCol-1][row] & 0x10) pLastObjectRemoved++;
  };
  pLastObjectRemoved--;
//**********************************************************
//** First we extract all the needed data and
//** put it into a structure for later re-insertion.
//**********************************************************
  pEXL = new EXTRACTED_LEVEL;
  pEXL->m_origLevel = level;
//************************************************************
//**
//** Extract level descriptor
//**
//************************************************************
  memcpy(&pEXL->m_levelDescriptor, &m_pLevelDescriptors[level], sizeof (LEVELDESC));
//************************************************************
//**
//** Copy the DSA indicies for this level
//**
//************************************************************
  for (i=0; i<32; i++)
  {
    pEXL->m_DSALevelIndex[i] = m_DSALevelIndex[level][i];
  };
//**********************************************************
//**
//** Extract important variables that will make it
//** easier to re-insert this level.
//**
//**********************************************************
  pEXL->m_cellflagSize = numCellBytesRemoved;
  pEXL->m_contentsSize = pLastObjectRemoved - pFirstObjectRemoved + 1;
  pEXL->m_pCellflags = (CELLFLAG *)malloc(pEXL->m_cellflagSize, MALLOC082);
  pEXL->m_pContents = (RN *)malloc(pEXL->m_contentsSize * 2, MALLOC083);
//*********************************************************
//**
//** Extract object lists for this level.
//**
//*********************************************************
  pNextObject = pLastObjectRemoved + 1;
  pEndOfObjects = &m_objectList[m_dungeonDatIndex->ObjectListLength()];
  remainingObjectLinks = pEndOfObjects - pNextObject;
  numObjectLinksRemoved = pNextObject - pFirstObjectRemoved;
  memcpy(pEXL->m_pContents, 
         pFirstObjectRemoved, 
         numObjectLinksRemoved * sizeof (RN)); 
//***********************************************************
//**
//** Extract Cellflags for this level
//**
//**********************************************************
  memcpy(pEXL->m_pCellflags,
         pFirstCellRemoved,
         numCellBytesRemoved);
//*******************************************************
//**
//** Remove DSA indicies for this level
//**
//*******************************************************
  memcpy(m_DSALevelIndex[level],
         m_DSALevelIndex[level+1],
         numLevelsFollowing * 32 * sizeof (m_DSALevelIndex[0][0]));
//*******************************************************
//**
//** Remove Cellflags for the level
//**
//*******************************************************
  pNextCell = pLastCellRemoved + 1;
  pEndOfCells = m_cellFlagArray + CellFlagArraySize();
  remainingCellBytes = pEndOfCells - pNextCell;
  numCellBytesRemoved = pNextCell - pFirstCellRemoved;
  memcpy(pFirstCellRemoved,
         pNextCell,
         remainingCellBytes);
  pNewEndOfCells = pFirstCellRemoved + remainingCellBytes;
  memset(pNewEndOfCells, 0xff, numCellBytesRemoved);
  CellFlagArraySize(CellFlagArraySize() - numCellBytesRemoved);
//*******************************************************
//**
//** Remove Cellflag column pointers
//**
//*******************************************************
  ppCellflag = m_pppdPointer10450[level];
  for (i=level; i<numLevel-1; i++)
  {
    memcpy(ppCellflag,
           ppCellflag+numCol,
           (LastColumn(i+1) + 1) * sizeof (*m_pppdPointer10450[i]));
    ppCellflag += LastColumn(i+1) + 1;
  };
//*******************************************************
//**
//** Update remaining Cellflag column pointers
//**
//*******************************************************
  ppCellflag = m_pppdPointer10450[level];
  for (i=level; i<numLevel-1; i++)
  {
    for (c=0; c<=LastColumn(i+1); c++)
    {
      *(ppCellflag++) -= numCellBytesRemoved;
    };
  };
//*******************************************************
//**
//** Remove Cellflag level pointer and that will cause
//** the column pointers to move down one notch.
//**
//*******************************************************
  memcpy(&m_pppdPointer10450[level],
         &m_pppdPointer10450[level+1],
         numLevelsFollowing * sizeof(m_pppdPointer10450[level]));
  ppCellflag = (CELLFLAG **)m_pppdPointer10450 + numLevel;
  for (i=0; i<numLevel; i++)
  {
    if (i == level) continue; //They have been removed.
    memcpy(ppCellflag-1,
           ppCellflag,
           (LastColumn(i) + 1) * sizeof (ppCellflag[0]));
    ppCellflag += LastColumn(i) + 1;
  };
//*******************************************************
//**
//** Update Cellflag level pointers
//**
//*******************************************************
  for (i=0; i<numLevel-1; i++)
  {
    m_pppdPointer10450[i] -= 1;
    if (i >= level) m_pppdPointer10450[i] -= numCol;
  };
//*******************************************************
//**
//** Remove objects for the level
//**
//*******************************************************
  memcpy(pFirstObjectRemoved, 
         pNextObject,
         remainingObjectLinks * sizeof (RN));
  pNewEndObject = pFirstObjectRemoved + remainingObjectLinks;
  memset(pNewEndObject, 0xff, numObjectLinksRemoved * sizeof(RN));
//*******************************************************
//**
//** Remove object column indicies
//**
//*******************************************************
  if (level < numLevel-1)
  {
    dstColIndex = m_objectLevelIndex[level];
    srcColIndex = m_objectLevelIndex[level+1];
    for (i=level; i<numLevel-1; i++)
    {
      memcpy(&m_objectColumnIndex[dstColIndex],
             &m_objectColumnIndex[srcColIndex],
             (LastColumn(i+1) + 1) * sizeof (m_objectColumnIndex[0]));
      dstColIndex += LastColumn(i+1) + 1;
      srcColIndex += LastColumn(i+1) + 1;
    };
  };
//*******************************************************
//**
//** Update remaining object column indicies
//**
//*******************************************************
  colIndex = m_objectLevelIndex[level];
  for (i=level+1; i<numLevel; i++)
  {
    for (c=0; c<=LastColumn(i); c++, colIndex++)
    {
      m_objectColumnIndex[colIndex] = 
        (i16)(m_objectColumnIndex[colIndex] - numObjectLinksRemoved);
    };
  };
//*******************************************************
//**
//** Remove object level index for this level
//**
//*******************************************************
  memcpy(&m_objectLevelIndex[level],
         &m_objectLevelIndex[level+1],
         numLevelsFollowing * sizeof (m_objectLevelIndex[0]));
//*******************************************************
//**
//** Update remaining object level indicies
//**
//*******************************************************
  for (i=level; i<numLevel-1; i++)
  {
    m_objectLevelIndex[i] = (i16)(m_objectLevelIndex[i] - LastColumn(level) - 1);
  };
//*******************************************************
//**
//** Remove levelDescriptor for this level
//**
//*******************************************************
  memcpy(&m_pLevelDescriptors[level], 
         &m_pLevelDescriptors[level] + 1,
         numLevelsFollowing * sizeof(LEVELDESC));
//*******************************************************
//**
//**  Update CellOffsets in following level descriptors
//**
//*******************************************************
  for (i=level; i<numLevel-1; i++)
  {
    m_pLevelDescriptors[i].CellOffset(
         CellOffset(i) - numCellBytesRemoved);
    m_pLevelDescriptors[i].Level(i);
  };
  NumLevel(numLevel - 1);
  m_numColumnPointers -= numCol;
  m_dungeonDatIndex->ObjectListLength(
                  (i16)(pNewEndObject - m_objectList));
  if (!VerifyLevelData())
  {
    delete pEXL;
    return NULL;
  };
  return pEXL;
}

bool CCSBuildDoc::InsertLevel(int level, EXTRACTED_LEVEL *pEXL)
{
  int numLevel, numCol, numRow, numLevelsFollowing;
  int i, j, index, c, r, newSize;
  int newCellflagArraySize, cellBytesFollowing;
  int numCellBytesInserted;
  int numFollowingObjectLinks;
  CELLFLAG *pOrigCellFlagArray;
  CELLFLAG *pCell;
  int firstCellInsertedIndex;
  int lastCellInsertedIndex, newFollowingCellIndex, endOfCellsIndex;
  int newEndOfCellsIndex;
  CELLFLAG **pOrigCellLevelPointer;
  int firstObjectInsertedIndex;
  int oldLastObjectLinkIndex, newLastObjectLinkIndex;
  int colIndex, srcColIndex, dstColIndex;
  int numColumnsFollowing;
  if (!VerifyLevelData())
  {
    return false;
  };
  numLevel = NumLevel() + 1;
  if (numLevel > 1)
  {
    c = LastColumn(numLevel - 2);
    oldLastObjectLinkIndex 
       = m_objectColumnIndex[m_objectLevelIndex[numLevel-2] + c];
    for (r=0; r<=LastRow(numLevel-2); r++)
    {
      if (m_pppdPointer10450[numLevel-2][c][r] & 0x10) oldLastObjectLinkIndex++;
    };
    oldLastObjectLinkIndex--;
  }
  else
  {
    oldLastObjectLinkIndex = -1;
  };
  if (level < numLevel-1)
  {
    firstObjectInsertedIndex 
        = m_objectColumnIndex[m_objectLevelIndex[level]];
  }
  else
  {
    firstObjectInsertedIndex = oldLastObjectLinkIndex + 1;
  };
  numFollowingObjectLinks = oldLastObjectLinkIndex - firstObjectInsertedIndex + 1;
  numColumnsFollowing = 0;
  for (i=level; i<numLevel-1; i++)
  {
    numColumnsFollowing += LastColumn(i) + 1;
  };
  NumLevel(numLevel);
  numCol = pEXL->m_levelDescriptor.LastColumn() + 1;
  numRow = pEXL->m_levelDescriptor.LastRow() + 1;
  m_numColumnPointers += numCol;
//*******************************************************
//**
//**            ** And Firstly **
//** Insert levelDescriptor for this level
//**
//*******************************************************
  m_pLevelDescriptors 
      = (LEVELDESC *)realloc(
              m_pLevelDescriptors,
              numLevel * sizeof (LEVELDESC),
              MALLOC086);
  numLevelsFollowing = numLevel - level - 1;
  for (i=numLevel-1; i>level; i--)
  {
    m_pLevelDescriptors[i] = m_pLevelDescriptors[i-1];
    m_pLevelDescriptors[i].Level(i);
  };
  m_pLevelDescriptors[level] = pEXL->m_levelDescriptor;
  m_pLevelDescriptors[level].Level(level);
  memcpy(&pEXL->m_levelDescriptor, &m_pLevelDescriptors[level], sizeof (LEVELDESC));
//************************************************************
//**
//** Insert the DSA indicies for this level
//**
//************************************************************
  for (i=numLevel-1; i>level; i--)
  {
    for (j=0; j<32; j++)
    {
      m_DSALevelIndex[i][j] = m_DSALevelIndex[i-1][j];
    };
  };
  for (i=0; i<32; i++)
  {
     m_DSALevelIndex[level][i] = pEXL->m_DSALevelIndex[i];
  };
//*******************************************************
//**
//** Make room for Cellflags for the level
//**
//*******************************************************
  pOrigCellFlagArray = m_cellFlagArray;
  newCellflagArraySize =   CellFlagArraySize()
                         + pEXL->m_cellflagSize;
  m_cellFlagArray = (CELLFLAG *)realloc(m_cellFlagArray,
                                        newCellflagArraySize,
                                        MALLOC087);
//**********************************************************
//**
//** Update Cell Column pointers for new m_cellFlagArray
//**
//**********************************************************
  for (i=level; i<numLevel-1; i++)
  {
    for (c=0; c<=LastColumn(i+1); c++)
    {
      index = m_pppdPointer10450[i][c] - pOrigCellFlagArray;
      m_pppdPointer10450[i][c] = m_cellFlagArray + index;
    };
  };    
//***********************************************************
//**
//** Insert Cellflags for this level
//**
//**********************************************************
  if (level == numLevel-1)
  {
    firstCellInsertedIndex = CellFlagArraySize();
  }
  else
  {
    firstCellInsertedIndex = m_pppdPointer10450[level][0] - m_cellFlagArray;
  };
  lastCellInsertedIndex = firstCellInsertedIndex + pEXL->m_cellflagSize - 1;
  newFollowingCellIndex = lastCellInsertedIndex + 1;
  endOfCellsIndex = CellFlagArraySize();
  cellBytesFollowing = endOfCellsIndex - firstCellInsertedIndex;
  numCellBytesInserted = pEXL->m_cellflagSize;
  for (i=cellBytesFollowing-1; i>=0; i--)
  {
    m_cellFlagArray[newFollowingCellIndex + i] 
          = m_cellFlagArray[firstCellInsertedIndex + i];
  };
  newEndOfCellsIndex = newFollowingCellIndex + cellBytesFollowing;
  memcpy(m_cellFlagArray + firstCellInsertedIndex,
         pEXL->m_pCellflags,
         numCellBytesInserted);
  CellFlagArraySize(
        CellFlagArraySize() + numCellBytesInserted);
//*******************************************************
//**
//** Make room for additional cellflag level and column pointers
//**
//*******************************************************
  // We need one pointer for the level plus numCol pointers.
  pOrigCellLevelPointer = (CELLFLAG **)m_pppdPointer10450;
  m_pppdPointer10450 = (CELLFLAG ***)realloc(
      m_pppdPointer10450,
      (numLevel + m_numColumnPointers)*sizeof(m_pppdPointer10450[0]),
      MALLOC088);
  for (i=0; i<numLevel-1; i++)
  {
    index = m_pppdPointer10450[i] - pOrigCellLevelPointer;
    m_pppdPointer10450[i] = (CELLFLAG **)m_pppdPointer10450 + index + 1;
  };
//*******************************************************
//**
//** Insert new cellflag levelPointer
//**
//*******************************************************
  memmove(m_pppdPointer10450 + level + 1,
          m_pppdPointer10450 + level,
          (numLevelsFollowing + m_numColumnPointers - numCol) * sizeof (*m_pppdPointer10450));
  if (level == numLevel - 1)
  {
    m_pppdPointer10450[level] =  (CELLFLAG **)m_pppdPointer10450 
                                + numLevel
                                + m_numColumnPointers
                                - numCol;
  }
  else
  {
    index = m_pppdPointer10450[level] - pOrigCellLevelPointer;
    m_pppdPointer10450[level] =  (CELLFLAG **)m_pppdPointer10450
                               + index;
  };
//******************************************************
//**
//** Update following cellflag level pointers
//**
//******************************************************
  for (i=level+1; i<numLevel; i++)
  {
    index = m_pppdPointer10450[i] - pOrigCellLevelPointer;
    m_pppdPointer10450[i] = (CELLFLAG **)m_pppdPointer10450 + index + numCol;
  };
//*******************************************************
//**
//** Insert new Cellflag column pointers
//**
//*******************************************************
  if (level < numLevel-1)
  {
    memmove(m_pppdPointer10450[level] + numCol,
            m_pppdPointer10450[level],
            numColumnsFollowing * sizeof (*m_pppdPointer10450[0]));
  };
  for (c=0; c<numCol; c++)
  {
    m_pppdPointer10450[level][c] 
          = m_cellFlagArray + firstCellInsertedIndex + c*numRow;
  };
//*******************************************************
//**
//** Update remaining Cellflag column pointers
//**
//*******************************************************
  for (i=level+1; i<numLevel; i++)
  {
    for (c=0; c<=LastColumn(i); c++)
    {
      m_pppdPointer10450[i][c] += numCellBytesInserted;
    };
  };
//*******************************************************
//**
//** Make room for object lists for the level
//**
//*******************************************************
  newSize = oldLastObjectLinkIndex + 1 + pEXL->m_contentsSize;
  m_objectList = (RN *)realloc(
             m_objectList,
             newSize * sizeof (m_objectList[0]),
             MALLOC089);
  m_dungeonDatIndex->ObjectListLength((ui16)newSize);
  memmove(&m_objectList[firstObjectInsertedIndex + pEXL->m_contentsSize],
          &m_objectList[firstObjectInsertedIndex],
          numFollowingObjectLinks * sizeof (*m_objectList));
  newLastObjectLinkIndex = oldLastObjectLinkIndex + pEXL->m_contentsSize;
//*********************************************************
//**
//** Insert object lists for this level.
//**
//*********************************************************
  memcpy(m_objectList + firstObjectInsertedIndex,
         pEXL->m_pContents,
         pEXL->m_contentsSize * sizeof (m_objectList[0]));
//*******************************************************
//**
//** Update following object column indicies
//**
//*******************************************************
  for (i=level; i<numLevel-1; i++)
  {
    colIndex = m_objectLevelIndex[i];
    for (c=0; c<=LastColumn(i+1); c++)
    {
      m_objectColumnIndex[colIndex + c] = 
           (i16)(  m_objectColumnIndex[colIndex + c] 
                 + pEXL->m_contentsSize);
    };
  };
//*******************************************************
//**
//** Make room for object column indicies for this level
//**
//*******************************************************
  m_objectColumnIndex = (ui16 *)realloc(
          m_objectColumnIndex,
          m_numColumnPointers * sizeof (*m_objectColumnIndex),
          MALLOC090);
  if (level < numLevel-1)
  {
    srcColIndex = m_objectLevelIndex[level];
    dstColIndex = srcColIndex + numCol;
    memmove(m_objectColumnIndex + dstColIndex,
            m_objectColumnIndex + srcColIndex,
            numColumnsFollowing * sizeof(*m_objectColumnIndex));
  };
//*******************************************************
//**
//** Make room for new object level index for this level
//**
//*******************************************************
  m_objectLevelIndex = (ui16 *)realloc(
                m_objectLevelIndex,
                numLevel * sizeof (*m_objectLevelIndex),
                MALLOC091);
  memmove(&m_objectLevelIndex[level+1],
          &m_objectLevelIndex[level],
          numLevelsFollowing * sizeof (m_objectLevelIndex[0]));
//*******************************************************
//**
//** Insert new object level index for this level
//**
//*******************************************************
  if (level == 0)
  {
    m_objectLevelIndex[0] = 0;
  }
  else
  {
    m_objectLevelIndex[level] = (i16)(  m_objectLevelIndex[level-1]
                                      + LastColumn(level-1) + 1);
  };
//*******************************************************
//**
//** Update remaining object level indicies
//**
//*******************************************************
  for (i=level+1; i<numLevel; i++)
  {
    m_objectLevelIndex[i] = (i16)(m_objectLevelIndex[i] + numCol);
  };
//*******************************************************
//**
//** Rebuild ObjectColumnIndex for his level
//**
//*******************************************************
  pCell = m_pppdPointer10450[level][0];
  index = pCell - m_cellFlagArray;
  colIndex = firstObjectInsertedIndex;
  for (c=0; c<numCol; c++)
  {
    m_objectColumnIndex[m_objectLevelIndex[level] + c] = (i16)colIndex;
    for (r=0; r<numRow; r++)
    {
      if (*(pCell++) & 0x10) colIndex++;
    };
  };
//*******************************************************
//**
//** Update CellOffsets in levelDescriptors
//**
//*******************************************************
  m_pLevelDescriptors[level].CellOffset(
        m_pppdPointer10450[level][0] - m_cellFlagArray);
  for (i=level+1; i<numLevel; i++)
  {
    m_pLevelDescriptors[i].CellOffset(
       CellOffset(i) + numCellBytesInserted);
  };
  return VerifyLevelData();
}

//int CCSBuildDoc::IsHintable(void)
//{
//  //-1 means impossible
//  // 0 means not hintable
//  // 1 means hintable
//  if (m_block1.Word22594 != 1) return -1;
//  return m_block1.Word22592 == 13;
//}

//void CCSBuildDoc::IsHintable(bool hintable)
//{
//  //if (m_block1.Word22594 != 1) return;
//  if (hintable)
//  {
//    if (m_block1.Word22594 != 1) MODIFY
//    m_block1.Word22594 = 1;
//    if (m_block1.Word22592 != 13) MODIFY
//    m_block1.Word22592 = 13;
//  }
//  else
//  {
//    if (m_block1.Word22592 != 10) MODIFY
//    m_block1.Word22592 = 10;
//  };
//}

