#include "stdafx.h"
//#include "types.h"
#include "MainFrm.h"
#include "CSBuild.h"
#include "Actuator.h"

#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "EditText.h"
#include "WarningDialog.h"

void CCSBuildView::AddPortraitError(LOCATIONREL locr,
                                    CHKERRMSG *result,
                                    char *msg)
{
  if (result->FirstError() == NULL)
  {
    result->NewError(locr.Format() + msg);
  }
  else
  {
    result->NewError(CString("         ") + msg);
  };
}

void CCSBuildView::CheckOnePortrait(
               RN objPort, 
               CHKERRMSG *result, 
               LOCATIONREL locr,
               EditText *util) 
{
  LOCATIONREL textLocr;
  RN objText;
  int len;
  CString text;
  textLocr = locr;
  if (!textLocr.AdjacentCell(objPort.pos()))
  {
    result->NewError(locr.Format() + "Portrait has no text");
    return;
  };
  if (RoomType(textLocr) == roomSTONE)
  {
    result->NewError(locr.Format() + "Portrait faces wall");
    return;
  };
  objText = pDoc->FindFirstTextRecord(textLocr);
  if (objText == RNeof)
  {
    result->NewError(locr.Format() + "Portrait has no text");
    return;
  };
  text = pDoc->GetRawText(objText,TEXTTYPE_MIRROR);
  len = text.GetLength();
  if (len < 50)
  {
    result->NewError(locr.Format() + "Portrait text is too short");
    return;
  };
  text.Replace("\012","/");
  util->m_text = text;
  util->ExtractPortraitDataFromText();
  if (util->m_maxHP > MAXHP)
  {
    AddPortraitError(locr,result,"Portrait Max HP is too high");
  };
  if (util->m_maxStamina > MAXSTAMINA)
  {
    AddPortraitError(locr,result,"Portrait Max Stamina is too high");
  };
  if (util->m_maxMana > MAXMANA)
  {
    AddPortraitError(locr,result,"Portrait Max Mana is too high");
  };
  if (util->m_title.GetLength() > 19)
  {
    AddPortraitError(locr, result,"Portrait title > 19 characters");
  };
}

void CCSBuildView::OnCheckCharacterPortraits() 
{
	// TODO: Add your command handler code here
  CHKERRMSG result;
  EditText util;
  LOCATIONREL locr;
  DB3 *pDB3;
  ACTUATOR_Portrait *pPortrait;
  RN objAct;
  ACTUATORCLASS ac;
  int resp;
  bool activateable;
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    for (objAct = pDoc->FindFirstActuator(locr);
         objAct != RNeof;
         objAct = pDoc->FindNextActuator(objAct))
    {
      pDB3 = pDoc->GetRecordAddressDB3(objAct);
      ac = pDB3->actuatorClass(RoomType(locr));
      if (ac != AC_PORTRAIT) continue;
      pPortrait = pDB3->Cast2AC_Portrait(RoomType(locr));
      activateable = false;
      resp = pPortrait->SetResponses() & 3;
      if (resp == 1) activateable = true;
      if (resp == 3) activateable = true;
      resp = pPortrait->ClearResponses() & 3;
      if (resp == 1) activateable = true;
      if (resp == 3) activateable = true;
      resp = pPortrait->ToggleResponses() & 3;
      if (resp == 1) activateable = true;
      if (resp == 3) activateable = true;
      if (   (pPortrait->State() & 1) 
          && !activateable)  continue;
      CheckOnePortrait(objAct, &result, locr, &util);
    };
  };
  if (result.FirstError() != NULL)
  {
    WarningDialog Warning;
    Warning.m_title = "Character Portrait Errors";
    Warning.m_chkErrMsg = &result;
    Warning.DoModal();
  }
  else
  {
    pDoc->Information("No Character Portrait Errors");
  };

}
