// DSAHelp.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "DSAHelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char *helpText[] = {
  "Syntax:"
  "",
  "<integer> = Positive Decimal number",
  "",
  "<signed integer> = [+|-]<integer>",
  "",
  "<level>   default is current level",
  "    =  <integer>",
  "",
  "<position>   default is N",
  "    =  N | E | S | W",
  "",
  "<column>",
  "    =  S0 | C0 | T0 | S1 | etc...",
  "",
  "<position mask>",
  "    =  <integer>",
  "       1=N | 2=E | 4=S | 8=W",
  "",
  "<object type mask>",
  "    =  <integer>",
  "    Bits",
  "     DOOR      =  0",
  "     TELEPORTER=  1",
  "     TEXT      =  2",
  "     ACTUATOR  =  3",
  "     MONSTER   =  4",
  "     WEAPON    =  5",
  "     CLOTHING  =  6",
  "     SCROLL    =  7",
  "     POTION    =  8",
  "     CHEST     =  9",
  "     MISC      = 10",
  "     MISSILE   = 14",
  "     CLOUD     = 15",
  "",
  "<absolute location>   default is current cell",
  "    =  <level>(column,row)[<position>]",
  "         default position = 0",
  "",
  "<next state>    default is current state",
  "    =  integer",
  "           Note: The first command in a list determines the next state."
  "",
  "<delay>    default is 0",
  "    =  <integer>",
  "    =  X    means use first actuator parameter",
  "    =  Y    means use second actuator parameter",
  "",
  "<message type>     default is S",
  "    =  N    means do nothing",
  "    =  S    Set",
  "    =  C    Clear",
  "    =  T    Toggle",
  "",
  "<target>      default is A",
  "    =  A    means use first actuator parameter",
  "    =  B    means use second actuator parameter",
  "    =  *    means use <location> from stack",
  "            pos:2; level:6; x:5; y:5",
  "    =  <absolute location>",
  "",
  "<value>",
  "    =  <integer>",
  "    =  <absolute location>",
  "    =  A, B, C, D, etc. Parameters from this and following DSAs.",
  "",
  "<location> A relative (not including level offsets) location",
  "           in the dungeon encoded in an 18-bits integer.",
  "              pos[2], level[6], x[5], y[5]",
  "           Some operations allow <location> to specify the",
  "              cursor (-1) or a character's possessions.  Possessions",
  "              are specified by (characterOrdinal * 100) + backpackIndex.",
  "              Example: 101 is weapon hand of first character",
  "",
  "<from>    Same as <target>",
  "<to>      Same as <target>",
  "<case> = (<integer>,<state><column>)",
  "-----------------------------------------------",
  "OPERATION TYPES",
  "-----",
  "No operation",
  "    [<next state>]N",
  "         Change state but do Nothing else",
  "-----",
  "standard Message",
  "    [<next state>]M[<delay>]<message type>[<target>]",
  "-----",
  "Copy Teleporter",
  "    [<next state>]CT<from><to>",
  "-----",
  "Override",
  "    [<next state>]O<what>[<integer>]",
  "        <what> = P  override position on next command",
  "-----",
  "Gosub",
  "    [<next state>]G[<state>][<column>]",
  "-----",
  "Jump",
  "    [<next state>]J[<state>][<column>]",
  "-----",
  "Literal to Stack",
  "    [<next state>]L<value>",
  "    [<next state>]L$  ; <location> of current master cell",
  "-----",
  "Store Value from Stack",
  "    [<next state>]S<A|B|C|....>"
  "-----",
  "Fetch Variable to Stack",
  "    [<next state>]V<integer>@  ; ( ... value}",
  "-----",
  "Store Variable from Stack",
  "    [<next state>]V<integer>!  ; ( value ...}",
  "-----",
  "Fetch Global Variable to Stack",
  "    [<next state>]GV<integer>@  ; ( ... value}",
  "-----",
  "Store Global Variable from Stack",
  "    [<next state>]GV<integer>!  ; ( value ...}",
  "-----",
  "Fetch Object ID",
  "    F(<depth>,",
  "       <absolute location>,",
  "        <position mask>,",
  "         <object type mask> ... <objectID>)",
  "   Discussion:",
  "      If <position mask> == -1 then use position of <absolute location>."
  "      <depth> applies only to objects of the proper type at the"
  "              given positions.  Other objects are totally ignored"
  "-----",
  "IfElse",
  "    ?[<J|G>[<state>][<column>]][:<J|G>[<state>][<column>]]",
  "-----",
  "Case",
  "    ??{<case><case><case>........}  (n ... )",
  "          The top entry in stack is removed and compared",
  "          with each case value.  Control is transferred to",
  "          the appropriate place if there is a match.  Else",
  "          control continues to next command.",
  "",
  "------",
  "Stack Operation - '&' followed by operation name",
  "  &DROP  (x ... )",
  "  &2DROP (x y .. )",
  "  &PICK  (x y z 1 ... x y z y) ;Copy Nth item to top",
  "  &2PICK (x y z ... x y z x)   ; same as L2 &PICK",
  "  &POKE  (x y z 1 ... x z)     ;Store at Nth item",
  "  &ROLL  (x y z 2 ... y z x)   ;Move Nth Item to top",
  "  &-ROLL (x y z 2 ... z x y)   ;Reverse of ROLL",
  "  &ROT   (x y z ... y z x) ; same as L2 &ROLL",
  "  &-ROT  (x y z ... z x y) ; same as L2 &-ROLL",
  "  &!     (v i ... ) ; Store v at temporary variable[i]",
  "  &@     (i ... v)  ; Fetch v from temporary variable[i]",
  "                    ; for &@ and &! --   0 <= i <= 99",
  "  &+     (x y ... x+y)",
  "  &NEG   (x ... -x)",
  "  &AND   (x y ... x&y)",   
  "  &OR    (x y ... x|y)",
  "  &LAND  (x y ... x&&y)",
  "  &LOR   (x y ... x||y)",
  "  &=     (x y ... x==y)",
  "  &!=    (x y ... x!=y)",
  "  &NOT   (x ... !x) ; same as L0 &=",      
  "  &<     (x y ... x<y)",
  "  &U<    (x y ... x<y) ; unsigned",
  "  &SHIFT (x y ... x<<y) ; y signed",
  "  &RSHIFT(x y ... x>>y) ; y signed",
  "  &TYPE  (obj ... TypeOfObject) ;like apple or dagger",
  "  &DUP   (x ... x x)",
  "  &1-    (x ... x-1)",
  "  &1+    (x ... x+1)", 
  "  &SWAP  (x y ... y x)",
  "  &OVER  (x y ... x y x)  ;= L1 &PICK",
  "  &COMP  (x ... y) ; y is bitwise complement of x",
  "  &XOR   (x y ... x^y)",
  "  &2DUP  (x y ... x y x y)",
  "  &*     (x y ... x*y)",
  "  &%     (x y ... x%y)  ; -1 2 %/ = 1",
  "  &/     (x y ... x/y)  ; -1 2 %/ = -1",
  "  &RAND  (n ... r) ; 0 <= r < n",
  "  &BITCOUNT ( bits ... count );  Count the one bits in the binary integer 'bits'",
  "  &MISSILEINFO@ ( object ... contents range damage direction )",
  "  &MISSILEINFO! ( range damage direction object ... )",
  "  &LOC2ABSCOORD (<location> ... level x y pos)",
  "          ; Break down <location> into absolute coordinates.",
  "          ; This includes the level offsets.",
  "  &SETNEWSTATE (x .. )  ; Sets next state of machine",
  "  &FALSEPIT (target f ... ) ; Set pits at target to false if f non-zero",
  "                            ; else to real (non-false) if f is zero.",
  // "  &GENERATORDELAY (target delay ...) ;Set the delay of Monster Generator",
  "  &OVERLAY(p1 p2 p3 p4 overlay# ...) ;Select viewport overlay",
  "  &PALETTE(unused unused overlayNumber density . . . )",
  "  &DISABLESAVES(d ... ); Disable(d=1)/Enable(d=0) saves",
  "  &PARAM@ (n i ...); Fetch n parameters to temporary variable[i]",
  "  &PARAM! (n i ...); Store n parameters from temporary variable[i]",
  "  &MESSAGE(t mt np delay); Send Message with Parameters.",
  "                     t  = target <location> (must be wall cell)",
  "                     mt = Message Type (0=set, 1=Clear, 2=Toggle)",
  "                     np = number of parameters",
  "                     delay = time to deliver",
  "  &ECF@(<location> ... flags) ;Fetch Extended Cell Flags",
  "  &ECF!(flags <location> ...) ;Store Extended Cell Flags",
  "  &CHPOSS(<char num> <index> ...<objectID>)",
  "            <char num> = 0 to 3; <index = 0 to 29>",
  "            <char num> == 4 means 'Active Character'",
  "            <char num> == -1 means object in cursor",
  "  &MONPOSS ( monsterID index ... objectID ) ; Fetch Monster Possession",
  "  &SAY(<location> color ... ); Display the text from dungeon",
  "                             <location> in scrolled text area",
  "  &TEXT@ ( object index . . ); Fetch dungeon text to text array",
  "  &TEXTSAY ( index color ... ); Display textString[index] in scrolling area",
  "  &MASTERY (<char num> <skill num> flags ... <level of mastery>)",
  "            flags 01=don't include special item effects",
  "                  02=don't include temporary effects",
  "  &GETCURSE (obj ... flag); Get 'Cursed' flag",
  "  &SETCURSE (obj flag ...); Set 'Cursed' flag",
  "  &GETBROKEN (obj ... flag); Get 'Broken' flag",
  "  &SETBROKEN (obj flag ...); Set 'Broken' flag",
  "  &GETPOISONED (obj ... flag); Get 'Poisoned' flag",
  "  &SETPOISONED (obj flag ...); Set 'Poisoned' flag",
  "  &GETCHARGES (obj ... charges); Get number of charges",
  "  &SETCHARGES (obj charges ... ); Set number of charges",
  "  &CELL@ (location index num ...); Get info about dungeon location",
  "  &NEIGHBORS ( location criteriaMask ... result); Get information about neighboring cells",
  "  &GENERATORDELAY@ ( location ... delay ); return -1 if no generator at location",
  "  &GENERATORDELAY! ( delay location ... ); Set generator delay.  Ignore if no generator.",
  "  &Global@ (id ... value); Get global information",
  "                         ; id=1 - value is party <location>",
  "                         ; id=anything else - value is zero",
  "  &MULTIPLIER@ (dungeonLevel ... experienceMultiplier)",
  "  &PARTY@ (index num ... ) ; Get Party information",
  "  &CHAR@ ( char# index num ... ) ; Get info about a character",
  "  &EXPERIENCE+ (char# skill# experienceIncrement ... ); Increment must be positive",
  "  &COUNTINJURY ( charMask injuryMask ... num ) ; Count character(s) injuries",
  "  &MONSTER@ (id index num ...) ;Get info about monster",
  "  &THROW (type objectLocation launchLocation direction range damage delta ...)",
  "  &SOUND ( SoundNumber attenuation(divisor) flags ... )",
  "  &MONBLK ( directionMask ... ) ; Block monster movement",
  "                                ; Only works in Monster Movement Filter",
  "  &DESCRIBE ( location index color... ) ;Viewing Filter only.  Modify object description.",
  "  &SETADJUSTSKILLSPARAMETERS ( p0, p1, p2, p3, p4 ... )",
  "                         ; Sets runtime parameters for next 'AdjustSkills Filter' call.",
  "  &TIME@ ( ... time ) ; Fetches the 'Tick-Count' of the game (1/6 second units).",
  "  &J* ( message state ... ) Jump to state and message defined by stack",
  "  &G* ( message state ... ) GoSub to state and message defined by stack",
  " ------------------"
  "     ****Monster Moving Filter Only*****",
  "     &MonL&D ( <variable index> ...  ; Sets two variables: Monster Location and Distance",
  " ------------------",
  "The following stack oerations cannot be used in filters",
  " Each has an 'Indirect' form with a '%'. Example: '&%THROW'.",
  " The indirect form is consumated with '&%INDIRECT'.",
  " The indirect forms can use:",
  "  &%DELAY ( time . . . )",
  " which has the effect of delaying the next executed 'Indirect' Action.",
  "",
  "  &THROW (type objectLocation launchLocation direction range damage delta ...)",
  "  &CELL! (location index num ...); Set info about dungeon location",
  "  &COPY ( idSrc idDst ... ) ; Copy an object (eg: Change Actuator target.)",
  "  &DEL   (obj <location> ...) ;Delete from dungeon",
  "  &ADD   (posMsk <location> obj ...) ;Add item to dungeon",
  "  &MOVE  ( <source> <destination> ... ); Move item within game.",
  "             <source> and <destination> are identical. Each with 5 parameters.",
  "             ( locationType objMask positionMask location depth )", 
  "  &CAST(...) ; Cast spell using previously stored parameters",
  "  &MONSTER! (id index num ...) ;Set monster information",
  "  &DELMON (<location> index ... ) ; Delete single monster from group of more than one",
  "  &INSMON (<location> position ... ) ; Insert single monster into group",
  "  &CHAR! ( char# index num ... ) ; Set info about a character",
  "  &CAUSEPOISON ( poisonValue Char# ... )",
  "  &TELEPORTPARTY (<location> ... )",
  "  &CREATECLOUD(<location> type size ... )",
  "-----",
  "Note: Boolean results are represented by zero or one"
};

/////////////////////////////////////////////////////////////////////////////
// DSAHelp dialog


DSAHelp::DSAHelp(CWnd* pParent /*=NULL*/)
	: CDialog(DSAHelp::IDD, pParent)
{
	//{{AFX_DATA_INIT(DSAHelp)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void DSAHelp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DSAHelp)
	DDX_Control(pDX, IDC_HelpText, m_helpText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DSAHelp, CDialog)
	//{{AFX_MSG_MAP(DSAHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DSAHelp message handlers

BOOL DSAHelp::OnInitDialog() 
{
  int i;
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  //m_helpText.ResetContent();
  for (i=0; i<sizeof(helpText)/sizeof(helpText[0]); i++)
  {
    m_helpText.ReplaceSel(helpText[i]);
    m_helpText.ReplaceSel("\015\012");
  };
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
