// DatabaseEditor.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "DatabaseEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DatabaseEditor dialog


DatabaseEditor::DatabaseEditor(CWnd* pParent /*=NULL*/)
	: CDialog(DatabaseEditor::IDD, pParent)
{
	//{{AFX_DATA_INIT(DatabaseEditor)
	m_size = 0;
	m_hex = FALSE;
	m_d0 = _T("");
	m_d1 = _T("");
	m_d10 = _T("");
	m_d11 = _T("");
	m_d12 = _T("");
	m_d13 = _T("");
	m_d14 = _T("");
	m_d15 = _T("");
	m_d2 = _T("");
	m_d3 = _T("");
	m_d4 = _T("");
	m_d5 = _T("");
	m_d6 = _T("");
	m_d7 = _T("");
	m_d8 = _T("");
	m_d9 = _T("");
	m_explanation = _T("");
	//}}AFX_DATA_INIT
}


void DatabaseEditor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DatabaseEditor)
	DDX_Control(pDX, IDC_Key, m_key);
	DDX_Control(pDX, IDC_KeyTitle, m_keyTitle);
	DDX_Control(pDX, IDC_DatabaseType, m_databaseType);
	DDX_Text(pDX, IDC_Size, m_size);
	DDX_Check(pDX, IDC_Hex, m_hex);
	DDX_Text(pDX, IDC_D0, m_d0);
	DDX_Text(pDX, IDC_D1, m_d1);
	DDX_Text(pDX, IDC_D10, m_d10);
	DDX_Text(pDX, IDC_D11, m_d11);
	DDX_Text(pDX, IDC_D12, m_d12);
	DDX_Text(pDX, IDC_D13, m_d13);
	DDX_Text(pDX, IDC_D14, m_d14);
	DDX_Text(pDX, IDC_D15, m_d15);
	DDX_Text(pDX, IDC_D2, m_d2);
	DDX_Text(pDX, IDC_D3, m_d3);
	DDX_Text(pDX, IDC_D4, m_d4);
	DDX_Text(pDX, IDC_D5, m_d5);
	DDX_Text(pDX, IDC_D6, m_d6);
	DDX_Text(pDX, IDC_D7, m_d7);
	DDX_Text(pDX, IDC_D8, m_d8);
	DDX_Text(pDX, IDC_D9, m_d9);
	DDX_Text(pDX, IDC_Explanation, m_explanation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DatabaseEditor, CDialog)
	//{{AFX_MSG_MAP(DatabaseEditor)
	ON_BN_CLICKED(IDC_Read, OnRead)
	ON_CBN_SELCHANGE(IDC_DatabaseType, OnSelchangeDatabaseType)
	ON_BN_CLICKED(IDC_Write, OnWrite)
	ON_BN_CLICKED(IDC_Hex, OnHex)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DatabaseEditor message handlers

BOOL DatabaseEditor::OnInitDialog() 
{
  CWnd *pWnd;
	CDialog::OnInitDialog();
	pWnd = GetDlgItem(IDC_KeyTitle);
	// TODO: Add extra initialization here
	pWnd->SetWindowText("");
  m_d[0]  = &m_d0;
  m_d[1]  = &m_d1;
  m_d[2]  = &m_d2;
  m_d[3]  = &m_d3;
  m_d[4]  = &m_d4;
  m_d[5]  = &m_d5;
  m_d[6]  = &m_d6;
  m_d[7]  = &m_d7;
  m_d[8]  = &m_d8;
  m_d[9]  = &m_d9;
  m_d[10] = &m_d10;
  m_d[11] = &m_d11;
  m_d[12] = &m_d12;
  m_d[13] = &m_d13;
  m_d[14] = &m_d14;
  m_d[15] = &m_d15;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DatabaseEditor::OnRead() 
{
  int databaseType;
  ui32 *pData;
  int key;
  int i;
  int exSize;
	// TODO: Add your control notification handler code here
  UpdateData(true);
  databaseType = m_databaseType.GetCurSel();
  if (databaseType < 0) return;
	key = m_key.GetCurSel();
  exSize = expool.Locate((EDT_Database << 24) | (databaseType << 16) | key, &pData); 
  if (exSize == -1)
  {
    MessageBox("No such record","Search failed", MB_OK);
    return;
  };
  m_size = exSize;
  for (i=0; i<16; i++)
  {
    *m_d[i] = "";
  };
  for (i=0; i<exSize; i++)
  {
    if (m_hex)
    {
      m_d[i]->Format("0x%x", pData[i]);
    }
    else
      m_d[i]->Format("%d", pData[i]);
  };
  UpdateData(false);
}

void DatabaseEditor::OnSelchangeDatabaseType() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  m_key.ResetContent();
  switch (m_databaseType.GetCurSel())
  {
  case 0: // Object Weight
    m_key.AddString("Chest");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Object type");
    m_explanation = "One word entry giving integer weight";
    break;
  case 1: // Delete Duplicate Timer Entries
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_explanation = "One word entry: non-zero causes duplicate timer entries to be"
                    " discarded (the original code did this).  Zero causes all"
                    " timer messages to be delivered (more intuitive IMHO)";
    break;
  case 2: // Runtime File Signatures
    m_key.AddString("CSBGraphics.dat");
    m_key.AddString("Graphics.dat");
    m_key.AddString("CSBwin.exe");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Filename");
    m_explanation = "An integer specifying the digital signature of"
                    " the runtime file that is to be used with"
                    " this dungeon.  Setting value to zero (or debuging mode)"
                    " disables signature checking.";
    break;
  case 3: // Debuging mode
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_explanation = "Any non-zero value disables signature checking for"
                    " CSBGraphics.dat, Graphics.dat, and CSBwin.exe."; 
    break;
  case 4: //global variables
    m_key.AddString("0-15");
    m_key.AddString("16-31");
    m_key.AddString("32-47");
    m_key.AddString("48-63");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Global Variable numbers");
    m_explanation = "Global variables referenced in DSAs using the"
                    " &GVnnn@ and GVnnn! instruction words.";
    break;
  case 5: // Disable Saves
    m_key.AddString("Not Used");
    m_key.SetCurSel(0);
    m_keyTitle.SetWindowText("Not Used");
    m_explanation = "Any record will disable saves"; 
    break;
  default:
    return;
  };
  UpdateData(false);
}

void DatabaseEditor::OnWrite() 
{
	// TODO: Add your control notification handler code here
  int databaseType;
  ui32 data[16];
  int key;
  int count;
  int i, n;
  int size;
  CString text;
	// TODO: Add your control notification handler code here
  UpdateData(true);
  databaseType = m_databaseType.GetCurSel();
  if (databaseType < 0) return;
	key = m_key.GetCurSel();
  size = m_size;
  count = 0;
  for (i=0; i<16; i++)
  {
    if (i < size)
    {
      if (m_hex)
      {
        n = sscanf(*m_d[i],"%x",&data[i]);
      }
      else
      {
        n = sscanf(*m_d[i], "%d", &data[i]);
      };
      if (n != 1)
      {
        MessageBox ("Bad Numeric Data","error",MB_OK);
        return;
      };
    }
    else
    {
      if (*m_d[i] != "")
      {
        MessageBox("Too Much Data Supplied", "Error", MB_OK);
        return;
      };
    };
  };
  expool.Write(
        (EDT_Database << 24) | (databaseType << 16) | key,
        data,
        size);
  MODIFY
}

void DatabaseEditor::OnHex() 
{
  int i;
  int n;
  BOOL hex;
  int data;
	// TODO: Add your control notification handler code here
  hex = m_hex;
  UpdateData(true);
  for (i=0; i<16; i++)
  {
    if (*m_d[i] == "") continue;
    if (hex)
    {
      n = sscanf(*m_d[i],"%x",&data);
    }
    else
    {
      n = sscanf(*m_d[i], "%d", &data);
    };
    if (n != 1)
    {
      *m_d[i] = "";
    }
    else
    {
      if (m_hex)
      {
        m_d[i]->Format("0x%x", data);
      }
      else
      {
        m_d[i]->Format("%d", data);
      };
    };
  };
  UpdateData(false);
}
