// EditChest.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "ObjectListBox.h"
#include "EditChest.h"
#include "CSBuildDoc.h"
#include "dlg_InsertObject.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditChest dialog


EditChest::EditChest(LOCATIONREL locr,
                     CWnd* pParent /*=NULL*/)
	: CDialog(EditChest::IDD, pParent)
{
  m_locr = locr;
  m_levelInfo = locr;
	//{{AFX_DATA_INIT(EditChest)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void EditChest::DoDataExchange(CDataExchange* pDX)
{
  RN obj;
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditChest)
	//DDX_Control(pDX, IDC_ChestPossibles, m_chestPossibles);
	DDX_Control(pDX, IDC_ChestContents, m_chestContents);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    int index;
    index = m_chestContents.GetCurSel();
    m_chestContents.ResetContent();
    for (obj = m_pDB9->contents(); 
         obj != RNeof; 
         obj = pDoc->GetDBRecordLink(obj))
    {
      m_chestContents.AddObject(obj, roomOPEN);
      // There should be nothing in the chest that 
      // depends on the room type.
    };
    m_chestContents.SetCurSel(index);
  };
}


BEGIN_MESSAGE_MAP(EditChest, CDialog)
	//{{AFX_MSG_MAP(EditChest)
	ON_BN_CLICKED(IDC_AddToChest, OnAddToChest)
	ON_BN_CLICKED(IDC_DeleteFromChest, OnDeleteFromChest)
	ON_BN_CLICKED(IDC_Edit, OnEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditChest message handlers

void EditChest::OnAddToChest() 
{
	// TODO: Add your control notification handler code here
  RN obj, newobj;
  //DBTYPE dbType;
  int typeMask = 0;
  int count;
  count = 0;
  typeMask |= 1<<dbMISC;
  typeMask |= 1<<dbCLOTHING;
  typeMask |= 1<<dbSCROLL;
  typeMask |= 1<<dbCHEST;
  typeMask |= 1<<dbPOTION;
  typeMask |= 1<<dbWEAPON;
  dlg_InsertObject dlg(m_locr, typeMask, 0);
  for (obj = m_pDB9->contents();
       obj != RNeof;
       obj = pDoc->GetDBRecordLink(obj))
  {
    count++;
  };
  if (count >= 8)
  {
    pDoc->Sorry("You can only put eight\nitems in a chest");
    return;
  };
  if (dlg.DoModal() == IDCANCEL) return;
  newobj = dlg.m_insertObject;
/*
  dbType = dlg.m_dbType;
  switch (dbType)
  {
  case dbCLOTHING:
    {
      DB6 *pDB6;
      newobj = pDoc->FindEmptyDB6Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another piece of clothing");
        return;
      };
      pDB6 = pDoc->GetRecordAddressDB6(newobj);
      *pDB6 = dlg.m_ClothingRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  case dbMISC:
    {
      DB10 *pDB10;
      newobj = pDoc->FindEmptyDB10Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another miscellaneous item");
        return;
      };
      pDB10 = pDoc->GetRecordAddressDB10(newobj);
      *pDB10 = dlg.m_MiscRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  case dbSCROLL:
    {
      DB7 *pDB7;
      newobj = pDoc->FindEmptyDB7Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another scroll");
        return;
      };
      pDB7 = pDoc->GetRecordAddressDB7(newobj);
      *pDB7 = dlg.m_ScrollRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  case dbCHEST:
    {
      DB9 *pChest;
      newobj = pDoc->FindEmptyDB9Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another chest");
        return;
      };
      pChest = pDoc->GetRecordAddressDB9(newobj);
      *pChest = dlg.m_ChestRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  case dbPOTION:
    {
      DB8 *pPotion;
      newobj = pDoc->FindEmptyDB8Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another potion");
        return;
      };
      pPotion = pDoc->GetRecordAddressDB8(newobj);
      *pPotion = dlg.m_PotionRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  case dbWEAPON:
    {
      DB5 *pWeapon;
      newobj = pDoc->FindEmptyDB5Entry();
      if (newobj == RNnul)
      {
        pDoc->Sorry("No room for another weapon");
        return;
      };
      pWeapon = pDoc->GetRecordAddressDB5(newobj);
      *pWeapon = dlg.m_WeaponRecord;
      pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    };
    break;
  default:
    pDoc->Sorry("That type not implemented");
    return;
  };
  */
  if (newobj != RNnul)
  {
    pDoc->AddObjectToList(newobj,m_pDB9->pContents(),RNeof);
    UpdateData(false);
  };
}

void EditChest::OnDeleteFromChest() 
{
  RN object;
  int index, item;
	// TODO: Add your control notification handler code here
  UpdateData(true);
	index = m_chestContents.GetCurSel();
  if (index < 0)
  {
    pDoc->Sorry("You must make a selection");
    return;
  };
  item = m_chestContents.GetItemData(index);
  object.ConstructFromInteger(item);
  pDoc->DeleteObjectFromList(object, m_pDB9->pContents(), true);
  if (index > 0) index--;
  m_chestContents.SetCurSel(index);
  UpdateData(false);
}

BOOL EditChest::OnInitDialog() 
{
	CDialog::OnInitDialog();
  RN obj;
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void EditChest::OnEdit() 
{
	// TODO: Add your control notification handler code here
  RN obj;
  int index;
  int item;
  LOCATIONREL locr;
  UpdateData(true);
	// TODO: Add your control notification handler code here
	index = m_chestContents.GetCurSel();
  if (index < 0)
  {
    pDoc->Sorry("You must make a selection");
    return;
  };
  item = m_chestContents.GetItemData(index);
  obj.ConstructFromInteger(item);
  if (obj == RNeof) return;
  ObjectEditor(obj, m_locr);
  UpdateData(false);	
}
