// EditDSAList.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "EditDSAList.h"
#include "misc.h"
#include "SelectDSA.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditDSAList dialog


EditDSAList::EditDSAList(int level,
                         CWnd* pParent /*=NULL*/)
	: CDialog(EditDSAList::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditDSAList)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
  m_level = level;
}


void EditDSAList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditDSAList)
	DDX_Control(pDX, IDC_DSAList, m_DSAlist);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    DSA *pDSA;
    char line[100];
    int i;
    ui16 DSAindex;
    m_DSAlist.ResetContent();
    for (i=0; i<32; i++)
    {
      DSAindex = m_copyOfLevelList[i];
      if (   (DSAindex > 255)
           ||((pDSA = pDoc->getDSA(DSAindex)) == NULL))
      {
        sprintf(line,"%02d",i);
      }
      else
      {
        sprintf(line,"%02d - %03d %s",i, DSAindex, pDSA->Description());
      };
      m_DSAlist.AddString(line);
    };
  };
}


BEGIN_MESSAGE_MAP(EditDSAList, CDialog)
	//{{AFX_MSG_MAP(EditDSAList)
	ON_BN_CLICKED(IDC_Replace, OnReplace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditDSAList message handlers

void EditDSAList::OnReplace() 
{
  SelectDSA dlg(-1);
  int index;
	// TODO: Add your control notification handler code here
	index = m_DSAlist.GetCurSel();
  if (index < 0)
  {
    NoSelection();
    return;
  };
  if (dlg.DoModal() == IDOK)
  {
    m_copyOfLevelList[index] = (ui16)dlg.m_DSAindex;
    UpdateData(false);
  };
}

BOOL EditDSAList::OnInitDialog() 
{
  int i;
  CString windowTitle;
  for (i=0; i<32; i++)
  {//We will edit a copy of the list until user says 'OK'
    m_copyOfLevelList[i] = pDoc->getDSA(m_level, i);
  };
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  windowTitle.Format("Edit DSA List for Level %d",m_level);
  SetWindowText(windowTitle);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditDSAList::OnOK() 
{
  int i;
	// TODO: Add extra validation here
	for (i=0; i<32; i++)
  {
    pDoc->setDSA(m_level, i, m_copyOfLevelList[i]); 
  };
	CDialog::OnOK();
}
