// EditDoor.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditDoor.h"
#include "CSBuildDoc.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditDoor dialog


EditDoor::EditDoor(LOCATIONREL locr, CWnd* pParent /*=NULL*/)
	: CDialog(EditDoor::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditDoor)
	m_doorSwitch = FALSE;
	m_opensUp = FALSE;
	m_openWithAxe = FALSE;
	m_openWithFireball = FALSE;
	//}}AFX_DATA_INIT
  m_locr = locr;
}


void EditDoor::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
    m_openWithAxe = m_pDB0->canOpenWithAxe();
    m_openWithFireball = m_pDB0->canOpenWithFireball();
    m_opensUp = m_pDB0->mode();
    m_doorSwitch = m_pDB0->doorSwitch();
  };

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditDoor)
	DDX_Control(pDX, IDC_DoorDecoration, m_ornateTypes);
	DDX_Control(pDX, IDC_DoorType, m_doorType);
	DDX_Check(pDX, IDC_DoorSwitch, m_doorSwitch);
	DDX_Check(pDX, IDC_OpensUp, m_opensUp);
	DDX_Check(pDX, IDC_OpenWithAxe, m_openWithAxe);
	DDX_Check(pDX, IDC_OpenWithFireball, m_openWithFireball);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    int i, index;
    int doortype0, doortype1;
    CString doorName;
    ORNATETYPE ornateType;
    m_doorType.ResetContent();
    doortype0 = pDoc->DoorType(m_locr.l(),0);
    doorName = DoorTypeName(doortype0);
    m_doorType.AddString(doorName);
    doortype1 = pDoc->DoorType(m_locr.l(),1);
    doorName = DoorTypeName(doortype1);
    m_doorType.AddString(doorName);
    m_doorType.SetCurSel(m_pDB0->doorType());
    m_ornateTypes.AddString("none");
    m_ornateTypes.SetItemData(0,0);
    for (i=0; i<pDoc->NumDoorDecorations(m_locr.l()); i++)
    {
      ornateType = pDoc->DoorDecorationType(m_locr.l(),i);
      index = m_ornateTypes.AddString(ornateType.Name());
      m_ornateTypes.SetItemData(index, i+1);
    };
    m_ornateTypes.SetCurSel(m_pDB0->ornateness());
    m_doorType.SetCurSel(m_pDB0->doorType());
  };
  if (pDX->m_bSaveAndValidate)
  {
    m_pDB0->canOpenWithAxe(m_openWithAxe);
    m_pDB0->canOpenWithFireball(m_openWithFireball);
    m_pDB0->mode(m_opensUp);
    m_pDB0->doorSwitch(m_doorSwitch);
    m_pDB0->ornateness(m_ornateTypes.GetCurSel());
    m_pDB0->doorType(m_doorType.GetCurSel());
  };
}


BEGIN_MESSAGE_MAP(EditDoor, CDialog)
	//{{AFX_MSG_MAP(EditDoor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditDoor message handlers

BOOL EditDoor::OnInitDialog() 
{

	CDialog::OnInitDialog();


  //UpdateData(false);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


