// EditMonster.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "ObjectListBox.h"
#include "EditMonster.h"
#include "dlg_InsertObject.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditMonster dialog


EditMonster::EditMonster(LOCATIONREL locr,
                         RN RNmonster,
                         CWnd* pParent /*=NULL*/)
	: CDialog(EditMonster::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditMonster)
	m_facing = -1;
	m_numMonster = -1;
	m_hitPoints0 = 0;
	m_hitPoints1 = 0;
	m_hitPoints2 = 0;
	m_hitPoints3 = 0;
	m_position0 = 0;
	m_position1 = 0;
	m_position2 = 0;
	m_position3 = 0;
	m_infiniteHP0 = FALSE;
	m_infiniteHP1 = FALSE;
	m_infiniteHP2 = FALSE;
	m_infiniteHP3 = FALSE;
	m_invisible = FALSE;
	m_drawAsSize4 = FALSE;
	m_unique = FALSE;
	m_poisoned = FALSE;
	m_graphics = -1;
	//}}AFX_DATA_INIT
  m_locr = locr;
  m_RNmonster = RNmonster;
}

void EditMonster::ExtractDataFromRecord(void)
{
  m_monsterType = m_pMonster->monsterType();
  m_graphics    = m_pMonster->alternateGraphics();
  m_facing = m_pMonster->facing();
  m_numMonster = m_pMonster->numMonster()-1;
  m_invisible =  m_pMonster->Invisible();
  m_drawAsSize4 = m_pMonster->DrawAsSize4();
  m_unique      = m_pMonster->Unique();
  m_poisoned    = m_pMonster->Poisoned();
  m_hitPoints0 = m_pMonster->hitPoints(0);
  m_hitPoints1 = m_pMonster->hitPoints(1);
  m_hitPoints2 = m_pMonster->hitPoints(2);
  m_hitPoints3 = m_pMonster->hitPoints(3);
  m_infiniteHP0 = m_hitPoints0 == 65535;
  m_infiniteHP1 = m_hitPoints1 == 65535;
  m_infiniteHP2 = m_hitPoints2 == 65535;
  m_infiniteHP3 = m_hitPoints3 == 65535;
  m_position0   = (m_pMonster->positions() >> 0) & 3;
  m_position1   = (m_pMonster->positions() >> 2) & 3;
  m_position2   = (m_pMonster->positions() >> 4) & 3;
  m_position3   = (m_pMonster->positions() >> 6) & 3;
}

bool EditMonster::EncodeDataIntoRecord(void)
{
  m_pMonster->monsterType(m_monsterType);
  m_pMonster->alternateGraphics(m_graphics);
  m_pMonster->facing(m_facing);
  m_pMonster->Invisible(m_invisible != 0);
  m_pMonster->DrawAsSize4(m_drawAsSize4 != 0);
  m_pMonster->Unique(m_unique != 0);
  m_pMonster->Poisoned(m_poisoned != 0);
  m_pMonster->numMonster(m_numMonster+1);
  m_pMonster->hitPoints(0, m_hitPoints0);
  m_pMonster->hitPoints(1, m_hitPoints1);
  m_pMonster->hitPoints(2, m_hitPoints2);
  m_pMonster->hitPoints(3, m_hitPoints3);
  m_pMonster->groupIndex(
       (m_position3 << 6)
     | (m_position2 << 4)
     | (m_position1 << 2)
     | (m_position0 << 0)
    );
  //if (m_pMonster->numMonster() == 1) m_pMonster->groupIndex(255);
  //if (m_pMonster->numMonster() == 2) m_pMonster->groupIndex(13);
  return true;
}

void EditMonster::Show(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}

void EditMonster::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditMonster)
	DDX_Control(pDX, IDC_Possessions, m_possessionList);
	DDX_Control(pDX, IDC_MonsterList, m_monsterList);
	DDX_CBIndex(pDX, IDC_Facing, m_facing);
	DDX_CBIndex(pDX, IDC_NumberOfMonsters, m_numMonster);
	DDX_Text(pDX, IDC_HitPoints0, m_hitPoints0);
	DDV_MinMaxUInt(pDX, m_hitPoints0, 0, 65535);
	DDX_Text(pDX, IDC_HitPoints1, m_hitPoints1);
	DDV_MinMaxUInt(pDX, m_hitPoints1, 0, 65535);
	DDX_Text(pDX, IDC_HitPoints2, m_hitPoints2);
	DDV_MinMaxUInt(pDX, m_hitPoints2, 0, 65535);
	DDX_Text(pDX, IDC_HitPoints3, m_hitPoints3);
	DDV_MinMaxUInt(pDX, m_hitPoints3, 0, 65535);
	DDX_Text(pDX, IDC_Position0, m_position0);
	DDV_MinMaxUInt(pDX, m_position0, 0, 3);
	DDX_Text(pDX, IDC_Position1, m_position1);
	DDV_MinMaxUInt(pDX, m_position1, 0, 3);
	DDX_Text(pDX, IDC_Position2, m_position2);
	DDV_MinMaxUInt(pDX, m_position2, 0, 3);
	DDX_Text(pDX, IDC_Position3, m_position3);
	DDV_MinMaxUInt(pDX, m_position3, 0, 3);
	DDX_Check(pDX, IDC_InfiniteHP0, m_infiniteHP0);
	DDX_Check(pDX, IDC_InfiniteHP1, m_infiniteHP1);
	DDX_Check(pDX, IDC_InfiniteHP2, m_infiniteHP2);
	DDX_Check(pDX, IDC_InfiniteHP3, m_infiniteHP3);
	DDX_Check(pDX, IDC_Invisible, m_invisible);
	DDX_Check(pDX, IDC_DrawAsSize4, m_drawAsSize4);
	DDX_Check(pDX, IDC_Unique, m_unique);
	DDX_Check(pDX, IDC_Poisoned, m_poisoned);
	DDX_CBIndex(pDX, IDC_Graphics, m_graphics);
	//}}AFX_DATA_MAP
  if (pDX->m_bSaveAndValidate)
  {
    int index;
    index = m_monsterList.GetCurSel();
    m_monsterType = m_monsterList.GetItemData(index);
  };
  if (!pDX->m_bSaveAndValidate)
  {
    //int index;
    RN obj;
    m_possessionList.ResetContent();
    for (obj=m_pMonster->possession();  
         obj!=RNeof; 
         obj=pDoc->GetDBRecordLink(obj))
    {
      m_possessionList.AddObject(obj, RoomType(m_locr));
      //index = m_possessionList.AddString(obj.Name());
      //m_possessionList.SetItemData(index,obj.ConvertToInteger());
    };
    Show(IDC_HitPoints0, m_hitPoints0 != 65535);
    Show(IDC_HitPoints1, m_hitPoints1 != 65535);
    Show(IDC_HitPoints2, m_hitPoints2 != 65535);
    Show(IDC_HitPoints3, m_hitPoints3 != 65535);
  };
}


BEGIN_MESSAGE_MAP(EditMonster, CDialog)
	//{{AFX_MSG_MAP(EditMonster)
	ON_BN_CLICKED(IDC_New, OnNew)
	ON_BN_CLICKED(IDC_Delete, OnDelete)
	ON_BN_CLICKED(IDC_Edit, OnEdit)
	ON_BN_CLICKED(IDC_Pop, OnPop)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_InfiniteHP0, OnInfiniteHP0)
	ON_BN_CLICKED(IDC_InfiniteHP1, OnInfiniteHP1)
	ON_BN_CLICKED(IDC_InfiniteHP2, OnInfiniteHP2)
	ON_BN_CLICKED(IDC_InfiniteHP3, OnInfiniteHP3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditMonster message handlers
int DB4::Edit(LOCATIONREL locr, RN RNmonster)
{
  EditMonster dlg(locr, RNmonster);
  dlg.m_pMonster = this;
  return dlg.DoModal();
}


BOOL EditMonster::OnInitDialog() 
{
  int i;
  LOCATIONABS loca;
  CString title;
  loca = m_locr;
  ExtractDataFromRecord();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

  i = m_monsterType.FillComboBox(&m_monsterList, m_locr.l());
  m_monsterList.SetCurSel(i);
  title.Format("Monster [%04X] %02d(%02d,%02d)%d",
                  m_RNmonster.ConvertToInteger(),
                  loca.l,loca.x,loca.y,m_RNmonster.pos());
  SetWindowText(title);
  UpdateData(false);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditMonster::OnOK() 
{
	// TODO: Add extra validation here

  if (!UpdateData(true)) return;
	if (!EncodeDataIntoRecord()) return;
	
	CDialog::OnOK();
}

void EditMonster::AddObjectToPossessions(RN obj)
{
  pDoc->AddObjectToList(obj, m_pMonster->pPossession(), RNeof);
}

void EditMonster::OnNew() 
{
  int typeMask = 0;
  RN obj;
	// TODO: Add your control notification handler code here
  UpdateData(true);
  typeMask |= 1<<dbWEAPON;
  typeMask |= 1<<dbMISC;
  typeMask |= 1<<dbSCROLL;
  typeMask |= 1<<dbCHEST;
  typeMask |= 1<<dbPOTION;
  typeMask |= 1<<dbCLOTHING;
  typeMask |= 1<<dbMONSTER;
  typeMask |= 1<<dbTEXT;
  typeMask |= 1<<dbACTUATOR;
	dlg_InsertObject dlg(m_locr, typeMask);
  if (dlg.DoModal() == IDCANCEL) return;
  obj = dlg.m_insertObject;
  if (obj == RNnul) return;
  AddObjectToPossessions(obj);
  UpdateData(false);
}

void EditMonster::OnDelete() 
{
	// TODO: Add your control notification handler code here
	
  RN obj;
  int index, value;
  UpdateData(true);
  index = m_possessionList.GetCurSel();
  if (index == LB_ERR)
  {
    NoSelection();
    return;
  };
  value = m_possessionList.GetItemData(index);
  obj.ConstructFromInteger(value);
  if (obj == RNeof) return;
  if (obj == RNnul) return;
  pDoc->DeleteObjectFromList(obj, 
                             m_pMonster->pPossession(),
                             true);
  UpdateData(false);
}

void EditMonster::OnEdit() 
{
	// TODO: Add your control notification handler code here
  RN obj;
  int index, value;
  UpdateData(true);
  index = m_possessionList.GetCurSel();
  if (index == LB_ERR)
  {
    NoSelection();
    return;
  };
  value = m_possessionList.GetItemData(index);
  obj.ConstructFromInteger(value);
  if (obj == RNeof) return;
  ObjectEditor(obj, m_locr);
  UpdateData(false);
}

void EditMonster::OnPop() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  m_possessionList.Pop(m_pMonster->pPossession());
  UpdateData(false);
}

BOOL EditMonster::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_Pop: id = IDH_EditMonster_Pop; break;
  case IDC_Graphics: id = IDH_EditMonster_Graphics; break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;
}

void EditMonster::OnInfiniteHP0() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  if (m_infiniteHP0)
  {
    m_hitPoints0 = 65535;
  }
  else
  {
    m_hitPoints0 = 1;
  };
  UpdateData(false);
}

void EditMonster::OnInfiniteHP1() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  if (m_infiniteHP1)
  {
    m_hitPoints1 = 65535;
  }
  else
  {
    m_hitPoints1 = 1;
  };
  UpdateData(false);
	
}

void EditMonster::OnInfiniteHP2() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  if (m_infiniteHP2)
  {
    m_hitPoints2 = 65535;
  }
  else
  {
    m_hitPoints2 = 1;
  };
  UpdateData(false);
	
}

void EditMonster::OnInfiniteHP3() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  if (m_infiniteHP3)
  {
    m_hitPoints3 = 65535;
  }
  else
  {
    m_hitPoints3 = 1;
  };
  UpdateData(false);
	
}
