// EditPotion.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "EditPotion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditPotion dialog


EditPotion::EditPotion(LOCATIONREL locr,
                       RN RNpotion,
                       CWnd* pParent /*=NULL*/)
	: CDialog(EditPotion::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditPotion)
	m_important = FALSE;
	m_strength = 0;
	//}}AFX_DATA_INIT
  m_RNpotion = RNpotion;
  m_locr = locr;
}

int DB8::Edit(LOCATIONREL locr, RN RNmisc)
{
  EditPotion dlg(locr, RNmisc);
  dlg.m_pPotion = this;
  return dlg.DoModal();
}

void EditPotion::ExtractDataFromRecord(void)
{
  m_strength  = m_pPotion->strength();
  m_important = m_pPotion->important();
  m_type      = m_pPotion->potionType();
}

void EditPotion::EncodeDataIntoRecord(void)
{
  m_pPotion->strength(m_strength);
  m_pPotion->important(m_important?true:false);
  m_pPotion->potionType(m_type);
}

void EditPotion::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditPotion)
	DDX_Control(pDX, IDC_PotionType, m_potionType);
	DDX_Check(pDX, IDC_Important, m_important);
	DDX_Text(pDX, IDC_Strength, m_strength);
	DDV_MinMaxUInt(pDX, m_strength, 0, 255);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    m_potionType.SetCurSel(m_potionIndex);
  };
  if (pDX->m_bSaveAndValidate)
  {
    m_potionIndex = m_potionType.GetCurSel();
    m_type = m_potionType.GetItemData(m_potionIndex);
  };
}


BEGIN_MESSAGE_MAP(EditPotion, CDialog)
	//{{AFX_MSG_MAP(EditPotion)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditPotion message handlers

void EditPotion::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);
  EncodeDataIntoRecord();
	CDialog::OnOK();
}

BOOL EditPotion::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	ExtractDataFromRecord();
  m_potionIndex = m_type.FillComboBox(&m_potionType);

  UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
