// EditRoomStone.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
//#include "types.h"
#include "CSBuildDoc.h"
#include "CSBuildView.h"
#include "ObjectListBox.h"
#include "Misc.h"
#include "EditRoomStone.h"
#include "Actuator.h"
#include "dlg_InsertObject.h"
#include "EditText.h"
#include "clones.h"
#include "ShowLocations.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditRoomStone dialog
void CCSBuildView::EditRoomSTONE(int col, int row)
{
  CELL_CHECKPOINT *pCC1, *pCC2;
  LEVELINFO levelInfo; 
  levelInfo.left = pDoc->OffsetX(pDoc->m_currentDisplayLevel);
  levelInfo.top = pDoc->OffsetY(pDoc->m_currentDisplayLevel);
  levelInfo.right = levelInfo.left
           + pDoc->LastColumn(pDoc->m_currentDisplayLevel);
  levelInfo.bottom = levelInfo.top
           + pDoc->LastRow(pDoc->m_currentDisplayLevel);
  levelInfo.level = pDoc->m_currentDisplayLevel;
  EditRoomStone dlg(levelInfo);
  dlg.m_locr.l(pDoc->m_currentDisplayLevel);
  dlg.m_locr.x(col);
  dlg.m_locr.y(row);
  dlg.m_locr.p(0);
  pCC1 = pDoc->CheckpointCell(dlg.m_locr);
  if (dlg.DoModal() == IDOK) Invalidate();
  dlg.m_locr.p(0);
  pCC2 = pDoc->CheckpointCell(dlg.m_locr);
  if (*pCC1 == *pCC2)
  {
    delete pCC1;
  }
  else
  {
    pDoc->WriteCellUndo(pCC1);
  };
  delete pCC2;
}

EditRoomStone::EditRoomStone(LEVELINFO levelInfo, CWnd* pParent /*=NULL*/)
	: CDialog(EditRoomStone::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditRoomStone)
	m_randomEast = FALSE;
	m_randomNorth = FALSE;
	m_randomSouth = FALSE;
	m_randomWest = FALSE;
	m_nonBlockingTrickWall = FALSE;
	m_invisibleTrickWall = FALSE;
	//}}AFX_DATA_INIT
  {
    m_levelInfo = levelInfo;
    m_lists[0] = &m_ES_0_List;
    m_lists[1] = &m_ES_1_List;
    m_lists[2] = &m_ES_2_List;
    m_lists[3] = &m_ES_3_List;
  };
}

void EditRoomStone::ExtractDataFromRecord(void)
{
  CELLFLAG cf;
  cf = pDoc->GetCellFlag(m_locr);
  if (m_rt == roomFALSEWALL)
  {
    m_invisibleTrickWall = (cf & 0x04) != 0;
    m_nonBlockingTrickWall = (cf & 0x01) != 0;
  }
  else
  {
    m_randomNorth = (cf & 8) != 0;
    m_randomEast  = (cf & 4) != 0;
    m_randomSouth = (cf & 2) != 0;
    m_randomWest  = (cf & 1) != 0;
  };
}

void EditRoomStone::EncodeDataIntoRecord(void)
{
  CELLFLAG cf;
  cf = pDoc->GetCellFlag(m_locr);
  if (m_rt == roomFALSEWALL)
  {
    if (m_invisibleTrickWall) cf |= 0x04;
    else cf &= ~0x04;
    if (m_nonBlockingTrickWall) cf |= 0x01;
    else cf &= ~0x01;
  }
  else
  {
    cf &= 0xf0;
    if (m_randomNorth) cf |= 8;
    if (m_randomEast)  cf |= 4;
    if (m_randomSouth) cf |= 2;
    if (m_randomWest)  cf |= 1;
  };
  pDoc->SetCellFlag(m_locr, cf);
}

void EditRoomStone::Show(int id, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}

void EditRoomStone::DoDataExchange(CDataExchange* pDX)
{
  RN obj;
  int i, pos;
  int index, depth;
  RN rn;
  CString name;
  DBTYPE dbType;
  if (!pDX->m_bSaveAndValidate)
  {
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditRoomStone)
	DDX_Control(pDX, IDC_TargetOf, m_targetOf);
	DDX_Control(pDX, IDC_ES_3_List, m_ES_3_List);
	DDX_Control(pDX, IDC_ES_2_List, m_ES_2_List);
	DDX_Control(pDX, IDC_ES_1_List, m_ES_1_List);
	DDX_Control(pDX, IDC_ES_0_List, m_ES_0_List);
	DDX_Check(pDX, IDC_RandomEast, m_randomEast);
	DDX_Check(pDX, IDC_RandomNorth, m_randomNorth);
	DDX_Check(pDX, IDC_RandomSouth, m_randomSouth);
	DDX_Check(pDX, IDC_RandomWest, m_randomWest);
	DDX_Check(pDX, IDC_NonBlocking, m_nonBlockingTrickWall);
	DDX_Check(pDX, IDC_Invisible, m_invisibleTrickWall);
	//}}AFX_DATA_MAP

  if (!pDX->m_bSaveAndValidate)
  {
    Show(IDC_RandomNorth,      m_rt == roomSTONE);
    Show(IDC_RandomEast,       m_rt == roomSTONE);
    Show(IDC_RandomSouth,      m_rt == roomSTONE);
    Show(IDC_RandomWest,       m_rt == roomSTONE);
    Show(IDC_RandomDecoration, m_rt == roomSTONE);
    Show(IDC_Invisible,        m_rt == roomFALSEWALL);
    Show(IDC_NonBlocking,      m_rt == roomFALSEWALL);
    m_interestingObjectPos = -1;
    for (i=0; i<4; i++) 
    {
      m_saveSel[i] = m_lists[i]->GetCurSel();
      m_lists[i]->ResetContent();
    };
    for (depth=1, obj = pDoc->FindFirstObject(m_locr);
        obj != RNeof;
        depth++, obj = pDoc->GetDBRecordLink(obj))
    {
      dbType = obj.dbType();
      pos = obj.pos();
      switch (dbType)
      {
      case dbDOOR:
        Strange("There is a door in that wall");
        break;
      case dbTELEPORTER: 
        Strange("There is a teleporter in that wall");
        break;
      case dbTEXT:
        index = m_lists[pos]->AddString("Text");
        m_lists[pos]->SetItemData(index,obj.ConvertToInteger());
        break;
      case dbACTUATOR:
        m_lists[pos]->AddActuator(obj,roomSTONE, depth);
        break;
      case dbMONSTER:
        Strange("There is a monster in that wall");
        break;
      case dbWEAPON:
        m_lists[obj.pos()]->AddWeapon(obj, depth);
        break;
      case dbCLOTHING:
        m_lists[obj.pos()]->AddClothing(obj, depth);
        break;
      case dbSCROLL:
        m_lists[obj.pos()]->AddScroll(obj, depth);
        break;
      case dbPOTION:
        m_lists[obj.pos()]->AddPotion(obj, depth);
        break;
      case dbCHEST:
        m_lists[obj.pos()]->AddChest(obj, depth);
        break;
      case dbMISC:
        m_lists[obj.pos()]->AddMisc(obj, depth);
        break;
      };
      if (   (pos >= 0)
          && m_interestingObject.IsDBIndexOK()
          && obj.IsSameObjectAs(m_interestingObject))
      {
        m_interestingObjectPos = pos;
        m_interestingObjectIndex = m_lists[pos]->GetCount()-1;
      };
    };
    for (i=0; i<4; i++)
    {
      m_lists[i]->SetCurSel(m_saveSel[i]);
      if (   (m_lists[i]->GetCurSel() < 0)
           &&(m_lists[i]->GetCount() != 0))
      {
        m_lists[i]->SetCurSel(0);
      };
    };
    FillTargetListBox(&m_targetOf,m_locr,&m_triggerList);
    m_targetOf.SetCurSel(0);
  };
}

BEGIN_MESSAGE_MAP(EditRoomStone, CDialog)
	//{{AFX_MSG_MAP(EditRoomStone)
	ON_BN_CLICKED(IDC_ES_0_Edit, OnES0Edit)
	ON_BN_CLICKED(IDC_ES_1_Edit, OnES1Edit)
	ON_BN_CLICKED(IDC_ES_2_Edit, OnES2Edit)
	ON_BN_CLICKED(IDC_ES_3_Edit, OnES3Edit)
	ON_BN_CLICKED(IDC_ES_0_Delete, OnES0Delete)
	ON_BN_CLICKED(IDC_ES_1_Delete, OnES1Delete)
	ON_BN_CLICKED(IDC_ES_2_Delete, OnES2Delete)
	ON_BN_CLICKED(IDC_ES_3_Delete, OnES3Delete)
	ON_BN_CLICKED(IDC_ES_0_New, OnES0New)
	ON_BN_CLICKED(IDC_ES_1_New, OnES1New)
	ON_BN_CLICKED(IDC_ES_2_New, OnES2New)
	ON_BN_CLICKED(IDC_ES_3_New, OnES3New)
	ON_BN_CLICKED(IDC_ES_0_Pop, OnES0Pop)
	ON_BN_CLICKED(IDC_ES_1_Pop, OnES1Pop)
	ON_BN_CLICKED(IDC_ES_2_Pop, OnES2Pop)
	ON_BN_CLICKED(IDC_ES_3_Pop, OnES3Pop)
	ON_LBN_DBLCLK(IDC_ES_3_List, OnDblclkES3List)
	ON_LBN_DBLCLK(IDC_ES_2_List, OnDblclkES2List)
	ON_LBN_DBLCLK(IDC_ES_1_List, OnDblclkES1List)
	ON_LBN_DBLCLK(IDC_ES_0_List, OnDblclkES0List)
	ON_WM_HELPINFO()
	ON_COMMAND(IDC_MoveCCW, OnMoveCCW)
	ON_COMMAND(IDC_MoveAcross, OnMoveAcross)
	ON_COMMAND(IDC_MoveCW, OnMoveCW)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IDM_PeekAtSource, OnPeekAtSource)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditRoomStone message handlers

RN EditRoomStone::DetermineSelectedObject(int pos)
{
  int index, value;
  RN obj;
  index = m_lists[pos]->GetCurSel();
  if (index == LB_ERR)
  {
    NoSelection();
    return RNeof;
  };
  value = m_lists[pos]->GetItemData(index);
  obj.ConstructFromInteger(value);
  return obj;
}

void EditRoomStone::ESEdit(int position)
{
  RN obj;
  //DBTYPE dbType;
  //int result;
  UpdateData(true);
  obj = DetermineSelectedObject(position);
  if (obj == RNeof) return;
  m_locr.p(position);
  ObjectEditor(obj, m_locr);
}

void EditRoomStone::OnES0Edit() 
{
	// TODO: Add your control notification handler code here
  ESEdit(0);	
}

void EditRoomStone::OnES1Edit() 
{
	// TODO: Add your control notification handler code here
	ESEdit(1);
}

void EditRoomStone::OnES2Edit() 
{
	// TODO: Add your control notification handler code here
	ESEdit(2);
}

void EditRoomStone::OnES3Edit() 
{
	// TODO: Add your control notification handler code here
	ESEdit(3);
}

void EditRoomStone::DeleteItem(int pos)
{
  RN obj;
  CLONES clones(this);
  obj = DetermineSelectedObject(pos);
  if (obj == RNeof) return;
  if (obj == RNnul) return;
  clones.Clear();
  clones.MarkDungeonObjects();
  if (clones.IsObjectCloned(obj.dbType(),obj.dbIndex()))
  {
    pDoc->Sorry("That object is cloned, or is contained\n"
                "in a cloned object, or follows a cloned\n"
                "object in a list of objects.  Fix the cloning.");
  }
  else
  {
    pDoc->RemoveObjectFromRoom(m_locr, obj, true, true);
  };
  UpdateData(false);
}

void EditRoomStone::OnES0Delete() 
{
	// TODO: Add your control notification handler code here
  DeleteItem(0);	
}

void EditRoomStone::OnES1Delete() 
{
	// TODO: Add your control notification handler code here
  DeleteItem(1);	
}

void EditRoomStone::OnES2Delete() 
{
	// TODO: Add your control notification handler code here
  DeleteItem(2);	
}

void EditRoomStone::OnES3Delete() 
{
	// TODO: Add your control notification handler code here
  DeleteItem(3);	
}

void EditRoomStone::InsertObject(int position)
{
  int result;
  int typeMask = 0;
  RN newObj;
  //DB3 *pActuator;
  UpdateData(true);
  typeMask |= 1<<dbMISC;
  typeMask |= 1<<dbACTUATOR;
  typeMask |= 1<<dbWEAPON;
  typeMask |= 1<<dbTEXT;
  typeMask |= 1<<dbCLOTHING;
  typeMask |= 1<<dbPOTION;
  typeMask |= 1<<dbCHEST;
  typeMask |= 1<<dbSCROLL;
  dlg_InsertObject dlg(m_locr, typeMask);
  result = dlg.DoModal();
  if (result == IDCANCEL) return;
  newObj = dlg.m_insertObject;
  m_locr.p(position);
  pDoc->AddObjectToRoom(newObj, m_locr);
  m_interestingObject = newObj;
  UpdateData(false);
  if (m_interestingObjectPos != -1)
  {
    m_lists[m_interestingObjectPos]->SetCurSel(m_interestingObjectIndex);
    ESEdit(m_interestingObjectPos);
  };
}

void EditRoomStone::OnES0New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(0);	
}

void EditRoomStone::OnES1New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(1);	
}

void EditRoomStone::OnES2New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(2);	
}

void EditRoomStone::OnES3New() 
{
	// TODO: Add your control notification handler code here
  InsertObject(3);	
}

int EditRoomStone::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
  m_rt = RoomType(m_locr);
	ExtractDataFromRecord();
	return CDialog::DoModal();
}

void EditRoomStone::OnOK() 
{
	// TODO: Add extra validation here
  UpdateData(true);
  EncodeDataIntoRecord();	
	CDialog::OnOK();
}


static int tips[] =
{
  IDC_ES_0_List            , IDT_EditRoomStone_List,
  IDC_ES_1_List            , IDT_EditRoomStone_List,
  IDC_ES_2_List            , IDT_EditRoomStone_List,
  IDC_ES_3_List            , IDT_EditRoomStone_List,
  IDC_TargetOf             , IDT_EditRoomStone_List
};

BOOL EditRoomStone::OnInitDialog() 
{
  CString hdg;
  CString walltype;
  LOCATIONABS loca;

  CWnd *pWnd;
  m_toolTips.Create(this, 0);
  for (int i=0; i<sizeof(tips)/sizeof(int); i+=2)
  {
    pWnd = GetDlgItem(tips[i]);
    if (pWnd == NULL) continue;
    m_toolTips.AddTool(pWnd,tips[i+1]);
  };

  
  CDialog::OnInitDialog();
	// TODO: Add extra initialization here
  loca = m_locr;
  walltype = "Solid Wall";
  if (m_rt == roomFALSEWALL) walltype = "Trick Wall";
  hdg.Format("Edit %s at %d(%02d,%02d)",
              walltype,
              loca.l, loca.x, loca.y);
	SetWindowText(hdg);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditRoomStone::Pop(int position)
{
  RN obj;
  LOCATIONREL locr;
  UpdateData(true);
  locr = m_locr;
  obj = DetermineSelectedObject(position);
  if (obj == RNeof) return;
  pDoc->RemoveObjectFromRoom(m_locr, obj, false, true);
  locr.p(position);
  pDoc->AddObjectToRoom(obj, locr);
  UpdateData(false);
}


void EditRoomStone::OnES0Pop() 
{
	// TODO: Add your control notification handler code here
  Pop(0);	
}

void EditRoomStone::OnES1Pop() 
{
	// TODO: Add your control notification handler code here
	Pop(1);
}

void EditRoomStone::OnES2Pop() 
{
	// TODO: Add your control notification handler code here
	Pop(2);
}

void EditRoomStone::OnES3Pop() 
{
	// TODO: Add your control notification handler code here
	Pop(3);
}

void EditRoomStone::OnDblclkES3List() 
{
	// TODO: Add your control notification handler code here
	
	  OnES3Edit(); 	
}

void EditRoomStone::OnDblclkES2List() 
{
	// TODO: Add your control notification handler code here
	
	  OnES2Edit(); 	
}

void EditRoomStone::OnDblclkES1List() 
{
	// TODO: Add your control notification handler code here
	
	  OnES1Edit(); 	
}

void EditRoomStone::OnDblclkES0List() 
{
	// TODO: Add your control notification handler code here
	  OnES0Edit(); 	

}

BOOL EditRoomStone::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	CString s;
  int id;
  switch (pHelpInfo->iCtrlId)
  {
  case IDC_NonBlocking: id = IDH_EditRoomStone_NonBlocking; break;
  default: id = IDH_Context_None;
  };
	s.LoadString(id);
  HelpMsg(s);
  return true;

}

void EditRoomStone::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
  int index;
	if      (GetDlgItem(IDC_ES_0_List) == pWnd) index = 0;
  else if (GetDlgItem(IDC_ES_1_List) == pWnd) index = 1;
  else if (GetDlgItem(IDC_ES_2_List) == pWnd) index = 2;
  else if (GetDlgItem(IDC_ES_3_List) == pWnd) index = 3;
  else if (GetDlgItem(IDC_TargetOf) == pWnd)  index = 4;
  else index = -1;
  if ( (index >= 0) && (index < 4) )
  {
    CMenu menu;
    m_activeMoveWindow = index;
    if (menu.LoadMenu(IDR_RoomOpenCorners))      
    {
      CMenu* pPopup = menu.GetSubMenu(0);
      CObjectListBox *pBox;
      pBox = m_lists[index];
      if (pBox->GetCurSel() >= 0)
      {
        ASSERT(pPopup != NULL);
        pPopup->TrackPopupMenu(TPM_CENTERALIGN | TPM_RIGHTBUTTON,
                               point.x, point.y,
                               this);
      };
    };
  }
  else if (index == 4)
  {
    CMenu menu;
    m_activeMoveWindow = index;
    if (menu.LoadMenu(IDR_Triggers))
    {
      CMenu *pPopup = menu.GetSubMenu(0);
      CObjectListBox *pBox;
      pBox = &m_targetOf;
      if (pBox->GetCurSel() >= 0)
      {
        ASSERT(pPopup != NULL);
        pPopup->TrackPopupMenu(TPM_CENTERALIGN | TPM_RIGHTBUTTON,
                               point.x, point.y,
                               this);
      };
    };
  };
}

void EditRoomStone::MoveCW(int distance)
{
  CObjectListBox *pBox;
  int index, value, oldpos;
  RN obj;
  UpdateData(true);
  pBox = m_lists[m_activeMoveWindow];
  index = pBox->GetCurSel();
  if (index < 0) return; //should not happen
  value = pBox->GetItemData(index);
  obj.ConstructFromInteger(value);
  oldpos = obj.pos();
  obj.pos((oldpos + distance) & 3);
  UpdateData(false);
}

void EditRoomStone::OnPeekAtSource() 
{
	// TODO: Add your command handler code here
  ShowLocations dlg(&m_triggerList);
  UpdateData(true);
  dlg.DoModal();
}


void EditRoomStone::OnMoveCW() 
{
	// TODO: Add your command handler code here
	MoveCW(1);
}


void EditRoomStone::OnMoveCCW() 
{
	// TODO: Add your command handler code here
	MoveCW(3);
}

void EditRoomStone::OnMoveAcross() 
{
	// TODO: Add your command handler code here
	MoveCW(2);
}


BOOL EditRoomStone::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_toolTips.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}


