// EditScroll.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "EditScroll.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditScroll dialog


EditScroll::EditScroll(LEVELINFO levelInfo,
                       CWnd* pParent /*=NULL*/)
	: CDialog(EditScroll::IDD, pParent)
{
  m_levelInfo = levelInfo;
	//{{AFX_DATA_INIT(EditScroll)
	m_text = _T("");
	//}}AFX_DATA_INIT
}

void EditScroll::ExtractDataFromRecord(void)
{
  RN objText;
  int i, len;
  char ch;
  objText = m_pScroll->text();
  CString temp;
  if (objText.dbType() != dbTEXT)
  {
    m_text = "Scroll has illegal text";
  }
  else
  {
    temp = pDoc->GetRawText(objText, TEXTTYPE_SCROLL);
    m_text = DecodeText(temp, TEXTTYPE_SCROLL);
    m_text = "";
    len = temp.GetLength();
    for (i=0; i<len; i++)
    {
      ch = temp.GetAt(i);
      if (ch == 10) ch = '/';
      m_text += ch;
    };
    //m_explanation = CString("use '/' for possible line-break");
    //m_showText = pDoc->GetRecordAddressDB2(m_object)->show();
  };
}

void EditScroll::DoDataExchange(CDataExchange* pDX)
{
  if (!pDX->m_bSaveAndValidate)
  {
  };
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditScroll)
	DDX_Text(pDX, IDC_Text, m_text);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
  };
}


BEGIN_MESSAGE_MAP(EditScroll, CDialog)
	//{{AFX_MSG_MAP(EditScroll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditScroll message handlers

BOOL EditScroll::OnInitDialog() 
{
  ExtractDataFromRecord();
  m_originalText = m_text;
	CDialog::OnInitDialog();
  SetWindowText(m_title);	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditScroll::OnOK() 
{
  int len, i;
  char ch;
  int maxLineLen, numline, linelen;
  CString temp;
	// TODO: Add extra validation here
  UpdateData(true);
  if (m_text != m_originalText)
  {
    maxLineLen = 0;
    numline = 1;
    linelen = 0;
    len = m_text.GetLength();
    temp = "";
    for (i=0; i<len; i++)
    {
      ch = m_text.GetAt(i);
      if (ch == '/')
      {
        temp += (char)0x0a;
        if (linelen > maxLineLen) maxLineLen = linelen;
        linelen = 0;
        numline++;
      }
      else 
      {
        temp += ch;
        linelen++;
      };
    };
    if (linelen > maxLineLen) maxLineLen = linelen;
    if (maxLineLen > 16)
    {
      pDoc->Sorry("Line is too long");
    };
    if (numline > 9)
    {
      pDoc->Sorry("Too many lines");
    };
    if (m_pScroll->text().dbType() == dbTEXT)
    {
      pDoc->SetText(m_pScroll->text(), temp, TEXTTYPE_SCROLL);
    };
  };
	CDialog::OnOK();
}
