// EditText.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "EditText.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int savedEditLuck = 0;

/////////////////////////////////////////////////////////////////////////////
// EditText dialog


EditText::EditText(CWnd* pParent /*=NULL*/)
	: CDialog(EditText::IDD, pParent)
{
	//{{AFX_DATA_INIT(EditText)
	m_text = _T("");
	m_explanation = _T("");
	m_showText = FALSE;
	m_name = _T("");
	m_title = _T("");
	m_maxHP = 0;
	m_maxMana = 0;
	m_maxStamina = 0;
	m_male = -1;
	m_editLuck = 0;
	m_basicAttribute = 0;
	m_attributePenalty = -1;
	m_basicStatPenalty = -1;
	m_randomPoints = -1;
	//}}AFX_DATA_INIT
}

void EditText::SetWindowSize(void)
{
  RECT rect;
  GetWindowRect(&rect);
  if (m_editingPortrait)
  {
//    MoveWindow(rect.left,rect.top,530,390);
  }
  else
  { 
//    MoveWindow(rect.left,rect.top,250,360);
  };
  
}

int EditText::Extract4(int *col)
{
  int i, result = 0;
  for (i=0; i<4; i++)
  {
    if (*col == m_text.GetLength()) break;
    result <<= 4;
    result += m_text.GetAt(*col) - 'A';
    (*col)++;
  };
  return result;
}

int EditText::Extract2(int *col)
{
  int i, result = 0;
  for (i=0; i<2; i++)
  {
    if (*col == m_text.GetLength()) break;
    result <<= 4;
    result += m_text.GetAt(*col) - 'A';
    (*col)++;
  };
  return result;
}

int EditText::Extract1(int *col)
{
  if (*col == m_text.GetLength()) return 0;
  return m_text.GetAt((*col)++) - 'A';
}

void EditText::ExtractPortraitDataFromText(void)
{
  int i, j, col, numslash;
  char c;
  m_name = "";
  m_title = "";
  m_male = 0;
  m_editLuck = savedEditLuck;
  for (j=0; j<=6; j++)
  {
    for (i=0; i<=4; i++)
    {
      m_attribute[j][i] = 0;
    };
  };
  col = 0;
  for (;;)
  {
    if (col==m_text.GetLength()) break;
    c = m_text.GetAt(col);
    if (c=='/')
    {
      col++;
      break;
    };
    m_name += c;
    col++;
  };
  numslash = 0;
  for (;;)
  {
    if (col == m_text.GetLength()) break;
    c = m_text.GetAt(col);
    if (c=='/')
    {
      col++;
      numslash++;
      if (numslash==2) break;
    }
    else
    {
      m_title += c;
      col++;
    };
  };
  m_male = 0;
  if (col != m_text.GetLength())
  {
    if (m_text.GetAt(col) == 'F') m_male = 1;
  };
  if (col != m_text.GetLength()) col++;
  if (col != m_text.GetLength()) col++;
  m_maxHP = Extract4(&col);
  m_maxStamina = Extract4(&col);
  m_maxMana    = Extract4(&col);
  if (col != m_text.GetLength()) col++;
  for (j=0; j<=6; j++)
  {
    m_attribute[j][0] = Extract2(&col);
  };
  if (col != m_text.GetLength()) col++;
  for (j=1; j<=4; j++)
  {
    for (i=1; i<=4; i++)
    {
      m_attribute[j][i] = Extract1(&col);
    };
  };
  m_attributePenalty = 2;
  if (col != m_text.GetLength()) m_attributePenalty = Extract1(&col);
  if (m_attributePenalty > 16) m_attributePenalty = 16;
  m_basicStatPenalty = 8;
  if (col != m_text.GetLength()) m_basicStatPenalty = Extract1(&col);
  if (m_basicStatPenalty > 16) m_basicStatPenalty = 16;
  m_randomPoints = 3;
  if (col != m_text.GetLength()) m_randomPoints = Extract1(&col);
  if (m_randomPoints > 25) m_randomPoints = 25;

}

void EditText::Encode4(int val)
{
  int i;
  for (i=12; i>=0; i-=4)
  {
    m_text += (char)(((val>>i) & 15) + 'A');
  };
}

void EditText::Encode2(int val)
{
  int i;
  for (i=4; i>=0; i-=4)
  {
    m_text += (char)(((val>>i) & 15) + 'A');
  };
}

void EditText::Encode1(int val)
{
  m_text += (char)(val+'A');
}

void EditText::EncodePortraitDataIntoText(void)
{
  int i, j;
  m_text = m_name;
  m_text += '/';
  if (m_title.GetLength() > 19)
  {
    pDoc->Warning("Title has more than 19 characters");
  };
  m_text += m_title;
  m_text += "//";
  m_text += (m_male==0) ? 'M' : 'F';
  m_text += '/';
  Encode4(m_maxHP);
  Encode4(m_maxStamina);
  Encode4(m_maxMana);
  m_text += '/';
  for (j=0; j<=6; j++)
  {
    Encode2(m_attribute[j][0]);
  };
  m_text += '/';
  for (j=1; j<=4; j++)
  {
    for (i=1; i<=4; i++)
    {
      Encode1(m_attribute[j][i]);
    };
  };
  Encode1(m_attributePenalty);
  Encode1(m_basicStatPenalty);
  Encode1(m_randomPoints);
} 

void EditText::Show(int id, BOOL show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(id);
  if (pWnd != NULL) pWnd->ShowWindow(show);
}

void EditText::DoDataExchange(CDataExchange* pDX)
{
  int oldEditLuck = -1;
  if (!pDX->m_bSaveAndValidate)
  {
    if (m_editingPortrait)
    {
      m_basicAttribute = m_attribute[m_editLuck][0];
      switch (m_editLuck)
      {
      case 0: // Luck
      case 5: //Anti-magic
      case 6: //Anti-fire
        Show(IDC_Skill1, false);
        Show(IDC_Skill2, false);
        Show(IDC_Skill3, false);
        Show(IDC_Skill4, false);
        break;
      case 1: //Strength
      case 2: //Dexterity
      case 3: //Wisdom
      case 4: //Vitality
        Show(IDC_Skill1, true);
        Show(IDC_Skill2, true);
        Show(IDC_Skill3, true);
        Show(IDC_Skill4, true);
        m_skill1.SetCurSel(m_attribute[m_editLuck][1]);
        m_skill2.SetCurSel(m_attribute[m_editLuck][2]);
        m_skill3.SetCurSel(m_attribute[m_editLuck][3]);
        m_skill4.SetCurSel(m_attribute[m_editLuck][4]);
        break;
      };
    };
  };
  if (pDX->m_bSaveAndValidate)
  {
    oldEditLuck = m_editLuck;
  };

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditText)
	DDX_Control(pDX, IDC_Text, m_textCtrl);
	DDX_Control(pDX, IDC_EditPortrait, m_editPortrait);
	DDX_Control(pDX, IDC_Skill4, m_skill4);
	DDX_Control(pDX, IDC_Skill3, m_skill3);
	DDX_Control(pDX, IDC_Skill2, m_skill2);
	DDX_Control(pDX, IDC_Skill1, m_skill1);
	DDX_Text(pDX, IDC_Text, m_text);
	DDX_Text(pDX, IDC_Explanation, m_explanation);
	DDX_Check(pDX, IDC_ShowText, m_showText);
	DDX_Text(pDX, IDC_Name, m_name);
	DDX_Text(pDX, IDC_Title, m_title);
	DDX_Text(pDX, IDC_MaxHP, m_maxHP);
	DDX_Text(pDX, IDC_MaxMana, m_maxMana);
	DDX_Text(pDX, IDC_MaxStamina, m_maxStamina);
	DDX_Radio(pDX, IDC_Male, m_male);
	DDX_Radio(pDX, IDC_EditLuck, m_editLuck);
	DDX_Text(pDX, IDC_BasciAttribute, m_basicAttribute);
	DDX_CBIndex(pDX, IDC_AttributePenalty, m_attributePenalty);
	DDX_CBIndex(pDX, IDC_BasicStatPenalty, m_basicStatPenalty);
	DDX_CBIndex(pDX, IDC_RandomPoints, m_randomPoints);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    Show(IDC_SexTitle,              m_editingPortrait);
    Show(IDC_Male,                  m_editingPortrait);
    Show(IDC_Female,                m_editingPortrait);
    Show(IDC_MaxHP,                 m_editingPortrait);
    Show(IDC_HPTitle,               m_editingPortrait);
    Show(IDC_MaxStamina,            m_editingPortrait);
    Show(IDC_StaminaTitle,          m_editingPortrait);
    Show(IDC_MaxMana,               m_editingPortrait);
    Show(IDC_ManaTitle,             m_editingPortrait);
    Show(IDC_EditLuck,              m_editingPortrait);
    Show(IDC_EditStrength,          m_editingPortrait);
    Show(IDC_EditDexterity,         m_editingPortrait);
    Show(IDC_EditWisdom,            m_editingPortrait);
    Show(IDC_EditVitality,          m_editingPortrait);
    Show(IDC_EditAntiMagic,         m_editingPortrait);
    Show(IDC_EditAntiFire,          m_editingPortrait);
    Show(IDC_WhatTitle,             m_editingPortrait);
    Show(IDC_WhatToEdit,            m_editingPortrait);
    Show(IDC_Name,                  m_editingPortrait);
    Show(IDC_Title,                 m_editingPortrait);
    Show(IDC_NameTitle,             m_editingPortrait);
    Show(IDC_TitleTitle,            m_editingPortrait);
    Show(IDC_Explanation,          !m_editingPortrait);
    Show(IDC_BasicAttributeTitle,   m_editingPortrait);
    Show(IDC_BasicAttribute,        m_editingPortrait);
    Show(IDC_AssociatedSkillsTitle, m_editingPortrait);
    Show(IDC_Skill1,                m_editingPortrait);
    Show(IDC_Skill2,                m_editingPortrait);
    Show(IDC_Skill3,                m_editingPortrait);
    Show(IDC_Skill4,                m_editingPortrait);
    Show(IDC_BasicStatsTitle,       m_editingPortrait);
    Show(IDC_BasicStatPenalty,      m_editingPortrait);
    Show(IDC_AttributePenalty,      m_editingPortrait);
    Show(IDC_StatPenaltyTitle,      m_editingPortrait);
    Show(IDC_AttributePenaltyTitle, m_editingPortrait);
    Show(IDC_RandomPoints,          m_editingPortrait);
    Show(IDC_RandomPointsTitle,     m_editingPortrait);
    
    m_editPortrait.SetCheck(m_editingPortrait);
    SetWindowSize();
  };
  if (pDX->m_bSaveAndValidate)
  {
    if (m_editingPortrait)
    {
      m_attribute[oldEditLuck][0] = m_basicAttribute;
      m_attribute[oldEditLuck][1] = m_skill1.GetCurSel();
      m_attribute[oldEditLuck][2] = m_skill2.GetCurSel();
      m_attribute[oldEditLuck][3] = m_skill3.GetCurSel();
      m_attribute[oldEditLuck][4] = m_skill4.GetCurSel();
    };
    m_editingPortrait = m_editPortrait.GetCheck() != 0;
  };
}


BEGIN_MESSAGE_MAP(EditText, CDialog)
	//{{AFX_MSG_MAP(EditText)
	ON_BN_CLICKED(IDC_EditPortrait, OnEditPortrait)
	ON_BN_CLICKED(IDC_EditLuck, OnEditLuck)
	ON_EN_UPDATE(IDC_Text, OnUpdateText)
	ON_BN_CLICKED(IDC_EditAntiFire, OnEditLuck)
	ON_BN_CLICKED(IDC_EditAntiMagic, OnEditLuck)
	ON_BN_CLICKED(IDC_EditDexterity, OnEditLuck)
	ON_BN_CLICKED(IDC_EditStrength, OnEditLuck)
	ON_BN_CLICKED(IDC_EditVitality, OnEditLuck)
	ON_BN_CLICKED(IDC_EditWisdom, OnEditLuck)
	ON_BN_CLICKED(IDC_SubstitutionHelp, OnSubstitutionHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditText message handlers


BOOL EditText::OnInitDialog() 
{
  int len, i, db2index, textIndirectIndex, compressedTextIndex;
  LOCATIONABS loca;
  unsigned char ch;
  DB2 *pText;
//  RECT rect;
  CString temp;
  pText = pDoc->GetRecordAddressDB2(m_object);
  db2index = m_object.dbIndex();
  textIndirectIndex = pText->index();
  compressedTextIndex = pDoc->GetCompressedTextIndex(m_object);
  loca = m_locr;
  temp.Format("Text %d(%02d,%02d)[%d][%d][%d][%d]",
              loca.l, loca.x, loca.y,
              m_object.ConvertToInteger(),
              db2index,
              textIndirectIndex,
              compressedTextIndex);
  SetWindowText(temp);
//  GetWindowRect(&rect);
//  MoveWindow(100,100,rect.right-rect.left,rect.bottom-rect.top);
	temp = pDoc->GetRawText(m_object,m_textType);
  switch (m_textType)
  {
  case TEXTTYPE_WALL:
    m_text = DecodeText(temp, TEXTTYPE_WALL);
    m_text.Replace("\n", "\015\012");
    m_explanation = CString("Use Control-Enter or '/' for line break");
    m_showText = pDoc->GetRecordAddressDB2(m_object)->show();
    break;
  case TEXTTYPE_MIRROR:
  case TEXTTYPE_ENDGAME:
    m_text = "";
    len = temp.GetLength();
    for (i=0; i<len; i++)
    {
      ch = temp.GetAt(i);
      if (ch == 10) ch = '/';
      m_text += ch;
    };
    m_explanation = CString("Use '/' for line breaks.");
    m_showText = pDoc->GetRecordAddressDB2(m_object)->show();
    break;
  default:
    InternalError("Unknown text type");
  };
  m_origText = m_text;//So we can see if it changes.
  m_origShowText = pDoc->GetRecordAddressDB2(m_object)->show();
  m_editingPortrait = false;
	CDialog::OnInitDialog();

  for (i=0; i<18; i++)
  {
    temp.Format("%d",125<<i);
    if (i==0) temp = "0";
    m_skill1.AddString(temp);
    m_skill2.AddString(temp);
    m_skill3.AddString(temp);
    m_skill4.AddString(temp);
  };
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void EditText::OnOK() 
{
	// TODO: Add extra validation here
  int len, i;
  char ch;
  UpdateData(true);
  if (m_editingPortrait)
  {
    EncodePortraitDataIntoText();
  };
	if (  (m_origText != m_text)
      ||(m_origShowText != m_showText))
  {
    if (m_text.GetLength() > 500)
    {
      pDoc->Sorry("Text is too long");
    }
    else 
    {
      CString temp = "ILLEGAL TEXT TYPE";
      switch (m_textType)
      {
      case TEXTTYPE_WALL:
        m_text.Replace("/", "\015\012");
        len = m_text.GetLength();
        temp = "";
        for (i=0; i<len; i++)
        {
          ch = m_text.GetAt(i);
          if (  (ch == 13)
              &&(i < len-1)
              &&(m_text.GetAt(i+1) == 10))
          {
            i++;
            temp += (unsigned char)0x80;
          }
          else if (ch == ' ')
          {
            temp += (char)0x1a;
          }
          else if (ch == '.')
          {
            temp += (char)27;
          }
          else (temp += (char)(ch - 'A'));
        };
        break;
      case TEXTTYPE_MIRROR:
        len = m_text.GetLength();
        temp = "";
        for (i=0; i<len; i++)
        {
          ch = m_text.GetAt(i);
          if (ch == '/')
          {
            temp += (char)0x0a;
          }
          else temp += ch;
        };
        break;
      default:
        pDoc->Sorry("Illegal text type");
      };
      pDoc->SetText(m_object, temp, m_textType);
      pDoc->GetRecordAddressDB2(m_object)->show(m_showText);
    };
  };
  if (m_editingPortrait)
  {
    savedEditLuck = m_editLuck;
  };
	CDialog::OnOK();
}

void EditText::OnEditPortrait() 
{
	// TODO: Add your control notification handler code here

  UpdateData(true);
  if (m_editingPortrait)
  {
    CWnd *pWnd;
    m_editLuck = savedEditLuck;
    pWnd = GetDlgItem(IDC_Text);
    if (pWnd != NULL) pWnd->EnableWindow(false);
    ExtractPortraitDataFromText();
  }
  else
  {
    CWnd *pWnd;
    pWnd = GetDlgItem(IDC_Text);
    if (pWnd != NULL) pWnd->EnableWindow(true);
    savedEditLuck = m_editLuck;
    EncodePortraitDataIntoText();
  };
  UpdateData(false);
}

void EditText::OnEditLuck() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
  UpdateData(false);
}

void EditText::OnUpdateText() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	//UpdateData(true);
  // m_text.Replace("/", "\015\012");
  // This causes loss of cursor position so we do this only
  // when we lose focus.
  //UpdateData(false);
	// TODO: Add your control notification handler code here
	
}

void EditText::OnSubstitutionHelp() 
{
	// TODO: Add your control notification handler code here
  CString s;

	s.LoadString(IDH_EditTextSubstitution);
  HelpMsg(s);
}
