// FixCloneDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "FixCloneDlg.h"
#include "Misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern i32 dbEntrySizes[16];

/////////////////////////////////////////////////////////////////////////////
// FixCloneDlg dialog


FixCloneDlg::FixCloneDlg(CWnd* pParent /*=NULL*/)
	: CDialog(FixCloneDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(FixCloneDlg)
	m_clonedObject = _T("");
	//}}AFX_DATA_INIT
  m_listIndex = -1;
}

void FixCloneDlg::Show(int ID, bool show)
{
  CWnd *pWnd;
  pWnd = GetDlgItem(ID);
  if (pWnd == NULL) return;
  pWnd->ShowWindow(show);
}


void FixCloneDlg::DoDataExchange(CDataExchange* pDX)
{
  DBTYPE cloneType;
  CHKERRMSG *pcem;
  DBTYPE parentType;
  int index;
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FixCloneDlg)
	DDX_Control(pDX, IDC_CloneList, m_cloneList);
	DDX_Text(pDX, IDC_ClonedObject, m_clonedObject);
	//}}AFX_DATA_MAP
  cloneType = pDoc->DataType(m_pcem->CloneIndirectIndex());
  Show (IDC_CopyAll, true);
  switch (cloneType)
  {
  case dbTELEPORTER:
  case dbTEXT:
  case dbACTUATOR:
  case dbWEAPON:
  case dbMONSTER:
  case dbMISC:
  case dbPOTION:
    Show (IDC_Delete,  true);
    Show (IDC_MakeCopy,true);
    break;
  default:
    Show (IDC_Delete,  false);
    Show (IDC_MakeCopy,true);
    break;
  };
  if (pDX->m_bSaveAndValidate)
  {
    m_listIndex = m_cloneList.GetCurSel();
  };
  index = m_cloneList.GetCurSel();
  if (index >= 0)
  {
    pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
    parentType = pDoc->DataType(pcem->ParentIndirectIndex());
    if (pcem->Repaired())
    {
      Show(IDC_Delete,  false);
      Show(IDC_MakeCopy,false);
      Show(IDC_CopyAll, false);
    }
    else
    {
      switch(parentType)
      {
      case dbTEXT:
      case dbMONSTER:
      case dbTELEPORTER:
      case dbDOOR: 
      case dbACTUATOR:
      case dbMISC:
      case dbWEAPON:
      case dbCLOTHING:
      case dbPOTION:
      case dbCHEST:
        break;
      case dbSCROLL:
        if (pcem->ErrorType() == CEMT_SCROLLTEXT)
        {
          Show(IDC_Delete, false);
        };
        break;
      default:
        Show(IDC_Delete,   false);
        Show(IDC_CopyAll,  false);
        Show(IDC_MakeCopy, false);
        break;
      };
    };
  }
  else
  {
    Show(IDC_Delete,   false);
    Show(IDC_MakeCopy, false);
    Show(IDC_CopyAll,  false);
  };
}


BEGIN_MESSAGE_MAP(FixCloneDlg, CDialog)
	//{{AFX_MSG_MAP(FixCloneDlg)
	ON_BN_CLICKED(IDC_Delete, OnDelete)
	ON_BN_CLICKED(IDC_MakeCopy, OnMakeCopy)
	ON_BN_CLICKED(IDC_CopyAll, OnCopyAll)
	ON_LBN_SELCHANGE(IDC_CloneList, OnSelchangeCloneList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FixCloneDlg message handlers

CString FixCloneDlg::GetGraphicName(const CHKERRMSG *pcem)
{
  RN obj;
  DB3 *pDB3;
  int indirectIndex;
  indirectIndex = pcem->CloneIndirectIndex();
  for (pcem=pcem->Next(); pcem!=NULL; pcem=pcem->Next())
  {
    switch(pcem->ErrorType())
    {
    case CEMT_CLONE: return CString("{unknown}");
    case CEMT_PARENTCELL:
    case CEMT_CLONEDPARENTLIST:
    case CEMT_UNCLONEDPARENTLIST:
      ASSERT(pcem->CloneIndirectIndex() == indirectIndex);
      obj.ConstructFromInteger(indirectIndex);
      pDB3 = pDoc->GetRecordAddressDB3(obj);
      return CString("{") + pDB3->GraphicName(pcem->Location()) + "}";
    };
  };
  return CString("{unknown}");
}



void FixCloneDlg::DescribeObject(void)
{
  DBTYPE dbType;
  int indirectIndex;
  m_clonedObject.Format("[%04x] ", 
                   m_pcem->CloneIndirectIndex());
  indirectIndex = m_pcem->CloneIndirectIndex();
  dbType = pDoc->DataType(indirectIndex);
  switch (dbType)
  {
  case dbACTUATOR:
    {
      DB3 *pDB3;
      ROOMTYPE rt;
      rt = RoomType(m_pcem->Location());
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB3 = pDoc->GetRecordAddressDB3(obj);
      m_clonedObject += pDB3->Name(rt);
      m_clonedObject += GetGraphicName(m_pcem);
    };
    break;
  case dbMONSTER:
    {
      DB4 *pDB4;
      MONSTERTYPE mt;
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB4 = pDoc->GetRecordAddressDB4(obj);
      mt = pDB4->monsterType();
      m_clonedObject += mt.Name();
    };
    break;
  case dbPOTION:
    {
      DB8 *pDB8;
      POTIONTYPE pt;
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB8 = pDoc->GetRecordAddressDB8(obj);
      pt = pDB8->potionType();
      m_clonedObject += pt.Name();
    };
    break;
  case dbMISC:
    {
      DB10 *pDB10;
      MISCTYPE mt;
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB10 = pDoc->GetRecordAddressDB10(obj);
      mt = pDB10->miscType();
      m_clonedObject += mt.Name();
    };
    break;
  case dbWEAPON:
    {
      DB5 *pDB5;
      WEAPONTYPE wt;
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB5 = pDoc->GetRecordAddressDB5(obj);
      wt = pDB5->weaponType();
      m_clonedObject += wt.Name();
    };
    break;
  case dbCLOTHING:
    {
      DB6 *pDB6;
      CLOTHINGTYPE ct;
      RN obj;
      obj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDB6 = pDoc->GetRecordAddressDB6(obj);
      ct = pDB6->clothingType();
      m_clonedObject += ct.Name();
    };
    break;
  case dbTELEPORTER:
    m_clonedObject += "Teleporter";
    break;
  case dbDOOR:
    m_clonedObject += "Door";
    break;
  case dbTEXT:
    {
      char result[81];
      RN textObj;
      textObj.ConstructFromInteger(m_pcem->CloneIndirectIndex());
      pDoc->ExpandText(result, textObj, 1, 80);
      m_clonedObject += result;
    };
    break;
  case dbSCROLL:
    m_clonedObject += "Scroll";
    break;
  default:
    m_clonedObject += "Description Not Implemented...report to program's author";
    break;
  };
}

void FixCloneDlg::FillListBox()
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  CString msg;
  CHKERRMSG *pcem;
  int index;
  m_cloneList.ResetContent();
  if (m_pcem->CloneIndirectIndex() < 0) return;
  pcem = m_pcem->Next();
  while (pcem!=NULL)
  {
    switch (pcem->ErrorType())
    {
    case CEMT_PARENTCELL:
      locr = pcem->Location();
      loca = locr;
      msg.Format("%s[%04x] Parent is Dungeon Cell %02d(%02d,%02d)",
                 pcem->Repaired()?"Repaired ":"",
                 pcem->CloneIndirectIndex(),
                 loca.l, loca.x, loca.y);
      index = m_cloneList.AddString(msg);
      m_cloneList.SetItemDataPtr(index,pcem);
      break;
    case CEMT_CLONEDPARENTLIST:
//      index = m_cloneList.AddString("Parent is cloned list object");
//      m_cloneList.SetItemDataPtr(index, pcem);
//      break;
    case CEMT_UNCLONEDPARENTLIST:
      {
        RN parentObj;
        parentObj.ConstructFromInteger(pcem->ParentIndirectIndex());
        locr = pcem->Location();
        loca = locr;
        msg.Format("%s[%04x] Uncloned list @ %d(%02d,%02d) ",
                    pcem->Repaired()?"Repaired ":"",
                    pcem->ParentIndirectIndex(),
                    loca.l, loca.x, loca.y);
        msg += parentObj.Name(RoomType(locr));
        index = m_cloneList.AddString(msg);
        m_cloneList.SetItemDataPtr(index, pcem);
      };
      break;
    case CEMT_SCROLLTEXT:
      locr = pcem->Location();
      loca = locr;
      msg.Format("%s[%04x] Scroll @ %d(%02d,%02d)",
                  pcem->Repaired()?"Repaired ":"",
                  pcem->ParentIndirectIndex(),
                  loca.l, loca.x, loca.y);
      index = m_cloneList.AddString(msg);
      m_cloneList.SetItemDataPtr(index, pcem);
      break;
    case CEMT_MONSTERPOSSESSION:
      {
        locr = pcem->Location();
        loca = locr;
        MONSTERTYPE mt;
        CString name;
        RN monster;
        monster.ConstructFromInteger(pcem->ParentIndirectIndex());
        name = monster.Name(RoomType(locr));
        msg.Format("%s[%04x]  %s Possession @ %d(%02d,%02d)",
                   pcem->Repaired()?"Repaired ":"",
                   pcem->ParentIndirectIndex(),
                   name,
                   loca.l, loca.x, loca.y);
        index = m_cloneList.AddString(msg);
        m_cloneList.SetItemDataPtr(index, pcem);
      };
      break;
    case CEMT_CHARACTERPOSSESSION:
      {
        locr = pcem->Location();
        msg.Format("%s Character %d Possession %d",
                   pcem->Repaired()?"Repaired ":"",
                   locr.x(),
                   locr.y());
        index = m_cloneList.AddString(msg);
        m_cloneList.SetItemDataPtr(index, pcem);
      };
      break;
    case CEMT_CHESTCONTENTS:
      {
        locr = pcem->Location();
        loca = locr;
        RN chest;
        chest.ConstructFromInteger(pcem->ParentIndirectIndex());
        msg.Format("%s[%04x]  Chest Contents @ %d(%02d,%02d)",
                   pcem->Repaired()?"Repaired ":"",
                   pcem->ParentIndirectIndex(),
                   loca.l, loca.x, loca.y);
        index = m_cloneList.AddString(msg);
        m_cloneList.SetItemDataPtr(index, pcem);
      };
      break;
    case CEMT_CLONE:
      pcem = NULL;
      break;
    default:
      NotImplemented();
      pcem = NULL;
      break;
    };
    if (pcem != NULL) pcem = pcem->Next();
  };
  if (m_listIndex < 0) m_listIndex = 0;
  m_cloneList.SetCurSel(m_listIndex);
}

void FixCloneDlg::SelectNonRepaired(void)
{
  int index;
  CHKERRMSG *pcem;
  index = m_cloneList.GetCurSel();
  if (index < 0) index = 0;
  while (index < m_cloneList.GetCount())
  {
    pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
    if (!pcem->Repaired()) break;
    index++;
  };
  if (index >= m_cloneList.GetCount()) index--;
  while (index >= 0)
  {
    pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
    if (!pcem->Repaired()) break;
    index--;
  };
  if (index >= 0) m_cloneList.SetCurSel(index);
}


BOOL FixCloneDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  m_modified = false;
  DescribeObject();
	FillListBox();
  UpdateData(false);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void FixCloneDlg::OnDelete() 
{
	// TODO: Add your control notification handler code here
  int index;
  bool modification = false;
  CHKERRMSG *pcem;
  DBCOMMON *pCOMMON;
  DBTYPE cloneType;
  RN parent, child, grandChild;
  UpdateData(true);
  index = m_cloneList.GetCurSel();
  if (index < 0)
  {
    pDoc->Sorry("You need to select a parent");
    return;
  };
  pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
  switch (pcem->ErrorType())
  {
  case CEMT_UNCLONEDPARENTLIST:
  case CEMT_CLONEDPARENTLIST:
    parent.ConstructFromInteger(pcem->ParentIndirectIndex());
    pCOMMON = pDoc->GetCommonAddress(parent);
    child.ConstructFromInteger(pcem->CloneIndirectIndex());
    pDoc->DeleteObjectFromList(child, 
                               pCOMMON->pLink(), 
                               false,
                               false);
    // Leave child alone.  If anyone else is pointing
    // to it then it may or may not still be a clone.
    // But if nobody is pointing at it, then it will
    // become an orphan and can be deleted later.
    modification = true;
    break;
  case CEMT_PARENTCELL:
    cloneType = pDoc->DataType(pcem->CloneIndirectIndex());
    switch (cloneType)
    {
    case dbACTUATOR:
    case dbMONSTER:
    case dbPOTION:
    case dbMISC:
    case dbTEXT:
    case dbWEAPON:
      {
        DBCOMMON *pDB;
        LOCATIONREL locr;
        RN cloneObj;
        locr = pcem->Location();
        cloneObj.ConstructFromInteger(pcem->CloneIndirectIndex());
        pDB = pDoc->GetCommonAddress(cloneObj);
        pDoc->RemoveObjectFromRoom(
                       locr,
                       cloneObj,
                       false,
                       false); 
        //Let it dangle...the worst that can happen is that
        //it will become an orphan.  We can deal with it then.
        modification = true;
      };
      break;
    case dbTELEPORTER:
      {
        DBCOMMON *pDB;
        LOCATIONREL locr;
        RN cloneObj, firstTeleporter;
        locr = pcem->Location();
        cloneObj.ConstructFromInteger(pcem->CloneIndirectIndex());
        pDB = pDoc->GetCommonAddress(cloneObj);
        pDoc->RemoveObjectFromRoom(
                       locr,
                       cloneObj,
                       false,
                       false); 
        //Let it dangle...the worst that can happen is that
        //it will become an orphan.  We can deal with it then.
        modification = true;
        firstTeleporter = 
             pDoc->FindFirstTeleporter(locr);
        if (firstTeleporter == RNeof)
        {
          pDoc->SetCellFlag(
                locr, 
                (CELLFLAG)((pDoc->GetCellFlag(locr) & 0x1f) | 0x20));
        };
      };
      break;
    default:
      pDoc->Sorry("Clone type not implemented");
      return;
    };
    break;
  case CEMT_MONSTERPOSSESSION:
    {
      DB4 *pDB4;
      RN monsterObj, possessionObj, possessionLink;
      monsterObj.ConstructFromInteger(pcem->ParentIndirectIndex());
      pDB4 = pDoc->GetRecordAddressDB4(monsterObj);
      possessionObj.ConstructFromInteger(pcem->CloneIndirectIndex());
      pDoc->DeleteObjectFromList(
                   possessionObj,
                   pDB4->pPossession(),
                   false,
                   false);
      modification = true;
    };
    break;
  default:
	  pDoc->Sorry("Not Implemented...contact programmer");
  };
  if (modification) 
  {
    pDoc->ClearCellCheckpoints();
    m_modified = true;
    pcem->Repaired(true);
    FillListBox();
    SelectNonRepaired();
    UpdateData(false);
  };
}

RN FixCloneDlg::DuplicateClone(CHKERRMSG *pcem)
{
  RN oldObject, newObject;
  DBTYPE dbtype;
  oldObject.ConstructFromInteger(pcem->CloneIndirectIndex());
  dbtype = oldObject.dbType();   //child type
  DBCOMMON *pNewDB, *pOldDB;
  newObject = RNnul;
  switch (dbtype)
  {
  case dbMONSTER:
    newObject = pDoc->FindEmptyDB4Entry();
    break;
  case dbWEAPON:
    newObject = pDoc->FindEmptyDB5Entry();
    break;
  case dbPOTION:
    newObject = pDoc->FindEmptyDB8Entry();
    break;
  case dbCLOTHING:
    newObject = pDoc->FindEmptyDB6Entry();
    break;
  case dbTEXT:
    newObject = pDoc->FindEmptyDB2Entry(TEXTTYPE_WALL,false);
    break;
  case dbMISC:
    newObject = pDoc->FindEmptyDB10Entry();
    break;
  case dbTELEPORTER:
    newObject = pDoc->FindEmptyDB1Entry();
    break;
  case dbDOOR:
    newObject = pDoc->FindEmptyDB0Entry();
    break;
  case dbACTUATOR:
    newObject = pDoc->FindEmptyDB3Entry(AC_PUSHBUTTON);
    break;
  case dbSCROLL:
    newObject = pDoc->FindEmptyDB7Entry();
    break;
  default:
    pDoc->Sorry("That data type not implemented");
    break;
  };
  if (newObject == RNnul) return RNnul;
  newObject.pos(oldObject.pos());
  pNewDB = pDoc->GetCommonAddress(newObject);
  pOldDB = pDoc->GetCommonAddress(oldObject);
  memcpy(pNewDB, pOldDB, dbEntrySizes[dbtype]);
  return newObject;
}

void FixCloneDlg::OnMakeCopy() 
{
	// TODO: Add your control notification handler code here
  CHKERRMSG *pcem;
  int index;
  RN obj;
  RN cloneObj;
  DBTYPE cloneType;
  LOCATIONREL locr;
  UpdateData(true);
  bool modification = false;
  index = m_cloneList.GetCurSel();
  if (index < 0)
  {
    pDoc->Sorry("You need to select a parent");
    return;
  };
  pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
  if (pcem->Repaired())
  {
    pDoc->Information("That Clone reference is already repaired");
    return;
  };
  cloneObj.ConstructFromInteger(pcem->CloneIndirectIndex());
  cloneType = cloneObj.dbType();
  switch (pcem->ErrorType())
  {
  case CEMT_SCROLLTEXT:
    {
      RN scroll;
      DB7 *pDB7;
      scroll.ConstructFromInteger(pcem->ParentIndirectIndex());
      pDB7 = pDoc->GetRecordAddressDB7(scroll);
      switch(cloneType)
      {
      case dbTEXT:
        {
          RN newObject;
          newObject = DuplicateClone(pcem);
          if (newObject == RNnul) break;
          pDB7->text(newObject);
          pDoc->SetModifiedFlag();
          modification = true;
        };
        break;
      default:
        pDoc->Sorry("That child object type not implemented");
        break;
      };
      break;
    };
  case CEMT_MONSTERPOSSESSION:
    {
      RN monster;
      DB4 *pDB4;
      monster.ConstructFromInteger(pcem->ParentIndirectIndex());
      pDB4 = pDoc->GetRecordAddressDB4(monster);
      switch(cloneType)
      {
      case dbMISC:
      case dbMONSTER:
      case dbWEAPON:
      case dbPOTION:
        {
          RN newObject;
          newObject = DuplicateClone(pcem);
          if (newObject == RNnul) break;
          pDB4->possession(newObject);
          pDoc->SetModifiedFlag();
          modification = true;
        };
        break;
      default:
        pDoc->Sorry("That child object type not implemented");
        break;
      };
      break;
    };
  case CEMT_CHARACTERPOSSESSION:
    {
      switch(cloneType)
      {
      case dbMISC:
      case dbMONSTER:
      case dbWEAPON:
      case dbPOTION:
        {
          RN newObject;
          int iChar, iPos;
          newObject = DuplicateClone(pcem);
          if (newObject == RNnul) break;
          iChar = pcem->Location().x();
          iPos = pcem->Location().y();
          pDoc->CharacterPossession(iChar, iPos, newObject); 
          pDoc->SetModifiedFlag();
          modification = true;
        };
        break;
      default:
        pDoc->Sorry("That child object type not implemented");
        break;
      };
      break;
    };
  case CEMT_CHESTCONTENTS:
    {
      RN chest;
      DB9 *pDB9;
      chest.ConstructFromInteger(pcem->ParentIndirectIndex());
      pDB9 = pDoc->GetRecordAddressDB9(chest);
      switch(cloneType)
      {
      case dbMISC:
      case dbMONSTER:
      case dbWEAPON:
      case dbPOTION:
        {
          RN newObject;
          newObject = DuplicateClone(pcem);
          if (newObject == RNnul) break;
          pDB9->contents(newObject);
          pDoc->SetModifiedFlag();
          modification = true;
        };
        break;
      default:
        pDoc->Sorry("That child object type not implemented");
        break;
      };
      break;
    };
  case CEMT_CLONEDPARENTLIST:
  case CEMT_UNCLONEDPARENTLIST:
    {
      RN parent;
      DBCOMMON *pDB;
      parent.ConstructFromInteger(pcem->ParentIndirectIndex());
      pDB = pDoc->GetCommonAddress(parent);
      switch(cloneType)
      {
      case dbSCROLL:
      case dbMONSTER:
      case dbTELEPORTER:
      case dbTEXT:
      case dbACTUATOR:
      case dbPOTION:
      case dbMISC:
      case dbWEAPON:
      case dbCLOTHING:
        {
          RN newObject;
          newObject = DuplicateClone(pcem);
          if (newObject == RNnul) break;
          pDB->link(newObject);
          pDoc->SetModifiedFlag();
          modification = true;
        };
        break;
      default:
        pDoc->Sorry("That child object type not implemented");
        break;
      };
      break;
    };
  case CEMT_PARENTCELL:
    locr = pcem->Location(); //Parent cell location
    switch(cloneType)
    {
    case dbTELEPORTER:
    case dbDOOR:
    case dbTEXT:
    case dbACTUATOR:
    case dbMONSTER:
    case dbWEAPON:
    case dbMISC:
    case dbPOTION:
      {
        RN newObject;
        newObject = DuplicateClone(pcem);
        if (newObject == RNnul) break;
        pDoc->ReplaceRoomObjectList(locr, newObject);
        modification = true;
      };
      break;
    default:
      pDoc->Sorry("That child object type not implemented");
      break;
    };
    break;
  default:
	  pDoc->Sorry("Not Implemented...contact programmer");
  };
  if (modification) 
  {
    pDoc->ClearCellCheckpoints();
    m_modified = true;
    pcem->Repaired(true);
    FillListBox();
    UpdateData(false);
  };
}

void FixCloneDlg::OnCopyAll() 
{
	// TODO: Add your control notification handler code here
  int num, index;
  CHKERRMSG *pcem;
	for (num=0, index=0; index<m_cloneList.GetCount(); index++)
  {
    pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
    if (!pcem->Repaired())
    {
      num++;
    }
  };
  for (index=0; index<m_cloneList.GetCount(); index++)
  {
    pcem = (CHKERRMSG *)m_cloneList.GetItemDataPtr(index);
    if (!pcem->Repaired())
    {
      num--;
      if (num == 0) break;
      m_cloneList.SetCurSel(index);
      OnMakeCopy();
    };
  };
}

void FixCloneDlg::OnSelchangeCloneList() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
}
