// ListDSAs.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "ListDSAs.h"
#include "myClistCtrl.h"
#include "DesignedActuator.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// ListDSAs dialog


ListDSAs::ListDSAs(CWnd* pParent /*=NULL*/)
	: CDialog(ListDSAs::IDD, pParent)
{
	//{{AFX_DATA_INIT(ListDSAs)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void ListDSAs::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ListDSAs)
	DDX_Control(pDX, IDC_ListOfDSAs, m_listOfDSAs);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate)
  {
    BuildList();
  };
}


BEGIN_MESSAGE_MAP(ListDSAs, CDialog)
	//{{AFX_MSG_MAP(ListDSAs)
	ON_BN_CLICKED(IDC_EditDSA, OnEditDSA)
	ON_LBN_DBLCLK(IDC_ListOfDSAs, OnDblclkListOfDSAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ListDSAs message handlers

void ListDSAs::BuildList(void)
{
  int i;
  CString text;
  m_listOfDSAs.ResetContent();
  for (i=0; i<256; i++)
  {
    if (pDoc->getDSA(i) == NULL)
    {
      text.Format("%03d",i);
    }
    else
    {
      text.Format("%03d %s",i,pDoc->getDSA(i)->Description());
    }
    m_listOfDSAs.AddString(text);
  };
}

void ListDSAs::OnEditDSA() 
{
  int index;
  DSA *pDSA;
	// TODO: Add your control notification handler code here
  DesignedActuator dlg;
  UpdateData(true);
  index = m_listOfDSAs.GetCurSel();
  if (index < 0)
  {
    NoSelection();
    BuildList();
    return;
  };
  pDSA = pDoc->getDSA(index);
  if (pDSA != NULL)
  {
    dlg.m_DSA = *pDSA;
  };
  if (dlg.DoModal() == IDOK) 
  {
    pDoc->setDSA(index, &dlg.m_DSA); 
  };
  BuildList();
}

void ListDSAs::OnDblclkListOfDSAs() 
{
	// TODO: Add your control notification handler code here
  OnEditDSA();	
}
