// LocateDecoration.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "LocateDecoration.h"
#include "Misc.h"
#include "ShowLocations.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LocateDecoration dialog


LocateDecoration::LocateDecoration(CWnd* pParent /*=NULL*/)
	: CDialog(LocateDecoration::IDD, pParent)
{
	//{{AFX_DATA_INIT(LocateDecoration)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void LocateDecoration::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LocateDecoration)
	DDX_Control(pDX, IDC_WallDecorationList, m_wallDecorationList);
	DDX_Control(pDX, IDC_FloorDecorationList, m_floorDecorationList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(LocateDecoration, CDialog)
	//{{AFX_MSG_MAP(LocateDecoration)
	ON_BN_CLICKED(IDC_FindFloor, OnFindFloor)
	ON_BN_CLICKED(IDC_FindWall, OnFindWall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LocateDecoration message handlers

BOOL LocateDecoration::OnInitDialog() 
{
  CString name;
  int index;
  WALLTYPE wt;
  FLOORTYPE ft;
	CDialog::OnInitDialog();
  for (ft.FirstType(); ft.IsLegal(); ft.NextType())
  {
    name = ft.Name();
    index = m_floorDecorationList.AddString(NicelyDecapitalize(name));
    m_floorDecorationList.SetItemData(index, ft.Integer());
  };
  m_floorDecorationList.SetCurSel(0);

  for (wt.FirstType(); wt.IsLegal(); wt.NextType())
  {
    name = wt.Name();
    index = m_wallDecorationList.AddString(NicelyDecapitalize(name));
    m_wallDecorationList.SetItemData(index, wt.Integer());
  };
  m_wallDecorationList.SetCurSel(0);
  
  // TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void LocateDecoration::OnFindFloor() 
{
	// TODO: Add your control notification handler code here
  OBJECTLIST objectList;
  RN act;
  LOCATIONREL locr;
  FLOORTYPE ft, ftSearch;
  ROOMTYPE rt;
  int graphicOrdinal;
  DB3 *pDB3;
  ftSearch.Integer(m_floorDecorationList.GetItemData(m_floorDecorationList.GetCurSel()));
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    rt = RoomType(locr);
    if (rt == roomSTONE) continue;
    if (rt == roomFALSEWALL) continue;
    for (act = pDoc->FindFirstActuator(locr);
         act != RNeof;
         act = pDoc->FindNextActuator(act))
    {
      pDB3 = pDoc->GetRecordAddressDB3(act);
      graphicOrdinal = pDB3->GraphicOrdinal(locr);
      if (graphicOrdinal == 0) continue;
      ft = pDoc->FloorDecorationType(locr.l(), graphicOrdinal);
      if (ft == ftSearch)
      {
        locr.p(act.pos());
        objectList.Insert(RNnul, locr);
      };
    };
  };
  if (objectList.NumEnt() > 0)
  {
    ShowLocations dlg(&objectList);
    dlg.DoModal();
  };
}

void LocateDecoration::OnFindWall() 
{
	// TODO: Add your control notification handler code here
	
  OBJECTLIST objectList;
  RN act;
  LOCATIONREL locr;
  WALLTYPE wt, wtSearch;
  ROOMTYPE rt;
  int graphicOrdinal;
  DB3 *pDB3;
  wtSearch.Integer(m_wallDecorationList.GetItemData(m_wallDecorationList.GetCurSel()));
  for (locr.First(); locr.l()>=0; locr.Next())
  {
    rt = RoomType(locr);
    if (rt != roomSTONE) continue;
    for (act = pDoc->FindFirstActuator(locr);
         act != RNeof;
         act = pDoc->FindNextActuator(act))
    {
      pDB3 = pDoc->GetRecordAddressDB3(act);
      graphicOrdinal = pDB3->GraphicOrdinal(locr);
      if (graphicOrdinal == 0) continue;
      wt = pDoc->WallDecorationType(locr.l(), graphicOrdinal-1);
      if (wt == wtSearch)
      {
        locr.p(act.pos());
        objectList.Insert(RNnul, locr);
      };
    };
  };
  if (objectList.NumEnt() > 0)
  {
    ShowLocations dlg(&objectList);
    dlg.DoModal();
  };
}
