#include "stdafx.h"
//#include "types.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "EditText.h"
#include "Edit_Teleporter.h"
#include "ObjectListBox.h"
#include "myCListCtrl.h"
#include "EditChest.h"
#include "EditDoor.h"
#include "EditScroll.h"
#include "Misc.h"


int ObjectEditor(RN obj, LOCATIONREL locr)
{
  LEVELINFO levelInfo;
  DBTYPE dbType;
  int result = IDCANCEL;
  OBJECT_CHECKPOINT oldCheckpoint(obj,RoomType(locr),&locr);
  levelInfo = locr;
  dbType = obj.dbType();
  switch (dbType)
  {
  case dbTEXT:
    {
      EditText dlg;
      dlg.m_object = obj;
      dlg.m_locr = locr;
      switch (RoomType(locr))
      {
      case roomOPEN:
      case roomTELEPORTER:
      case roomDOOR:
      case roomSTAIRS:
        dlg.m_textType = TEXTTYPE_MIRROR;
        break;
      case roomFALSEWALL:
      case roomSTONE:
        dlg.m_textType = TEXTTYPE_WALL;
        break;
      default:
        Strange("Unknown Text Type");
        return IDCANCEL;
      };
      return dlg.DoModal(); //Sets Modified Flag
    };
  case dbACTUATOR:
    //DB3::Edit sets Modified Flag
    return pDoc->GetRecordAddressDB3(obj)->Edit(locr, obj);
  case dbWEAPON:
    result = pDoc->GetRecordAddressDB5(obj)->Edit(locr, obj);
    break;
  case dbMISC:
    result = pDoc->GetRecordAddressDB10(obj)->Edit(locr, obj);
    break;
  case dbPOTION:
    result = pDoc->GetRecordAddressDB8(obj)->Edit(locr, obj);
    break;
  case dbCLOTHING:
    result = pDoc->GetRecordAddressDB6(obj)->Edit(locr, obj);
    break;
  case dbMONSTER:
    result = pDoc->GetRecordAddressDB4(obj)->Edit(locr, obj);
    break;
  case dbTELEPORTER:
    {
      Edit_Teleporter dlg(obj, locr);
      //dlg.m_pDB1 = pDoc->GetRecordAddressDB1(obj);
      result = dlg.DoModal();
    };
    break;
  case dbCHEST:
    {
      EditChest dlg(locr);
      dlg.m_pDB9 = pDoc->GetRecordAddressDB9(obj);
      result = dlg.DoModal();
    };
    break;
  case dbDOOR:
    {
      EditDoor dlg(locr);
      dlg.m_pDB0 = pDoc->GetRecordAddressDB0(obj);
      result = dlg.DoModal();
    };
    break;
  case dbSCROLL:
    {
      EditScroll dlg(levelInfo);
      RN txt;
      dlg.m_pScroll = pDoc->GetRecordAddressDB7(obj);
      txt = dlg.m_pScroll->text();
      dlg.m_title.Format("Edit Scroll[%d][%d][%d][%d]",
                         obj.ConvertToInteger(),
                         obj.dbIndex(),
                         txt.ConvertToInteger(),
                         txt.dbIndex());
      return dlg.DoModal();//Sets Modified Flag
    }
  default:
    NotImplemented();
    return IDCANCEL;
  };
  if (result == IDOK)
  {
    OBJECT_CHECKPOINT newCheckpoint(obj, RoomType(locr), &locr);
    if (!(oldCheckpoint == newCheckpoint)) MODIFY
  }
  else
  {
    oldCheckpoint.RebuildObject(obj);
  };
  return IDOK;
}



int EditOrphan(RN obj)
{
  //Return 1 to delete the object.
  LEVELINFO levelInfo;
  DBTYPE dbType;
  LOCATIONREL locr;
  locr.l(0);
  locr.x(0);
  locr.y(0); //A valid location.  Best we can do since
             //this object is nowhere referenced.
  int result = 0;
  result = MessageBox(NULL,
                      "Do you want to delete this object?\n"
                      "Click 'No' to edit the object.",
                      "Repairing valid Orphan",
                      MB_YESNO | MB_TOPMOST);
  if (result == IDYES) return 1;
  //OBJECT_CHECKPOINT oldCheckpoint(obj,RoomType(locr),&locr);
  levelInfo = locr;
  dbType = obj.dbType();
  switch (dbType)
  {
  case dbTEXT:
    {
      EditText dlg;
      dlg.m_object = obj;
      //dlg.m_locr = locr;
      //switch (RoomType(locr))
      //{
      //case roomOPEN:
      //case roomTELEPORTER:
      //case roomDOOR:
      //case roomSTAIRS:
        dlg.m_textType = TEXTTYPE_MIRROR;
      //  break;
      //case roomFALSEWALL:
      //case roomSTONE:
      //  dlg.m_textType = TEXTTYPE_WALL;
      //  break;
      //default:
      //  Strange("Unknown Text Type");
      //  return IDCANCEL;
      //};
      dlg.DoModal(); //Sets Modified Flag
    };
    break;
  case dbACTUATOR:
    //DB3::Edit sets Modified Flag
    pDoc->GetRecordAddressDB3(obj)->Edit(locr, obj);
    break;
  case dbWEAPON:
    pDoc->GetRecordAddressDB5(obj)->Edit(locr, obj);
    break;
  case dbMISC:
    pDoc->GetRecordAddressDB10(obj)->Edit(locr, obj);
    break;
  case dbPOTION:
    pDoc->GetRecordAddressDB8(obj)->Edit(locr, obj);
    break;
  case dbCLOTHING:
    pDoc->GetRecordAddressDB6(obj)->Edit(locr, obj);
    break;
  case dbMONSTER:
    pDoc->GetRecordAddressDB4(obj)->Edit(locr, obj);
    break;
  case dbTELEPORTER:
    {
      Edit_Teleporter dlg(obj, locr);
      //dlg.m_pDB1 = pDoc->GetRecordAddressDB1(obj);
      dlg.DoModal();
    };
    break;
  case dbCHEST:
    {
      EditChest dlg(locr);
      dlg.m_pDB9 = pDoc->GetRecordAddressDB9(obj);
      dlg.DoModal();
    };
    break;
  case dbDOOR:
    {
      EditDoor dlg(locr);
      dlg.m_pDB0 = pDoc->GetRecordAddressDB0(obj);
      dlg.DoModal();
    };
    break;
  case dbSCROLL:
    {
      EditScroll dlg(levelInfo);
      RN txt;
      dlg.m_pScroll = pDoc->GetRecordAddressDB7(obj);
      txt = dlg.m_pScroll->text();
      dlg.m_title.Format("Edit Scroll[%d][%d][%d][%d]",
                         obj.ConvertToInteger(),
                         obj.dbIndex(),
                         txt.ConvertToInteger(),
                         txt.dbIndex());
      dlg.DoModal();//Sets Modified Flag
    }
    break;
  default:
    NotImplemented();
    break;
  };
  return 0;
}