// SelectDSA.cpp : implementation file
//

#include "stdafx.h"
#include "CSBuild.h"
#include "CSBuildDoc.h"
#include "SelectDSA.h"
#include "misc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SelectDSA dialog


SelectDSA::SelectDSA(int level, CWnd* pParent /*=NULL*/)
	: CDialog(SelectDSA::IDD, pParent)
{
	//{{AFX_DATA_INIT(SelectDSA)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
  m_level = level;
}


void SelectDSA::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SelectDSA)
	DDX_Control(pDX, IDC_DSAList, m_DSAList);
	//}}AFX_DATA_MAP
  if (!pDX->m_bSaveAndValidate) BuildList();
}


BEGIN_MESSAGE_MAP(SelectDSA, CDialog)
	//{{AFX_MSG_MAP(SelectDSA)
	ON_LBN_DBLCLK(IDC_DSAList, OnDblclkDSAList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SelectDSA message handlers


void SelectDSA::BuildList(void)
{
  int i;
  CString text;
  m_DSAList.ResetContent();
  if (m_level < 0)
  {
    for (i=0; i<256; i++)
    {
      if (pDoc->getDSA(i) == NULL)
      {
        text.Format("%03d",i);
      }
      else
      {
        text.Format("%03d %s",i,pDoc->getDSA(i)->Description());
      }
      m_DSAList.AddString(text);
    };
  }
  else
  {
    for (i=0; i<32; i++)
    {
      if (pDoc->getDSA(m_level, i) == 0xffff)
      {
        text.Format("%d ffff", i);
      }
      else
      {
        if (pDoc->getDSA(pDoc->getDSA(m_level,i)) == NULL)
        {
          text.Format("%d %d undefined",
                      i,
                      pDoc->getDSA(m_level,i));
        }
        else
        {
          text.Format("%d %d %s",
                      i,
                      pDoc->getDSA(m_level, i),
                      pDoc->getDSA(pDoc->getDSA(m_level,i))->Description());
        };
      };
      m_DSAList.AddString(text);
    };
  };
}


void SelectDSA::OnOK() 
{
	// TODO: Add extra validation here
	m_DSAindex = m_DSAList.GetCurSel();
  if (m_DSAindex < 0)
  {
    NoSelection();
    return;
  };
	CDialog::OnOK();
}

void SelectDSA::OnDblclkDSAList() 
{
	// TODO: Add your control notification handler code here
	OnOK();
}
