#if !defined(AFX_VIEWLEVELINFO_H__62CA2000_D636_11D6_A264_D6529BA4F63D__INCLUDED_)
#define AFX_VIEWLEVELINFO_H__62CA2000_D636_11D6_A264_D6529BA4F63D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ViewLevelInfo.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// ViewLevelInfo dialog

class ViewLevelInfo : public CDialog
{
// Construction
public:
	ViewLevelInfo(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(ViewLevelInfo)
	enum { IDD = IDD_LevelInfo };
	CListBox	m_doorDecoration;
	CListBox	m_FloorList;
	CListBox	m_MonsterList;
	CListBox	m_WallDecorations;
	UINT	m_Height;
	UINT	m_Width;
	UINT	m_OffsetX;
	UINT	m_OffsetY;
	UINT	m_RandomWall;
	UINT	m_RandomFloor;
	UINT	m_experienceMultiplier;
	int		m_door1Type;
	int		m_door2Type;
	UINT	m_currentLevel;
	UINT	m_defaultSkin;
	//}}AFX_DATA
  int m_wallDecorationCount[16];
  int m_floorDecorationCount[16];
  int m_doorDecorationCount[16];
  int m_monsterCount[16];
  int m_generatorCount[16];

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ViewLevelInfo)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
  void CountMonstersAndDecorations(void);
  void FillWallDecorations(void);
  void FillMonsterList(void);
  void FillFloorDecorations(void);
  void FillDoorDecorations(void);
  void ExtractDataFromRecord(void);
  void EncodeDataIntoRecord(void);
  void Show(int id, bool show);
  void PopListItem(int offset,
                   CListBox *box, 
                   char *msg);
  void RandomDecorations(ROOMTYPE, bool place);
  void ExportLevel(FILE *f);
  void ImportLevel(FILE *f);

	// Generated message map functions
	//{{AFX_MSG(ViewLevelInfo)
	virtual void OnOK();
	afx_msg void OnAddColumn();
	afx_msg void OnAddRow();
	virtual BOOL OnInitDialog();
	afx_msg void OnNewFloor();
	afx_msg void OnNewWall();
	afx_msg void OnNewMonster();
	afx_msg void OnEditDSAList();
	afx_msg void OnNewDoorDecoration();
	afx_msg void OnReplaceDoorDecoration();
	afx_msg void OnReplaceFloor();
	afx_msg void OnReplaceWall();
	afx_msg void OnReplaceMonster();
	afx_msg void OnWallDecorationsEverywhere();
	afx_msg void OnWallDecorationsNowhere();
	afx_msg void OnFloorDecorationsEverywhere();
	afx_msg void OnFloorDecorationsNowhere();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnEditPalette();
	afx_msg void OnChangeCurrentLevel();
	afx_msg void OnDeltaposSpinLevel(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnExportLevel();
	afx_msg void OnImport();
	afx_msg void OnEditSpecialLocations();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIEWLEVELINFO_H__62CA2000_D636_11D6_A264_D6529BA4F63D__INCLUDED_)
