#include "stdafx.h"
//#include "types.h"
#include "misc.h"
#include "CSBuildView.h"
#include "CSBuildDoc.h"

AFX_INLINE UINT AFXAPI HashKey(CString& str)
{
  int i, len;
  unsigned int result;
  len = str.GetLength();
  result = len;
  for (i=0; (i<2)&&(i<len); i++) result = result*19 + str[i];
  for (i=len-1; (i>len-2)&&(i>=0); i--)result = result*19 + str[i];
  return result;
}


class ObjectNameTranslateTable
{
public:
  CMap<CString, CString&, CString, CString&> objXlate;
  ObjectNameTranslateTable(void);
  CString Xlate(const CString& name)
  {
    CString lowname, result;
    lowname = name;
    lowname.MakeLower();
    if (objXlate.Lookup(lowname,result)) return result;
    else return name;
  };
};

CString Trim(CString& str)
{
  int front, end;
  for (front=0; str[front]==' '; front++){};
  for (end=str.GetLength()-1; str[end]==' '; end--){};
  return str.Mid(front, end-front+1);
}

ObjectNameTranslateTable::ObjectNameTranslateTable(void)
{
  FILE *f;
  char line[81];
  int comma, len, term;
  CString key, value;
  f = fopen("objnames.txt","r");
  if (f == NULL) return;
  while (fgets(line,80,f)!=NULL)
  {
    //look for a comma
    len = strlen(line);
    for (comma=0; line[comma]!=0; comma++)
    {
      if (line[comma] == '#') break;
      if (line[comma] == ',') break;
      if (line[comma] == '\n') break;
    };
    if (line[comma] != ',') continue;
    key = CString(line, comma);
    key = Trim(key);
    key.MakeLower();
    for (term=comma+1; line[term]!=0; term++)
    {
      if (line[term] == '#') break;
      if (line[term] == '\n') break;
    };
    if (term == comma+1) continue;
    value = CString(line+comma+1, term-comma-1);
    value = Trim(value);
    objXlate.SetAt(key, value);
  };
  fclose(f);
}

ObjectNameTranslateTable objectNameTranslateTable;

CString TranslateObjectName(const char *name)
{
  return objectNameTranslateTable.Xlate(name);
}

struct TARGET
{
  TARGETTYPE   type; //0=A/1=B/2=explicit
  LOCATIONREL  target;
};

extern char ExtendedFeaturesVersion;

char *colName[12] = {"S0","C0","T0","S1","C1","T1","S2","C2","T2","S3","C3","T3"};

void setmodifiedflag(void)
{
  pDoc->SetModifiedFlag();
}

//*********************************************** RN
//
//*********************************************** RN
bool RN::IsMagicSpell(void) const
{
  return indirectIndex>=RNFireball;
}
/*
bool RN::IsCloned(void) const
{
  ASSERT(IsIndirectIndexOK());
  return pDoc->IsDataCloned(indirectIndex);
}

void RN::IsCloned(bool b)
{
  ASSERT(IsIndirectIndexOK());
  pDoc->IsDataCloned(indirectIndex, b);
}
*/
RN::RN(enum RNVAL i)
{
  ASSERT((i>=RNFireball) || (i==0));
  indirectIndex = (ui16)i;
}

void RN::ConstructFromInteger(i32 v) 
{
  indirectIndex = (ui16)v;
  ASSERT(IsIndirectIndexOK());
}

void RN::NonExtendedInteger(i32 v) 
{
  indirectIndex = (ui16)v;
}

DBTYPE RN::dbType(void) const 
{
  ASSERT(IsIndirectIndexOK());
  return pDoc->DataType(indirectIndex);
}

bool RN::operator !=(RNVAL i) const 
{
  ASSERT((i>=RNFireball) || (i==0));
  return indirectIndex != i;
}

bool RN::operator ==(RNVAL i) const 
{
  ASSERT((i>=RNFireball) || (i==0));
  return indirectIndex == i;
}

ui8 RN::pos(void) const 
{
  ASSERT (IsIndirectIndexOK());
  return (ui8 )pDoc->DataPosition(indirectIndex);
}

RN::RN(DBTYPE dbType, int dbIndex)
{
  indirectIndex = pDoc->AllocateIndirectIndex(dbType, dbIndex);
}

ui8 RN::dbNum(void) const 
{
  ASSERT(IsIndirectIndexOK());
  return (ui8)pDoc->DataType(indirectIndex);
}

ui16 RN::dbIndex(void) const 
{
  ASSERT(IsIndirectIndexOK());
  return pDoc->DataDBIndex(indirectIndex);
}

void RN::Delete(LOCATIONREL *plocr)
{
  RN contents, possessions;
  DB7 *pScroll;
  RN RNtext;
  DB9 *pChest;
  DB4 *pMonster;
  DB3 *pActuator;
  ACTUATORCLASS ac;
  TIMER *pTimer;
  int i;
  ASSERT(pDoc->GetDBRecordLink(*this) == RNeof);
  switch (dbType())
  {
  case dbTEXT:
    pDoc->RemoveText(pDoc->GetRecordAddressDB2(*this));
    pDoc->Delete(*this, 0x12abc);
    break;
  case dbSCROLL:
    pScroll = pDoc->GetRecordAddressDB7(*this);
    RNtext = pScroll->text();
    pDoc->DeleteObjectFromList(RNtext, pScroll->pText(), true);
    pDoc->Delete(*this, 0x12abc);
    break;
  case dbACTUATOR:
    //if disabled generator then find and delete timer entry
    pActuator = pDoc->GetRecordAddressDB3(*this);
    if (plocr == NULL) ac = AC_UNKNOWN;
    else ac = pActuator->actuatorClass(RoomType(*plocr));
    switch (ac)
    {
    case AC_DISABLED:
      for (i=0; i<pDoc->NumTimers(); i++)
      {
        pTimer = pDoc->Timer(i);
        if (pTimer->timerFunction != timerFunction65) continue;
        if ((unsigned)plocr->l() != ((pTimer->time >> 24) & 0xff)) continue;
        if (plocr->x != pTimer->uByte6) continue;
        if (plocr->y != pTimer->uByte7) continue;
        //locr.p = pTimer->uByte8;
        pDoc->DeleteTimer(pTimer);
      };
      break;
    default: break;
    };
    pDoc->Delete(*this, 0x12abc);
    break;
  case dbCHEST:
    pChest = pDoc->GetRecordAddressDB9(*this);
    while (pChest->contents() != RNeof)
    {
      pDoc->DeleteObjectFromList(pChest->contents(),
                                 pChest->pContents(),
                                 true);
    };
    pDoc->Delete(*this, 0x12abc);
    break;
  case dbMONSTER:
    pMonster = pDoc->GetRecordAddressDB4(*this);
    while (pMonster->possession() != RNeof)
    {
      pDoc->DeleteObjectFromList(pMonster->possession(),
                                 pMonster->pPossession(),
                                 true);
    };
    pDoc->Delete(*this, 0x12abc);
    break;
  default:
    pDoc->Delete(*this, 0x12abc);
    break;
  };
}
  //dbA3 = GetCommonAddress(curObj);
  //ASSERT(GetDBRecordLink(nextObj) != RNnul);
  //dbA3->link(GetDBRecordLink(nextObj));
  //dbA3 = GetCommonAddress(objD7);
  //dbA3->link(Release ? RNnul : RNeof);
  

bool RN::IsIndirectIndexOK(void) const
{
  return (indirectIndex!=0)&&(indirectIndex<pDoc->dataMapLength());
}

bool RN::IsDBIndexOK(void) const 
{
  if (!IsIndirectIndexOK()) return false;
  return pDoc->IsDBIndexOK(indirectIndex);
}

ui16 RN::ConvertToInteger(void) const 
{
  return indirectIndex;
}

bool RN::IsSpell(void) const 
{
  return   (indirectIndex>=RNFireball) 
         &&( indirectIndex<RNeof);
}

void RN::pos(ui32 pos) 
{
  pDoc->DataPosition(indirectIndex, pos);
}

CString RN::Name(ROOMTYPE rt) const
{
  CString result;
  DBTYPE dbtype;
  dbtype = dbType();
  switch (dbtype)
  {
  case dbTEXT:
    return CString ("Text");
  case dbTELEPORTER:
    {
      DB1 *pDB1;
      pDB1 = pDoc->GetRecordAddressDB1(*this);
      return pDB1->Name();
    };
  case dbMONSTER:
    {
      MONSTERTYPE mt;
      DB4 *pDB4;
      pDB4 = pDoc->GetRecordAddressDB4(*this);
      mt = pDB4->monsterType();
      result = mt.Name();
      return result;
    };
  case dbWEAPON:
  case dbPOTION:
  case dbMISC:
  case dbCLOTHING:
    {
      MODIFIEDOBJECTTYPE mot(*this);
      result = CString(mot.Name());
      if (result == "BONES(PARTY)")
      {
        DB10 *pDB10;
        int value;
        CString party;
        pDB10 = pDoc->GetRecordAddressDB10(*this);
        value = pDB10->value();
        party.Format("-%c",value+'A');
        result += party;
      };
      return result;
    };
  case dbACTUATOR:
    {
      DB3 *pDB3;
      pDB3 = pDoc->GetRecordAddressDB3(*this);
      return pDB3->Name(rt); //How would we know the roomtype?
    };
  case dbSCROLL:
    {
      DB7 *pDB7;
      RN RNtext;
      DB2 *pDB2;
      CString rawline, line;
      pDB7 = pDoc->GetRecordAddressDB7(*this);
      RNtext = pDB7->text();
      if (RNtext.dbType() == dbTEXT)
      {
        pDB2 = pDoc->GetRecordAddressDB2(RNtext);
        if (pDB2->ValidText())
        {
          rawline = pDoc->GetRawText(RNtext, TEXTTYPE_SCROLL);
          line = DecodeText(rawline, TEXTTYPE_SCROLL);
          line.Replace("\n"," ");
          line = CString("Scroll \"") + line + "\"";
          return line;
        };
      };
      return CString("Scroll(illegal)");
    };
  case dbDOOR:
    {
      DB0 *pDB0;
      pDB0 = pDoc->GetRecordAddressDB0(*this);
      return pDB0->Name();
    };

  default:
    return CString("Name Unknown");
  };
}

bool RN::IsSameObjectAs(RN obj) const 
{
  int i1, i2;
  ASSERT(IsIndirectIndexOK());
  ASSERT(IsDBIndexOK());
  ASSERT(obj.IsDBIndexOK());
  if (indirectIndex == obj.indirectIndex) return true;
  i1 = pDoc->DataDBIndex(indirectIndex);
  i2 = pDoc->DataDBIndex(obj.indirectIndex);
  if (i1 == i2)
  {
    if(pDoc->DataType(indirectIndex)==pDoc->DataType(obj.indirectIndex))
    {
      //ASSERT(pDoc->DataPosition(indirectIndex)==pDoc->DataPosition(obj.indirectIndex));
      return true;
    };
  };
  return false;
}

 


//*********************************************** DB0
//
//*********************************************** DB0

DB0& DB0::operator =(DB0& /*db0*/)
{
  InternalError("DB0 operator =");
  return *this;
}

//*********************************************** DB1
//
//*********************************************** DB1

DB1& DB1::operator =(DB1& /*db1*/)
{
  InternalError("DB1 operator =");
  return *this;
}


//*********************************************** DB2
//
//*********************************************** DB2

DB2& DB2::operator =(DB2& /*db2*/)
{
  InternalError("DB2 operator =");
  return *this;
}

//*********************************************** DB3
//
//*********************************************** DB3
DB3& DB3::operator =(const DB3& db3)
{
  InternalError();
  m_word2 = db3.m_word2;
  m_word4 = db3.m_word4;
  m_word6 = db3.m_word6;
  return *this;
}



//*********************************************** DB4
//
//*********************************************** DB4

DB4::DB4(void)
{
  Clear();
}


DB4& DB4::operator =(DB4& /*db4*/)
{
  InternalError("DB4 operator =");
  return *this;
}


//*********************************************** DB5
//
//*********************************************** DB5

DB5& DB5::operator =(DB5& /*db5*/)
{
  InternalError("DB5 operator =");
  return *this;
}


//*********************************************** DB6
//
//*********************************************** DB6

DB6& DB6::operator =(DB6& /*db6*/)
{
  InternalError("DB6 operator =");
  return *this;
}



//*********************************************** DB7
//
//*********************************************** DB7

DB7::DB7(void)
{
  Clear();
}

DB7& DB7::operator =(DB7& /*db7*/)
{
  InternalError("DB7 operator =");
  return *this;
}


//*********************************************** DB8
//
//*********************************************** DB8

DB8& DB8::operator =(DB8& /*db8*/)
{
  InternalError("DB8 operator =");
  return *this;
}



//*********************************************** DB9
//
//*********************************************** DB9

DB9::DB9(void)
{
  Clear();
}

DB9::~DB9(void)
{
  if (m_contents != RNeof)
      InternalError("DB9 Destructor.  Chest not empty");
}

DB9& DB9::operator =(DB9& /*db9*/)
{ 
  InternalError("DB9 operator =");
  return *this;
}


//*********************************************** DB10
//
//*********************************************** DB10

DB10& DB10::operator =(DB10& /*db10*/)
{
  InternalError("DB10 operator =");
  return *this;
}



//*********************************************** FLOORTYPE
//
//*********************************************** FLOORTYPE
static char *FloorNames[] =
{
	"SQUARE DRAIN",
	"SQUARE PAD",
	"POISON PUDDLE",
	"ROUND GRID",
	"HEXAGONAL PAD",
	"FIRE POT",
	"GREY MARK",
	"TINY PAD",
	"WATER PUDDLE"
};

FLOORTYPE::FLOORTYPE(int floortypeIndex)
{
  if (  (floortypeIndex <= floor_2small)
      ||(floortypeIndex >= floor_2large))
  {
    InternalError("Illegal floortype index");
    m_floorType = floor_2small;
  }
  else
  {
    m_floorType = (m_FLOORTYPE)(floortypeIndex);
  };
}

FLOORTYPE::FLOORTYPE(m_FLOORTYPE floorType)
{
  m_floorType = floorType;
}

CString FLOORTYPE::Name(void)
{
  CString name;
  if (  (m_floorType <= floor_2small)
      ||(m_floorType >= floor_2large) )
  {
    InternalError("Illegal Floor Type");
    return "Illegal";
  };
  name = FloorNames[m_floorType];
  return objectNameTranslateTable.Xlate(name);
}

void FLOORTYPE::FirstType(void)
{
  m_floorType = (m_FLOORTYPE)(floor_2small+1);
}

bool FLOORTYPE::IsLegal(int floortype)
{
  return     (floortype < floor_2large)
          && (floortype > floor_2small);
}

bool FLOORTYPE::IsLegal(void)
{
  return IsLegal(m_floorType);
}

void FLOORTYPE::NextType(void)
{
  m_floorType = m_FLOORTYPE(m_floorType+1);
}
 
int NumFloorTypes(void)
{
  return sizeof(FloorNames)/sizeof(FloorNames[0]);
}

FLOORTYPE& FLOORTYPE::operator =(const char *name)
{
  int i;
  for (i=0; i<sizeof(FloorNames)/sizeof(FloorNames[0]);i++)
  {
    if (strcmp(name, FloorNames[i])==0)
    {
      m_floorType = (m_FLOORTYPE)i;
      return *this;
    };
  };
  InternalError("Unknown floortype name");
  m_floorType = floor_2small;
  return *this;
}


//*********************************************** ORNATETYPE
//
//*********************************************** ORNATETYPE

static char *ornateNames[12] =
{
	"Square Grid",
	"Metal Bars",
	"Jewels",
	"Wood Ven",
	"Arched Grid",
	"Block Lock",
	"Corner Metal",
	"Ebony",
	"Red Triangle Lock",
	"Trianngle Lock",
	"Blue Force Field",
	"Damaged Metal"
};

void ORNATETYPE::FirstType(void)
{
  m_ornateType = (m_ORNATETYPE)(ornate_2small+1);
}

bool ORNATETYPE::IsLegal(void)
{
  return     (m_ornateType < ornate_2large)
          && (m_ornateType > ornate_2small);
}

void ORNATETYPE::NextType(void)
{
  m_ornateType = m_ORNATETYPE(m_ornateType+1);
}
 
CString ORNATETYPE::Name(void)
{
  CString name;
  name = ornateNames[m_ornateType];
  return objectNameTranslateTable.Xlate(name);
}

int NumOrnateTypes(void)
{
  return sizeof(ornateNames)/sizeof(ornateNames[0]);
}

ORNATETYPE& ORNATETYPE::operator =(const char *name)
{
  int i;
  for (i=0; i<sizeof(ornateNames)/sizeof(ornateNames[0]);i++)
  {
    if (stricmp(name, ornateNames[i])==0)
    {
      m_ornateType = (m_ORNATETYPE)i;
      return *this;
    };
  };
  InternalError("Unknown ornatetype name");
  FirstType();//m_ornateType = ornate_2small+1;
  return *this;
}

ORNATETYPE::ORNATETYPE(int ornatetypeIndex)
{
  if (  (ornatetypeIndex <= ornate_2small)
      ||(ornatetypeIndex >= ornate_2large))
  {
    InternalError("Illegal ornatetype index");
    FirstType();
  }
  else
  {
    m_ornateType = (m_ORNATETYPE)ornatetypeIndex;
  };
}

ORNATETYPE::ORNATETYPE(m_ORNATETYPE ornateType)
{
  if (  (ornateType <= ornate_2small)
      ||(ornateType >= ornate_2large))
  {
    InternalError("Illegal ornatetype index");
    FirstType();
  }
  else
  {
    m_ornateType = ornateType;
  };
}



//*********************************************** WALLTYPE
//
//*********************************************** WALLTYPE
static char *wallDecorationNames[60] =
{
  "Garbled Text",
  "Square Alcove",
  "VI Altar",
  "Ornate Alcove",
  "Hook",
  "Block Lock",
  "Iron Ring",
  "Small Switch",
  "Dent 1",
  "Dent 2",
  "Wood Ring",
  "Crack",
  "Slime Outlet",
  "Point",
  "Tiny Switch",
  "Green Button(Out)",
  "Blue Button(Out)",
  "Coin Slot",
  "Double Lock",
  "Square Lock",
  "Winged Lock",
  "Onyx Lock",
  "Stone Lock",
  "Cross Lock",
  "Jeweled Lock",
  "Skeleton Lock",
  "Gold Lock",
  "Turquoise Lock",
  "Emerald Lock",
  "Ruby Lock",
  "RA Lock",
  "Master Lock",
  "Gem Hole",
  "Slime",
  "Grate",
  "Fountain",
  "Manacles",
  "Demon Face",
  "Torch Holder(Empty)",
  "Dragon Claws",
  "Poison Holes",
  "Fireball Holes",
  "Dagger Holes",
  "Picture Frame",
  "Lever(Up)",
  "Lever(Down)",
  "Torch Holder(Full)",
  "Red Button(Out)",
  "Eye Switch",
  "Big Switch(Out)",
  "Crack Switch(Out)",
  "Green Buton(In)",
  "Blue Button(In)",
  "Red Button(In)",
  "Big Switch(In)",
  "Crack Switch(In)",
  "Amalgam",
  "Powered Amalgam",
  "Burnt Amalgam",
  "Evil Outside"
};

CString WALLTYPE::Name(void)
{
  CString name;
  name = wallDecorationNames[m_wallType];
  return objectNameTranslateTable.Xlate(name);
}

WALLTYPE::WALLTYPE(int walltypeIndex)
{
  if (  (walltypeIndex <= wall_2small)
      ||(walltypeIndex >= wall_2large))
  {
    InternalError("Illegal walltype index");
    FirstType();
  }
  else
  {
    m_wallType = (m_WALLTYPE)walltypeIndex;
  };
}

WALLTYPE::WALLTYPE(m_WALLTYPE wallType)
{
  if (wallType == wall_2small)
  {
    FirstType();
  }
  else
  {
    if (  (wallType <= wall_2small)
        ||(wallType >= wall_2large))
    {
      InternalError("Illegal walltype index");
      FirstType();
    }
    else
    {
      m_wallType = wallType;
    };
  };
}

WALLTYPE& WALLTYPE::operator =(const char *name)
{
  int i;
  for (i=0; 
       i<sizeof(wallDecorationNames)/sizeof(wallDecorationNames[0]);
       i++)
  {
    if (stricmp(name, wallDecorationNames[i])==0)
    {
      m_wallType = (m_WALLTYPE)i;
      return *this;
    };
  };
  InternalError("Unknown walltype name");
  FirstType();
  return *this;
}

void WALLTYPE::FirstType(void)
{
  m_wallType = (m_WALLTYPE)(wall_2small+1);
}

bool WALLTYPE::IsLegal(void)
{
  return   IsLegal(m_wallType);
}

bool WALLTYPE::IsLegal(int walltype)
{
  return     (walltype < wall_2large)
          && (walltype > wall_2small);
}

void WALLTYPE::NextType(void)
{
  m_wallType = m_WALLTYPE(m_wallType+1);
}
 
bool WALLTYPE::IsAlcove(void)
{
  return    (m_wallType >= wall_SquareAlcove)
         && (m_wallType <= wall_OrnateAlcove);
}

//****************************************** MODIFIEDOBJECTTYPE
//
//****************************************** MODIFIEDOBJECTTYPE

struct OBJDESC
{
  int objectType; // the MODIFIEDOBJECTTYPE
  char *objectName[2]; //CSBname, DMname
  //int carryLocations;
};
//***********************************
//
// This is normally part of graphic #0x22f
//
//***********************************
//
// This is normally part of graphic #0x22f
//
OBJDESC objDesc[180] = 
{
  { 30, "Scroll",                 "Scroll"},
  //{ 31, "Scroll",                 "Scroll"},
  {144, "Chest",                  "Chest"},
  {148, "Mon Potion(Stamina)",    "Mon Potion(Stamina)"},
  {149, "Um Potion",              "Um Potion"},
  {150, "Des Potion",             "Des Potion"},
  {151, "Ven Potion(Poison)",     "Ven Potion(Poison)"},
  {152, "Sar Potion",             "Sar Potion"},
  {153, "Zo Potion",              "Zo Potion"},
  {154, "Ros Potion(Dexterity)",  "Ros Potion(Dexterity)"},
  {155, "Ku potion(Strength)",    "Ku potion(Strength)"},
  {156, "Dane Potion(Wisdom)",    "Dane Potion(Wisdom)"},
  {157, "Neta Potion(Vitality",   "Neta Potion(Vitality"},
  {158, "Antivenin(Cure Poison)", "Bro Potion"},
  {159, "Mon Potion(Stamina)",    "Ma Potion"},
  {160, "Ya Potion(Magic Shield)","Ya Potion(Magic Shield)"},
  {161, "Ee Potion(Mana)",        "Ee Potion(Mana)"},
  {162, "Vi Potion(Health)",      "Vi Potion(Health)"},
  {163, "Water Flask",            "Water Flask"},
  {164, "Kath Bomb",              "Kath Bomb"},
  {165, "Pew Bomb",               "Pew Bomb"},
  {166, "Ra Bomb",                "Ra Bomb"},
  {167, "Ful Bomb",               "Ful Bomb"},
  {195, "Empty Flask",            "Empty Flask"},
  { 16, "Eye of Time",            "Eye of Time"},
  { 18, "Stormring",              "Stormring"},
  {  4, "Torch",                  "Torch"},
  { 14, "Flamitt",                "Flamitt"},
  { 20, "Staff of Claws",         "Staff of Claws"},
  { 23, "Storm",                  "Bolt Blade"},
  { 25, "Ra Blade",               "Fury"},
  { 27, "The Firestaff",          "The Firestaff"},   //30
  { 32, "Dagger",                 "Dagger"},
  { 33, "Falchion",               "Falchion"},
  { 34, "Sword",                  "Sword"},
  { 35, "Rapier",                 "Rapier"},
  { 36, "Biter",                  "Sabre"},
  { 37, "Samurai Sword",          "Samurai Sword"},
  { 38, "Side Splitter",          "Delta"},
  { 39, "Diamond Edge",           "Diamond Edge"},
  { 40, "Vorpal Blade",           "Vorpal Blade"},
  { 41, "Dragon Fang",            "Dragon Fang"},    //40
  { 42, "Axe",                    "Axe"},
  { 43, "Executioner",            "Executioner"},
  { 44, "Mace",                   "Mace"},
  { 45, "Mace of Order",          "Mace of Order"},
  { 46, "Morningstar",            "Morningstar"},
  { 47, "Club",                   "Club"},
  { 48, "Stone Club",             "Stone Club"},
  { 49, "Claw Bow",               "Bow"},
  { 50, "Crossbow",               "Crossbow"},
  { 51, "Arrow",                  "Arrow"},           //50
  { 52, "Slayer",                 "Slayer"},
  { 53, "Sling",                  "Sling"},
  { 54, "Rock",                   "Rock"},
  { 55, "Poison Dart",            "Poison Dart"},
  { 56, "Throwing Star",          "Throwing Star"},
  { 57, "Stick",                  "Stick"},
  { 58, "Staff",                  "Staff"},
  { 59, "Wand",                   "Wand"},
  { 60, "Teowand",                "Teowand"},
  { 61, "Yew Staff",              "Yew Staff"},        //60
  { 62, "Staff of Irra",          "Staff of Manar"},
  { 63, "Cross of Neta",          "Snake Staff"},
  { 64, "Serpent Staff",          "Conduit"},
  { 65, "Dragon Spit",            "Dragon Spit"},
  { 66, "Sceptre of Lyf",         "Sceptre of Lyf"},
  {135, "Horn of Fear",           "Horn of Fear"},
  {143, "Speedbow",               "Speedbow"},
  { 28, "The Firestaff+",         "The Firestaff+"},
  { 80, "Cape",                   "Cape"},
  { 81, "Cloak of Night",         "Cloak of Night"},   //70
  { 82, "Tattered Pants",         "Tattered Pants"},
  {112, "Sandals",                "Sandals"},
  {114, "Leather Boots",          "Leather Boots"},
  { 67, "Tattered Shirt",         "Robe(Body)"},
  { 83, "Robe",                   "Robe"},
  { 68, "Fine Robe(top)",         "Fine Robe(top)"},
  { 84, "Fine Robe(bottom)",      "Fine Robe(bottom)"},
  { 69, "Kirtle",                 "Kirtle"},
  { 70, "Silk Shirt",             "Silk Shirt"},
  { 85, "Tabard",                 "Tabard"},           //80
  { 86, "Gunna",                  "Gunna"},
  { 71, "Elven Doublet",          "Elven Doublet"},
  { 87, "Elven Huke",             "Elven Huke"},
  {119, "Elven Boots",            "Elven Boots"},
  { 72, "Leather Jerkin",         "Leather Jerkin"},
  { 88, "Leather Pants",          "Leather Pants"},
  {113, "Suede Boots",            "Suede Boots"},
  { 89, "Blue Pants",             "Blue Pants"},
  { 73, "Tunic",                  "Tunic"},
  { 74, "Ghi",                    "Ghi"},              //90
  { 90, "Ghi Trousers",           "Ghi Trousers"},
  {103, "Calista",                "Calista"},
  {104, "Crown of Nerra",         "Crown of Nerra"},
  { 96, "Bezerker Helm",          "Bezerker Helm"},
  { 97, "Helmet",                 "Helmet"},
  { 98, "Basinet",                "Basinet"},
  {105, "Neta Shield",            "Buckler"},
  {106, "Crystal Shield",         "Hide Shield"},
  {108, "Wooden Shield",          "Wooden Shield"},
  {107, "Small Shield",           "Small Shield"},    //100
  { 75, "Mail Aketon",            "Mail Aketon"},
  { 91, "Leg Mail",               "Leg Mail"},
  { 76, "Mithral Aketon",         "Mithral Aketon"},
  { 92, "Mithral Mail",           "Mithral Mail"},
  { 99, "Casque 'n Coif",         "Casque 'n Coif"},
  {115, "Hosen",                  "Hosen"},
  {100, "Armet",                  "Armet"},
  { 77, "Torso Plate",            "Torso Plate"},
  { 93, "Leg Plate",              "Leg Plate"},
  {116, "Foot Plate",             "Foot Plate"},      //110
  {109, "Sar Shield",             "Large Shield"},
  {101, "Helm of Ra",             "Helm of Lyte"},
  { 78, "Plate of Ra",            "Plate of Lyte"},
  { 94, "Poleyn of Ra",           "Poleyn of Lyte"},
  {117, "Greave of Ra",           "Greave of Lyte"},
  {110, "Shield of Ra",           "Shield of Lyte"},
  {102, "Dragon Helm",            "Helm of Darc"},
  { 79, "Dragon Plate",           "Plate of Darc"},
  { 95, "Dragon Poleyn",          "Poleyn of Darc"},
  {118, "Dragon Greave",          "Greave of Darc"},  //120
  {111, "Dragon Shield",          "Shield of Darc"},
  {140, "Dexhelm",                "Dexhelm"},
  {141, "Flamebain",              "Flamebain"},
  {142, "Powertowers",            "Powertowers"},
  {194, "Boots of Speed",         "Boots of Speed"},
  {196, "Halter",                 "Halter"},
  {  0, "Compass",                "Compass"},
  {  8, "Waterskin",              "Waterskin"},
  { 10, "Jewel Symal",            "Jewel Symal"},
  { 12, "Illumulet",              "Illumulet"},       //130
  {146, "Ashes",                  "Ashes"},
  {147, "Bones(Party)",           "Bones(Party)"},
  {125, "Sar Coin",               "Copper Coin"},
  {126, "Silver Coin",            "Silver Coin"},
  {127, "Gor Coin",               "Gold Coin"},
  {176, "Iron Key",               "Iron Key"},
  {177, "Key of B",               "Key of B"},
  {178, "Solid Key",              "Solid Key"},
  {179, "Square Key",             "Square Key"},
  {180, "Tourquoise Key",         "Tourquoise Key"},  //140
  {181, "Cross Key",              "Cross Key"},
  {182, "Onyx Key",               "Onyx Key"},
  {183, "Skeleton Key",           "Skeleton Key"},
  {184, "Gold Key",               "Gold Key"},
  {185, "Winged Key",             "Winged Key"},
  {186, "Topaz Key",              "Topaz Key"},
  {187, "Sapphire Key",           "Sapphire Key"},
  {188, "Emerald Key",            "Emerald Key"},
  {189, "Ruby Key",               "Ruby Key"},
  {190, "Ra Key",                 "Ra Key"},          //150
  {191, "Master Key",             "Master Key"},
  {128, "Boulder",                "Boulder"},
  {129, "Blue Gem",               "Blue Gem"},
  {130, "Orange Gem",             "Orange Gem"},
  {131, "Green Gem",              "Green Gem"},
  {168, "Apple",                  "Apple"},
  {169, "Corn",                   "Corn"},
  {170, "Bread",                  "Bread"},
  {171, "Cheese",                 "Cheese"},
  {172, "Screamer Slice",         "Screamer Slice"}, //160
  {173, "Worm Round",             "Worm Round"},
  {174, "Shank",                  "Drumstick"},
  {175, "Dragon Steak",           "Dragon Steak"},
  {120, "Gem of Ages",            "Gem of Ages"},
  {121, "Ekkhard Cross",          "Ekkhard Cross"},
  {122, "Moonstone",              "Moonstone"},
  {123, "The Hellion",            "The Hellion"},
  {124, "Pendant Feral",          "Pendant Feral"},
  {132, "Magic Box(Blue)",        "Magic Box(Blue)"},
  {133, "Magic Box(Green)",       "Magic Box(Green)"}, //170
  {134, "Mirror of Dawn",         "Mirror of Dawn"},
  {136, "Rope",                   "Rope"},
  {137, "Rabbit's Foot",          "Rabbit's Foot"},
  {138, "Corbum",                 "Corbamite"},
  {139, "Choker",                 "Choker"},
  {192, "Lock Picks",             "Lock Picks"},
  {193, "Magnifier",              "Magnifier"},    
  {197, "Zokathra Spell",         "Zokathra Spell"},
  {198, "Bones",                  "Bones"}            //179
};


void FillComboBox(CComboBox *pCComboBox)
{
  int i, index;
  int gameName;
  gameName = (pDoc->EditingOptions() & EDIT_OPT_UseDMObjectNames)?1:0;
  for (i=0; i<180; i++)
  {
    index = pCComboBox->AddString(objDesc[i].objectName[gameName]);
    pCComboBox->SetItemData(index, objDesc[i].objectType);
  };
}

ui8 TorchModifier[16] = {0,1,1,1,2,2,2,2,3,3,3,3,3,3,3,3};

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(int n)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE) n;
}

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(WEAPONTYPE wt)
{
  *this = wt;
}

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(CLOTHINGTYPE ct)
{
  *this = ct;
}

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(POTIONTYPE pt)
{
  *this = pt;
}

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(MISCTYPE mt)
{
  *this = mt;
}

int MODIFIEDOBJECTTYPE::GetObjectIndex(void)
{
  int i;
  for (i=0; i<180; i++)
  {
    if (m_modifiedObjectType == objDesc[i].objectType)
    {
      return i;
    };
  };
  Strange("An illegal object type");
  return 0;
}

CLOTHINGTYPE MODIFIEDOBJECTTYPE::clothingType(void)
{
  int index;
  ASSERT(DatabaseType() == dbCLOTHING);
  index = GetObjectIndex();
  return CLOTHINGTYPE(index - CLOTHING_TYPE_OFFSET);
}

DBTYPE MODIFIEDOBJECTTYPE::DatabaseType(void)
{
  int index;
  index = GetObjectIndex();
  if (index < POTION_TYPE_OFFSET) return dbCHEST;
  if (index < WEAPON_TYPE_OFFSET) return dbPOTION;
  if (index < CLOTHING_TYPE_OFFSET) return dbWEAPON;
  if (index < MISC_TYPE_OFFSET) return dbCLOTHING;
  if (index < 200) return dbMISC;
  InternalError();
  return dbMISC;
}

MODIFIEDOBJECTTYPE::MODIFIEDOBJECTTYPE(RN object)
{
  int index, k;
  DBTYPE dbNum;
  dbNum = object.dbType();
  DBCOMMON *dbA3;
  switch (dbNum)
  {
  case dbSCROLL:
      m_modifiedObjectType = 
        (m_MODIFIEDOBJECTTYPE)objDesc[0].objectType;
      break;
  case dbCHEST:
      index = pDoc->GetRecordAddressDB9(object)->chestType() 
                 + CHEST_TYPE_OFFSET;
      m_modifiedObjectType = 
            (m_MODIFIEDOBJECTTYPE)objDesc[index].objectType;
      break;
  case dbMISC:
      *this = pDoc->GetRecordAddressDB10(object)->miscType();
      break;
  case dbWEAPON:
      *this = pDoc->GetRecordAddressDB5(object)->weaponType();
      break;
  case dbCLOTHING:
      *this = pDoc->GetRecordAddressDB6(object)->clothingType();
      break;
  case dbPOTION:
      *this = pDoc->GetRecordAddressDB8(object)->potionType();
      break;
  default:
      Strange("Seeking objecttype of non-named object");
  };
  if (!IsValid()) return;
  // Firstly, if it is not a modifiable object or
  //  a flask of some sort, then return it as is.
  if (   (m_modifiedObjectType > obj_LastModifiableObject)
      || (m_modifiedObjectType < obj_FirstModifiableObject) )
  {
    if (   (m_modifiedObjectType < obj_FirstFullFlask) 
        || (m_modifiedObjectType > obj_LastFullFlask) )
    { // Not a filled flask
      if (m_modifiedObjectType != obj_EmptyFlask) return;
    };
  };
  dbA3 = pDoc->GetCommonAddress(object);
  if (   (m_modifiedObjectType >= obj_Torch_a)
      && (m_modifiedObjectType <= obj_Torch_d))
  {
    k = (i16)dbA3->CastToDB5()->b15();
    if (k)
    {
      k = (i16)dbA3->CastToDB5()->charges();
      k = TorchModifier[k];
      m_modifiedObjectType = 
             (m_MODIFIEDOBJECTTYPE)(obj_Torch_a + k);
    };
  };
  if (m_modifiedObjectType == obj_OpenScroll)
  {
    if (!dbA3->CastToDB7()->open())
    {
      m_modifiedObjectType = obj_Scroll;
    };
  };
  if (   (m_modifiedObjectType==obj_Waterskin)
      || (m_modifiedObjectType==obj_Illumulet_a)
      || (m_modifiedObjectType==obj_JewelSymal_a) )
  {
    k = (i16)dbA3->CastToDB10()->value();
    if (k)
    {
      m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)(m_modifiedObjectType + 1);
    };
  };
  if (   (m_modifiedObjectType == obj_Storm_a)
      || (m_modifiedObjectType == obj_Flamitt_a)
      || (m_modifiedObjectType == obj_StormRing_a)
      || (m_modifiedObjectType == obj_RABlade_a)
      || (m_modifiedObjectType == obj_EyeOfTime_a)
      || (m_modifiedObjectType == obj_StaffOfClaws_a) )
  {
    k = (i16)dbA3->CastToDB5()->charges();
    if (k)
    {
      m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)(m_modifiedObjectType + 1);
    };
  };
}

CString MODIFIEDOBJECTTYPE::Name(void)
{
  int i;
  CString name;
  if(m_modifiedObjectType == obj_ERROR)   return "ERROR";
  if(m_modifiedObjectType == obj_NONE)    return "NONE";
  if(m_modifiedObjectType == obj_ANY)     return "ANY";
  if(m_modifiedObjectType == obj_BEING)   return "BEING";
  if(m_modifiedObjectType == obj_STEP)    return "STEP";
  if(m_modifiedObjectType == obj_MOVE)    return "MOVE";
  if(m_modifiedObjectType == obj_MONSTER) return "MONSTER";
  if(m_modifiedObjectType == obj_PARTY)   return "PARTY";
  CheckValid();
  for (i=0; i<sizeof(objDesc)/sizeof(objDesc[0]); i++)
  {
    if (objDesc[i].objectType==m_modifiedObjectType)
    {
      int gameName;
      gameName = (pDoc->EditingOptions() & EDIT_OPT_UseDMObjectNames)?1:0;
      name = objDesc[i].objectName[gameName];
      return objectNameTranslateTable.Xlate(name);
    };
  };
  switch(m_modifiedObjectType)
  {
  case obj_Scroll:        name = "Scroll";           break;
  case obj_TheFirestaff_c:name = "Firestaff_B";      break;
  case obj_RABlade_b:     name = "Ra Blade_B";       break;
  case obj_Storm_b:       name = "Storm_B";          break; 
  case obj_StaffOfClaws_b:name = "Staff of Claws_B"; break;
  case obj_StaffOfClaws_c:name = "Staff of Claws_C"; break;
  case obj_StormRing_b:   name = "Storm Ring_B";     break;
  case obj_EyeOfTime_b:   name = "Eye of Time_B";    break;
  case obj_Compass_E:     name = "Compass_E";        break;
  case obj_Compass_S:     name = "Compass_S";        break;
  case obj_Compass_W:     name = "Compass_W";        break;
  case obj_Torch_b:       name = "Torch_B";          break;
  case obj_Torch_c:       name = "Torch_C";          break;
  case obj_Torch_d:       name = "Torch_D";          break;
  case obj_Water:         name = "Water";            break;
  case obj_JewelSymal_b:  name = "Jewel Symal_B";    break;
  case obj_Illumulet_b:   name = "Illumulet_B";      break;
  case obj_Flamitt_b:     name = "Flamitt_B";        break;
  case obj_OpenChest:     name = "Open Chest";       break;
  default:  name = "Unknown"; break;
  };
  return objectNameTranslateTable.Xlate(name);
}

bool MODIFIEDOBJECTTYPE::operator ==(MODIFIEDOBJECTTYPE& mot)
{
  CheckValid();
  return m_modifiedObjectType == mot.m_modifiedObjectType;
}

void MODIFIEDOBJECTTYPE::CheckValid(bool allowExtras)
{
  if (IsValid()) return;
  if (allowExtras)
  {
    if (   (m_modifiedObjectType >= obj_FIRSTEXTRA)
         &&(m_modifiedObjectType <= obj_LASTEXTRA)
       )
    {
      return;
    };
  };
  Strange("We encountered an\nIllegal Object Type");
  m_modifiedObjectType = obj_Apple;
}

bool MODIFIEDOBJECTTYPE::IsValid(void)
{
  return    (m_modifiedObjectType > obj_2small)
         && (m_modifiedObjectType < obj_2large);
}

bool MODIFIEDOBJECTTYPE::IsValid(int n)
{
  return    (n > obj_2small)
         && (n < obj_2large);
}

MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(const char *name)
{
  int i;
  if (stricmp(name,"ERROR") == 0)
  {
    m_modifiedObjectType = obj_ERROR;
    return *this;
  }
  if (stricmp(name,"NONE") == 0)
  {
    m_modifiedObjectType = obj_NONE;
    return *this;
  };
  if (stricmp(name,"ANY") == 0)
  {
    m_modifiedObjectType = obj_ANY;
    return *this;
  };
  if (stricmp(name,"BEING") == 0)
  {
    m_modifiedObjectType = obj_BEING;
    return *this;
  };
  if (stricmp(name,"STEP") == 0)
  {
    m_modifiedObjectType = obj_STEP;
    return *this;
  };
  if (stricmp(name,"MOVE") == 0)
  {
    m_modifiedObjectType = obj_MOVE;
    return *this;
  };
  if (stricmp(name,"MONSTER") == 0)
  {
    m_modifiedObjectType = obj_MONSTER;
    return *this;
  };
  if (stricmp(name,"PARTY") == 0)
  {
    m_modifiedObjectType = obj_PARTY;
    return *this;
  };
  for (i=obj_2small+1; i<obj_2large; i++)
  {
    m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)i;
    if (stricmp(name, Name()) == 0) return *this;
  };
  Strange("Illegal Object Name Encountered");
  return *this;
}

MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(int n)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)n;
  ASSERT(IsValid());
  return *this;
}


MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(WEAPONTYPE wt)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)
             objDesc[wt.Integer() + WEAPON_TYPE_OFFSET].objectType;
  return *this;
}

MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(CLOTHINGTYPE ct)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)
             objDesc[ct.Integer() + CLOTHING_TYPE_OFFSET].objectType;
  return *this;
}

MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(POTIONTYPE ct)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)
             objDesc[ct.Integer() + POTION_TYPE_OFFSET].objectType;
  return *this;
}

MODIFIEDOBJECTTYPE MODIFIEDOBJECTTYPE::operator =(MISCTYPE mt)
{
  m_modifiedObjectType = (m_MODIFIEDOBJECTTYPE)
             objDesc[mt.Integer() + MISC_TYPE_OFFSET].objectType;
  return *this;
}

int MODIFIEDOBJECTTYPE::FillComboBox(CComboBox *pCComboBox)
{
  int index, i;
  MODIFIEDOBJECTTYPE fsp(obj_TheFirestaff_b);
  CheckValid(true);
  MODIFIEDOBJECTTYPE mot, savedMot;
  pCComboBox->ResetContent();
  for (i=obj_2small+1; i<obj_2large; i++)
  {
    if (    !MODIFIEDOBJECTTYPE(i).IsBasicObject()
         && (!(MODIFIEDOBJECTTYPE(i) == fsp))) continue;
    if ((pDoc->EditingOptions() & EDIT_OPT_AllowPewRaKath) == 0)
    {
      if (i == obj_RaBomb) continue;
      if (i == obj_PewBomb) continue;
      if (i == obj_KathBomb) continue;
    };
    if (i == m_modifiedObjectType) 
    {
      savedMot = *this;
      continue;
    };
    index = pCComboBox->AddString(MODIFIEDOBJECTTYPE(i).Name());
    pCComboBox->SetItemData(index, i);
  };
  if (savedMot.IsValid())
  {
    index = pCComboBox->AddString(savedMot.Name());
    pCComboBox->SetItemData(index, savedMot.Integer());
    return index;
  }
  else return -1;
}

bool MODIFIEDOBJECTTYPE::IsBasicObject(void)
{
  if (  (m_modifiedObjectType == obj_Compass_E)
      ||(m_modifiedObjectType == obj_Compass_S)
      ||(m_modifiedObjectType == obj_Compass_W) 
      ||(m_modifiedObjectType == obj_Torch_b)
      ||(m_modifiedObjectType == obj_Torch_c)
      ||(m_modifiedObjectType == obj_Torch_d)
      ||(m_modifiedObjectType == obj_JewelSymal_b)
      ||(m_modifiedObjectType == obj_Illumulet_b)
      ||(m_modifiedObjectType == obj_Flamitt_b)
      ||(m_modifiedObjectType == obj_EyeOfTime_b)
      ||(m_modifiedObjectType == obj_StormRing_b)
      ||(m_modifiedObjectType == obj_StaffOfClaws_b)
      ||(m_modifiedObjectType == obj_StaffOfClaws_c)
      ||(m_modifiedObjectType == obj_Storm_b)
      ||(m_modifiedObjectType == obj_RABlade_b)
      ||(m_modifiedObjectType == obj_TheFirestaff_b)
      ||(m_modifiedObjectType == obj_TheFirestaff_c)
      ||(m_modifiedObjectType == obj_Special_a)
      ||(m_modifiedObjectType == obj_Special_b)
      ||(m_modifiedObjectType == obj_Special_c)
      ||(m_modifiedObjectType == obj_Special_d)
      ||(m_modifiedObjectType == obj_Special_e)
      ||(m_modifiedObjectType == obj_Special_f)
      ||(m_modifiedObjectType == obj_Special_g)
      ||(m_modifiedObjectType == obj_Special_h)
      ||(m_modifiedObjectType == obj_Special_i)
      ||(m_modifiedObjectType == obj_Special_j)
      ||(m_modifiedObjectType == obj_Special_k)
      ||(m_modifiedObjectType == obj_Special_l)
      ||(m_modifiedObjectType == obj_Special_m)
      ||(m_modifiedObjectType == obj_Special_n)
      ||(m_modifiedObjectType == obj_Water)
      ||(m_modifiedObjectType == obj_OpenChest)
      ||(m_modifiedObjectType == obj_Scroll)
     ) return false;
  return true;
}


//****************************************** WEAPONTYPE
//
//****************************************** WEAPONTYPE

WEAPONTYPE::WEAPONTYPE(int n)
{
  m_weaponType = (m_WEAPONTYPE)n;
}

WEAPONTYPE& WEAPONTYPE::operator =(WEAPONTYPE wt)
{
  m_weaponType = wt.m_weaponType;
  return *this;
}

WEAPONTYPE& WEAPONTYPE::operator =(const char *name)
{
  int i;
  for (i=weapon_2small+1; i<weapon_2large; i++)
  {
    m_weaponType = (m_WEAPONTYPE)i;
    if (stricmp(name, Name()) == 0) return *this;
  };
  Strange("Illegal Weapon Name Encountered");
  return *this;
}

CString WEAPONTYPE::Name(void)
{
  return MODIFIEDOBJECTTYPE(*this).Name();
}

void WEAPONTYPE::CheckValid(void)
{
  if (IsValid()) return;
  Strange("We Encountered an\nIllegal Weapon Type");
  m_weaponType = weapon_Arrow;
}

bool WEAPONTYPE::IsValid(void)
{
  return   (m_weaponType > weapon_2small)
         &&(m_weaponType < weapon_2large);
}

int WEAPONTYPE::FillComboBox(CComboBox *pCComboBox)
{
  int i, index;
  CheckValid();
  pCComboBox->ResetContent();
  for (i=weapon_2small+1; i<weapon_2large; i++)
  {
    if (i == m_weaponType) continue;
    else
    {
      index = pCComboBox->AddString(WEAPONTYPE(i).Name());
      pCComboBox->SetItemData(index, i);
    };
  };
  index = pCComboBox->AddString(Name());
  pCComboBox->SetItemData(index, m_weaponType);
  return index;
}

//*********************************************** MONSTERTYPE
//
//*********************************************** MONSTERTYPE

char *MonsterName[] =
{
  "Scorpion",       //0
  "Slime_Devil",    //1
  "Giggler",        //2
  "Flying_Eye",     //3
  "Hellhound",      //4
  "Ruster",         //5
  "Screamer",       //6
  "Rock_Pile",      //7
  "Rive",           //8
  "Stone_Golem",    //9
  "Mummy",          //10
  "Black_Flame",    //11
  "Skeleton",       //12
  "Couatl",         //13
  "Vexirk",         //14
  "Worm",           //15
  "Ant_Man",        //16
  "Muncher",        //17
  "Deth_Knight",    //18  
  "Zytaz",          //19
  "Water_Elemental",//20
  "Oitu",           //21
  "Demon",          //22
  "Lord_Chaos",     //23
  "Dragon",         //24
  "Lord_Order",     //25
  "Grey_Lord"       //26
};


MONSTERTYPE::MONSTERTYPE(int n)
{
  m_monsterType = (m_MONSTERTYPE)n;
}

MONSTERTYPE& MONSTERTYPE::operator =(MONSTERTYPE wt)
{
  m_monsterType = wt.m_monsterType;
  return *this;
}

bool MONSTERTYPE::IsValid(void)
{
  return    (m_monsterType > mon_2small)
         && (m_monsterType < mon_2large);
}

void MONSTERTYPE::CheckValid(void)
{
  if (IsValid()) return;
  Strange("Encountered Illegal\nMonster Type");
  m_monsterType = mon_Scorpion;
}

CString MONSTERTYPE::Name(void)
{
  CString name;
  CheckValid();
  name = MonsterName[m_monsterType];
  return objectNameTranslateTable.Xlate(name);
}

int MONSTERTYPE::FillComboBox(CComboBox *pCComboBox,
                              int level /*=-1*/)
{
  int i, index, n;
  bool OK;
  CheckValid();
  pCComboBox->ResetContent();
  for (i=mon_2small+1; i<mon_2large; i++)
  {
    if (i == m_monsterType) continue;
    else
    {
      OK = level==-1;
      if (!OK)
      {
        for (n=0; n<pDoc->NumMonsterType(level); n++)
        {
          if (pDoc->MonsterType(level,n).m_monsterType == i)
                  OK = true;
        };
      };
      if (OK)
      {
        index = pCComboBox->AddString(MONSTERTYPE(i).Name());
        pCComboBox->SetItemData(index, i);
      };
    };
  };
  index = pCComboBox->AddString(Name());
  pCComboBox->SetItemData(index, m_monsterType);
  return index;
}

int MONSTERTYPE::FillListBox(CListBox *pCListBox,
                              int level /*=-1*/)
{
  int i, index, n;
  bool OK;
  CheckValid();
  pCListBox->ResetContent();
  for (i=mon_2small+1; i<mon_2large; i++)
  {
    if (i == m_monsterType) continue;
    else
    {
      OK = level==-1;
      if (!OK)
      {
        for (n=0; n<pDoc->NumMonsterType(level); n++)
        {
          if (pDoc->MonsterType(level,n).m_monsterType == i)
                  OK = true;
        };
      };
      if (OK)
      {
        index = pCListBox->AddString(MONSTERTYPE(i).Name());
        pCListBox->SetItemData(index, i);
      };
    };
  };
  index = pCListBox->AddString(Name());
  pCListBox->SetItemData(index, m_monsterType);
  return index;
}

MONSTERTYPE& MONSTERTYPE::operator = (const char *name)
{
  int i;
  for (i=0; i<sizeof(MonsterName)/sizeof(MonsterName[0]); i++)
  {
    if (stricmp(name,MonsterName[i]) == 0)
    {
      m_monsterType = m_MONSTERTYPE(i);
      return *this;
    };
  };
  InternalError("Unknown Monster Name");
  m_monsterType = mon_Scorpion;
  return *this;
}

//*********************************************** CLOTHINGTYPE
//
//*********************************************** CLOTHINGTYPE

CLOTHINGTYPE::CLOTHINGTYPE(int n)
{
  m_clothingType = m_CLOTHINGTYPE(n);
}

CLOTHINGTYPE& CLOTHINGTYPE::operator =(CLOTHINGTYPE wt)
{
  m_clothingType = wt.m_clothingType;
  return *this;
}

CLOTHINGTYPE& CLOTHINGTYPE::operator =(MODIFIEDOBJECTTYPE mot)
{
  *this =  mot.clothingType();
  return *this;
}


CLOTHINGTYPE& CLOTHINGTYPE::operator =(const char *name)
{
  int i;
  for (i=clothing_2small+1; i<clothing_2large; i++)
  {
    m_clothingType = (m_CLOTHINGTYPE)i;
    if (stricmp(name, Name()) == 0) return *this;
  };
  Strange("Illegal Clothing Name Encountered");
  return *this;
}


bool CLOTHINGTYPE::IsValid(void)
{
  return    (m_clothingType > clothing_2small)
         && (m_clothingType < clothing_2large);
}

void CLOTHINGTYPE::CheckValid(void)
{
  if (IsValid()) return;
  Strange("Encountered Illegal\nClothing Type");
  m_clothingType = clothing_Sandals;
}

CString CLOTHINGTYPE::Name(void)
{
  return MODIFIEDOBJECTTYPE(*this).Name();
}

int CLOTHINGTYPE::FillComboBox(CComboBox *pCComboBox)
{
  int i, index;
  CheckValid();
  pCComboBox->ResetContent();
  for (i=clothing_2small+1; i<clothing_2large; i++)
  {
    if (i == m_clothingType) continue;
    else
    {
      index = pCComboBox->AddString(CLOTHINGTYPE(i).Name());
      pCComboBox->SetItemData(index, i);
    };
  };
  index = pCComboBox->AddString(Name());
  pCComboBox->SetItemData(index, m_clothingType);
  return index;
}

//*********************************************** POTIONTYPE
//
//*********************************************** POTIONTYPE

POTIONTYPE::POTIONTYPE(int n)
{
  m_potionType = m_POTIONTYPE(n);
}

POTIONTYPE& POTIONTYPE::operator =(POTIONTYPE pt)
{
  m_potionType = pt.m_potionType;
  return *this;
}

POTIONTYPE& POTIONTYPE::operator =(const char *name)
{
  int i;
  for (i=potion_2small+1; i<potion_2large; i++)
  {
    m_potionType = (m_POTIONTYPE)i;
    if (stricmp(name, Name()) == 0) return *this;
  };
  Strange("Illegal Potion Name Encountered");
  return *this;
}

bool POTIONTYPE::IsValid(void)
{

  if (m_potionType <= potion_2small)     return false;
  if (m_potionType >= potion_2large)     return false;
  //if (m_potionType == potion_MonPotionA) return false;
  if ((pDoc->EditingOptions() & EDIT_OPT_AllowPewRaKath) == 0)
  {
    if (m_potionType == potion_KathBomb) return false;
    if (m_potionType == potion_PewBomb) return false;
    if (m_potionType == potion_RaBomb) return false;
  };
  return true;
}

void POTIONTYPE::CheckValid(void)
{
  if (IsValid()) return;
  Strange("Encountered Illegal\nPotion Type");
  m_potionType = potion_ViPotion;
}

CString POTIONTYPE::Name(void)
{
  return MODIFIEDOBJECTTYPE(*this).Name();
}

int POTIONTYPE::FillComboBox(CComboBox *pCComboBox)
{
  int i, index;
  POTIONTYPE pt;
  CheckValid();
  pCComboBox->ResetContent();
  for (i=potion_2small+1; i<potion_2large; i++)
  {
    pt.Integer(i);
    if (!pt.IsValid()) continue;
    if (i == m_potionType) continue;
    else
    {
      index = pCComboBox->AddString(POTIONTYPE(i).Name());
      pCComboBox->SetItemData(index, i);
    };
  };
  index = pCComboBox->AddString(Name());
  pCComboBox->SetItemData(index, m_potionType);
  return index;
}


//*********************************************** MISCTYPE
//
//*********************************************** MISCTYPE

MISCTYPE::MISCTYPE(int n)
{
  m_miscType = m_MISCTYPE(n);
}

MISCTYPE& MISCTYPE::operator =(MISCTYPE pt)
{
  m_miscType = pt.m_miscType;
  return *this;
}

MISCTYPE& MISCTYPE::operator =(const char *name)
{
  int i;
  for (i=misc_2small+1; i<misc_2large; i++)
  {
    m_miscType = (m_MISCTYPE)i;
    if (stricmp(name, Name()) == 0) return *this;
  };
  Strange("Illegal Miscellaneous Name Encountered");
  return *this;
}

bool MISCTYPE::IsValid(void)
{
  return    (m_miscType > misc_2small)
         && (m_miscType < misc_2large);
}

void MISCTYPE::CheckValid(void)
{
  if (IsValid()) return;
  Strange("Encountered Illegal\nMisc Type");
  m_miscType = misc_Apple;
}

CString MISCTYPE::Name(void)
{
  return MODIFIEDOBJECTTYPE(*this).Name();
}

int MISCTYPE::FillComboBox(CComboBox *pCComboBox)
{
  int i, index;
  CheckValid();
  pCComboBox->ResetContent();
  for (i=misc_2small+1; i<misc_2large; i++)
  {
    if (i == m_miscType) continue;
    else
    {
      index = pCComboBox->AddString(MISCTYPE(i).Name());
      pCComboBox->SetItemData(index, i);
    };
  };
  index = pCComboBox->AddString(Name());
  pCComboBox->SetItemData(index, m_miscType);
  return index;
}

DSAAction::DSAAction(void)
{
  m_column      = -1;
  m_numPgmWords = 0;
  m_program     = NULL;
}

/*

void DSA_ACTION::Set(int state,
                     char msg1, int delay1,
                     char msg2, int delay2)
{
  int n;
  m_nextState = (ui8)state;
  switch (msg1)
  {
  case 'S': n=1; break;
  case 'C': n=2; break;
  case 'T': n=3; break;
  default:  n=0; break;
  };
  m_Msg = (ui8)(n<<4);
  m_DelayA = (ui16)delay1;
  switch (msg2)
  {
  case 'S': n=1; break;
  case 'C': n=2; break;
  case 'T': n=3; break;
  default:  n=0; break;
  };
  m_Msg = (ui8)((m_Msg & 0xf0) | n);
  m_DelayB = (ui16)delay2;
}

char DSA_ACTION::MessageA(void)
{
  int n = (m_Msg>>4)&15;
  switch (n)
  {
  case 1: return 'S';
  case 2: return 'C';
  case 3: return 'T';
  default: return 'N';
  };
}

char DSA_ACTION::MessageB(void)
{
  int n = m_Msg&15;
  switch (n)
  {
  case 1: return 'S';
  case 2: return 'C';
  case 3: return 'T';
  default: return 'N';
  };
}
*/


DSA::DSA(void)
{
  strcpy(m_description,"New DSA");
  StateLocation(0);
  m_groupID = 0;
  m_numState = 0;
  m_pStates = NULL;
  m_firstDisplayedState = 0;
  m_state = 0;
}

DSA::~DSA(void)
{
  int i;
  for (i=0; i<m_numState; i++)
  {
    delete m_pStates[i];
    m_pStates[i] = NULL;
  };
  m_numState = 0;
  if (m_pStates != NULL) free (m_pStates);
  m_pStates = NULL;
}

DSA& DSA::operator = (DSA& dsa)
{
  int i;
  memcpy(m_description, dsa.m_description, 80);
  m_StateLocation = dsa.m_StateLocation;
  m_groupID = dsa.m_groupID;
  m_state = dsa.m_state;
  m_firstDisplayedState = dsa.m_firstDisplayedState;
  for (i=0; i<m_numState; i++)
  {
    delete m_pStates[i];
  };
  if (m_pStates != NULL) free (m_pStates);
  m_pStates = NULL;
  m_numState = dsa.m_numState;
  if (m_numState != 0)
  {
    m_pStates = (DSAState **) malloc(
                   m_numState * sizeof(m_pStates[0]),
                   MALLOC044);
  };
  for (i=0; i<m_numState; i++)
  {
    if (dsa.m_pStates[i] == NULL)
    {
      m_pStates[i] = NULL;
    }
    else
    {
      m_pStates[i] = new DSAState;
      *m_pStates[i] = *dsa.m_pStates[i];
    };
  };
  return *this;
}
bool DSA::operator != (DSA& dsa)
{
  DSAState emptyState;
  DSAState *pntrA, *pntrB;
  int maxState;
  int i;
  if (strcmp(m_description, dsa.m_description) != 0) return true;
  if (m_state != dsa.m_state) return true;
  if (m_StateLocation != dsa.m_StateLocation) return true; // state in acutuator record
  if (m_groupID != dsa.m_groupID) return true;
  if (m_firstDisplayedState != dsa.m_firstDisplayedState) return true;;
  maxState = m_numState;
  if (dsa.m_numState > maxState) maxState = dsa.m_numState;
  for (i=0; i<maxState; i++)
  {
    if (i >= m_numState) pntrA = NULL;
    else pntrA = m_pStates[i];
    if (i >= dsa.m_numState) pntrB = NULL;
    else pntrB = dsa.m_pStates[i];
    if (pntrA == NULL)
    {
      if (pntrB == NULL) continue;
      if (*pntrB != emptyState) return true;
    }
    else
    {
      if (pntrB == NULL)
      {
        if (*pntrA != emptyState) return true;
      }
      else
      {
        if (*pntrA != *pntrB) return true;
      };
    };
  };
  return false;
}

void DSA::compress(void)
{ //Discard any states that are equivalent to an empty state.
  int lastNonEmptyState = -1;
  DSAState emptyState;
  int i;
  for (i=0; i<m_numState; i++)
  {
    if (m_pStates[i] == NULL) continue;
    m_pStates[i]->compress();
    if (!(*m_pStates[i] != emptyState)) 
    {
      delete m_pStates[i];
      m_pStates[i] = NULL;
      continue;
    };
    if (lastNonEmptyState < i)
    {
      lastNonEmptyState = i;
    };
  };
  if (m_numState > lastNonEmptyState + 1)
  {
    m_numState = lastNonEmptyState + 1;
  };
}

void DSA::Write(void)
{
  unsigned int i;
  unsigned int numNonEmptyStates = 0;
  pDoc->WCS(m_description, 80);
  pDoc->WCS(&m_state);
  pDoc->WCS(&m_StateLocation);
  pDoc->WCS(&m_groupID);
  pDoc->WCS(&m_numState);
  pDoc->WCS(&m_firstDisplayedState);
  for (i=0; i<(unsigned)m_numState; i++)
  {
    if (m_pStates[i] != NULL) numNonEmptyStates++;
  };
  pDoc->WCS(&numNonEmptyStates);
  for (i=0; i<(unsigned)m_numState; i++)
  {
    if (m_pStates[i] == NULL) continue;
    pDoc->WCS(&i);
    m_pStates[i]->Write();
  };
};

bool FormSignature(FILE *f, unsigned char *signature)
{
  char line[1001];
  MD5Init();
  fpos_t pos;
  for (;;)
  {
    fgetpos(f, &pos);
    if (fgets(line,1000,f) == NULL) return false;
    if (line[0] == '#') continue;
    if (memcmp(line, "signature = ", 12) == 0) break;
    MD5Update((unsigned char *)line, strlen(line));
  };
  fsetpos(f, &pos);
  MD5Final(signature);
  return true;
}

void DSA::Export(void)
{
  unsigned int i, result;
  fpos_t position;
  unsigned char signature[16];
  unsigned int numNonEmptyStates = 0;
  FILE *f;
  char fileName[1001];
  OPENFILENAME openFileName;
  memcpy(fileName, m_description, 80);
  openFileName.lStructSize = sizeof (openFileName);
  openFileName.hwndOwner   = NULL;
  openFileName.hInstance   = 0;
  openFileName.lpstrFilter = "Text (*.txt)\000*.txt\000All Files (*.*)\000*.*\000\000";
  openFileName.lpstrCustomFilter = NULL;
  openFileName.nMaxCustFilter = 0;
  openFileName.nFilterIndex   = 0;
  openFileName.lpstrFile      = fileName;
  openFileName.nMaxFile       = 1000;
  openFileName.lpstrFileTitle = NULL;
  openFileName.nMaxFileTitle  = 0;
  openFileName.lpstrInitialDir = NULL;
  openFileName.lpstrTitle      = NULL;
  openFileName.Flags           = OFN_OVERWRITEPROMPT;
  openFileName.nFileOffset     = 0;
  openFileName.nFileExtension  = (unsigned short)strlen(fileName);
  openFileName.lpstrDefExt     = "txt";
  openFileName.lCustData       = 0;
  openFileName.lpfnHook        = NULL;
  openFileName.lpTemplateName  = NULL;
  result = GetSaveFileName(&openFileName);
//  CFileDialog dlg(false,
//                  "txt",  //default extension
//                  NULL,   //default file name
//                  OFN_OVERWRITEPROMPT,
//                  "Text Files (*.txt)|*.txt|All files(*.*)|*.*||");
//  if (dlg.DoModal() != IDOK) return;
  if (fileName[strlen(fileName)-1] == '*') fileName[strlen(fileName)-1] = 0;
  f = fopen(fileName,"w+");
  if (f == NULL)
  {
    Error("Cannot open that file for writing");
    return;
  };
  fprintf(f,"Description = %s\n",m_description);
  fprintf(f,"State = %d\n",m_state);
  fprintf(f,"StateLocation = %d\n",m_StateLocation);
  fprintf(f,"GroupID = %d\n",m_groupID);
  fprintf(f,"Number of States = %d\n",m_numState);
  fprintf(f,"First Displayed State = %d\n",m_firstDisplayedState);
  for (i=0; i<(unsigned)m_numState; i++)
  {  
    if (m_pStates[i] != NULL) numNonEmptyStates++;
  };
  fprintf(f,"Number of non-empty states = %d\n",numNonEmptyStates);
  for (i=0; i<(unsigned)m_numState; i++)
  {
    if (m_pStates[i] == NULL) continue;
    fprintf(f,"State Number = %d\n",i);
    m_pStates[i]->Export(f, i);
  };
  fgetpos(f, &position);
  fprintf(f, "signature = 0123456789abcdef\n");
  rewind(f);
  FormSignature(f, signature);
  fprintf(f, "signature = ");
  for (i=0; i<16; i++)
  {
    fprintf(f,"%02X",signature[i]);
  };
  fprintf(f,"\n");
  fclose(f);
}

void DSA::Read(void)
{
  unsigned int i;
  unsigned int numNonEmptyStates;
  unsigned int stateNum;
  pDoc->RCS(m_description, 80);
  pDoc->RCS(&m_state);
  pDoc->RCS(&m_StateLocation);
  pDoc->RCS(&m_groupID);
  pDoc->RCS(&m_numState);
  pDoc->RCS(&m_firstDisplayedState);
  pDoc->RCS(&numNonEmptyStates);
  if (m_pStates != NULL)
  {
    DIE("DSA state table not NULL");
  };
  m_pStates = (DSAState **)malloc(m_numState*sizeof(DSAState *),
                                  MALLOC049);
  for (i=0; i<(unsigned)m_numState; i++) m_pStates[i] = NULL;
  for (i=0; i<numNonEmptyStates; i++)
  {
    pDoc->RCS(&stateNum);
    if (stateNum >= (unsigned)m_numState)
    {
      DIE("DSA state number > #states");
    };
    if (m_pStates[stateNum] != NULL)
    {
      DIE("Duplicate DSA state");
    };
    m_pStates[stateNum] = new DSAState;
    m_pStates[stateNum]->Read();
  };
};

bool BadSignature(void)
{
  int result;
  result = MessageBox(NULL,
                      "That file has\n"
                      "been tampered with.\n"
                      "Do you want to load it anyway?",
                      "Error", 
                      MB_YESNO);
  return result == IDYES;
}

void BadFile(FILE *f)
{
  fclose(f);
  MessageBox(NULL,"That file has\nbeen tampered with", "Error", MB_OK);
}


void ImportError(char *msg)
{
  MessageBox(NULL, msg, "Import Error", MB_OK);
}

struct FIELDS
{
  CString key;
  int     integer;
  CString string;
};

bool ImportLine(FILE *f, FIELDS& fields)
{
  char line[1001];
  char *eqpnt;
  int eqcol, len;
  do
  {
    if (fgets(line, 1000, f) == NULL) return false;
  } while (line[0] == '#');
  len = strlen(line);
  if (line[len-1] == '\n') line[--len] = 0;
  eqpnt = strchr(line, '=');
  if (eqpnt == NULL) return false;
  eqcol = eqpnt - line;
  if (eqcol < 2) return false;
  if (eqcol > len-3) return false;
  if (line[eqcol-1] != ' ') return false;
  if (line[eqcol+1] != ' ') return false;
  fields.key = CString(line,eqcol-1);
  fields.string = CString(line+eqcol+2, len-eqcol-2);
  fields.integer = atol(fields.string);
  return true;
}

void DSA::Import(void)
{
  FILE *f;
  char line[1001];
  int onebyte, stateCount;
  unsigned char signature[17];
  bool showSignature = false;
  int i, result, len;
  char fileName[1001];
  OPENFILENAME openFileName;
  FIELDS fields;
  fileName[0] = 0;
  openFileName.lStructSize = sizeof (openFileName);
  openFileName.hwndOwner   = NULL;
  openFileName.hInstance   = 0;
  openFileName.lpstrFilter = "Text (*.txt)\000*.txt\000All Files (*.*)\000*.*\000\000";
  openFileName.lpstrCustomFilter = NULL;
  openFileName.nMaxCustFilter = 0;
  openFileName.nFilterIndex   = 0;
  openFileName.lpstrFile      = fileName;
  openFileName.nMaxFile       = 1000;
  openFileName.lpstrFileTitle = NULL;
  openFileName.nMaxFileTitle  = 0;
  openFileName.lpstrInitialDir = NULL;
  openFileName.lpstrTitle      = NULL;
  openFileName.Flags           = 0;  
  openFileName.nFileOffset     = 0;
  openFileName.nFileExtension  = (unsigned short)strlen(fileName);
  openFileName.lpstrDefExt     = "txt";
  openFileName.lCustData       = 0;
  openFileName.lpfnHook        = NULL;
  openFileName.lpTemplateName  = NULL;
  
  
  result = GetOpenFileName(&openFileName);
//  CFileDialog dlg(false,
//                  "txt",  //default extension
//                  NULL,   //default file name
//                  0,
//                  "Text Files (*.txt)|*.txt|All files(*.*)|*.*||");
//  if (dlg.DoModal() != IDOK) return;
  f = fopen(fileName,"r");
  if (f == NULL)
  {
    Error("Cannot open that file for reading");
    return;
  };
  if (!FormSignature(f, signature))
  {
    BadFile(f);
    return;
  };
  if (fgets(line, 80, f) == NULL)
  {
    BadFile(f);
    return;
  };
  if (memcmp(line, "signature = ", 12) != 0)
  {
    BadFile(f);
    return;
  };
  for (i=15; i>=0; i--)
  {
    line[+14+2*i] = 0;
    sscanf(line+12+i*2,"%X",&onebyte);
    if (onebyte != signature[i])
    {
      showSignature = true;
      if (!BadSignature())
      {
        fclose(f);
        return;
      };
      break;
    };
  };
  rewind(f);
  memset(m_description,' ',80);
  for (;;)
  {
    if (!ImportLine(f,fields))
    {
      ImportError("Improper input line");
      fclose(f);
      return;
    };
    if (fields.key == "Description")
    {
      len = fields.string.GetLength();
      if (len > 80) len = 80;
      memcpy(m_description, fields.string, len);
      continue;
    };
    if (fields.key == "State")
    {
      m_state = (ui16)fields.integer;
      continue;
    };
    if (fields.key == "StateLocation")
    {
      m_StateLocation = (char)fields.integer;
      continue;
    };
    if (fields.key == "GroupID")
    {
      m_groupID = (ui8)fields.integer;
      continue;
    };
    if (fields.key == "Number of States")
    {
      continue;
    };
    if (fields.key == "First Displayed State")
    {
      m_firstDisplayedState = fields.integer;
      continue;
    };
    if (fields.key == "Number of non-empty states")
    {
      break;
    };
    ImportError("Unknown key field");
    fclose(f);
    return;
  };
  stateCount = fields.integer;
  for (i=0; i<stateCount; i++)
  {
    if (!ImportLine(f, fields))
    {
      ImportError("Error reading import file");
      showSignature = false;
      break;
    };
    if (fields.key != "State Number")
    {
      ImportError("Expected 'State Number'");
      showSignature = false;
      break;
    };
    Expand(fields.integer);
    if (!m_pStates[fields.integer]->Import(f, fields.integer))
    {
      showSignature = false;
      break;
    };
  };
  if (showSignature)
  {
    char line[80];
    signature[16] = 0;
    sprintf(line,"Signature should be \n");
    for (i=0; i<16; i++)
    {
      sprintf(line+strlen(line),"%02X",signature[i]);
    };
    MessageBox(NULL,line,"Signature",MB_OK);
  };
  fclose(f);
}


void DSAState::Write(void)
{
  int i;
  pDoc->WCS(&m_numAction);
  for (i=0; i<m_numAction; i++)
  {
    m_pActions[i]->Write();
  };
}

void DSAState::Export(FILE *f, int state)
{
  int i;
  fprintf(f,"Number of Actions = %d\n",m_numAction);
  for (i=0; i<m_numAction; i++)
  {
    m_pActions[i]->Export(f, state);
  };
}

bool DSAState::Import(FILE *f, int state)
{
  FIELDS fields;
  int i, msgIdx;
  int numAction;
  if (!ImportLine(f, fields)) return false;
  if (fields.key != "Number of Actions")
  {
    ImportError("Expected 'Number of Actions'");
    return false;
  };
  numAction = fields.integer;
  for (i=0; i<numAction; i++)
  {
    if (!ImportLine(f, fields))
    {
      ImportError("Improper 'Action' line");
      return false;
    };
    msgIdx = -1;
    if (fields.key == "S0") msgIdx = 0;
    if (fields.key == "C0") msgIdx = 1;
    if (fields.key == "T0") msgIdx = 2;
    if (fields.key == "S1") msgIdx = 3;
    if (fields.key == "C1") msgIdx = 4;
    if (fields.key == "T1") msgIdx = 5;
    if (fields.key == "S2") msgIdx = 6;
    if (fields.key == "C2") msgIdx = 7;
    if (fields.key == "T2") msgIdx = 8;
    if (fields.key == "S3") msgIdx = 9;
    if (fields.key == "C3") msgIdx = 10;
    if (fields.key == "T3") msgIdx = 11;
    if (fields.key == "S0+") msgIdx = 0;
    if (fields.key == "C0+") msgIdx = 1;
    if (fields.key == "T0+") msgIdx = 2;
    if (fields.key == "S1+") msgIdx = 3;
    if (fields.key == "C1+") msgIdx = 4;
    if (fields.key == "T1+") msgIdx = 5;
    if (fields.key == "S2+") msgIdx = 6;
    if (fields.key == "C2+") msgIdx = 7;
    if (fields.key == "T2+") msgIdx = 8;
    if (fields.key == "S3+") msgIdx = 9;
    if (fields.key == "C3+") msgIdx = 10;
    if (fields.key == "T3+") msgIdx = 11;
    if (msgIdx == -1)
    {
      ImportError("Illegal Column Name");
      return false;
    };
    if (fields.key.GetLength() != 3)
    {
      Pgm(msgIdx, fields.string, state);
    }
    else
    {
      CString prefix;
      prefix = Pgm(msgIdx, state);
      Pgm(msgIdx, prefix + ' ' + fields.string, state);
    };
  };
  return true;
}

void DSAState::Read(void)
{
  int i;
  pDoc->RCS(&m_numAction);
  if (m_numAction > 12)
  {
    DIE("Number of DSA actions > 12");
  };
  if (m_pActions != NULL)
  {
    DIE("Action table npt NULL");
  };
  m_pActions = (DSAAction **)malloc(
                    m_numAction * sizeof (DSAAction*),
                    MALLOC050);
  for (i=0; i<m_numAction; i++)
  {
    m_pActions[i] = new DSAAction;
    m_pActions[i]->Read();
  };
}

void DSA::Description(CString& desc)
{
  int len;
  len = desc.GetLength();
  if (len >= sizeof (m_description) - 1)
  {
    len = sizeof (m_description) - 1;
  };
  memset(m_description, 0, sizeof (m_description));
  memcpy(m_description, (LPCTSTR)desc, len);
}

void DSA::Expand(int state)
{
  int i;
  if (state < m_numState) 
  {
    if (m_pStates[state] != NULL) return;
    m_pStates[state] = new DSAState;
    return;
  };
  m_pStates = (DSAState **)realloc(
                        m_pStates, 
                        (state+1)*sizeof(m_pStates[0]),
                        MALLOC042);
  for (i=m_numState; i<=state; i++)
  {
    m_pStates[i] = NULL;
  };
  m_pStates[state] = new DSAState;
  m_numState = state + 1;
}

CString DSA::Pgm(int state, int msgIdx)
{
  if (state >= m_numState) return CString("");
  if (m_pStates[state] == NULL) return CString("");
  return m_pStates[state]->Pgm(msgIdx, state);
}

int DSA::Pgm(int state, int msgIdx, const CString& pgm)
{
  if (   (state >= m_numState)
      || (m_pStates[state] == NULL))
  {
    if (pgm == "") return -1;
    Expand(state);
  };
  return m_pStates[state]->Pgm(msgIdx, pgm, state);
}

DSAAction::~DSAAction(void)
{
  if (m_program != NULL) free (m_program);
  m_program = NULL;
  m_numPgmWords = 0;
}

DSAAction& DSAAction::operator =(DSAAction& action)
{
  m_column = action.m_column;
  if (m_program != NULL) free(m_program);
  m_program = NULL;
  m_numPgmWords = action.m_numPgmWords;
  if (m_numPgmWords != 0)
  {
    m_program = (ui16 *)malloc(2 * m_numPgmWords, MALLOC046);
    memcpy(m_program, action.m_program, 2*m_numPgmWords);
  };
  return *this;
}

bool DSAAction::operator != (DSAAction& da)
{
  if (m_column != da.m_column) return true;
  if (m_numPgmWords != da.m_numPgmWords) return true;
  if (memcmp(m_program, da.m_program, 2*m_numPgmWords)!=0) return true;
  return false;
}

void DSAAction::compress(void)
{
  if (m_numPgmWords != 0) return;
  m_column = -1;
  if (m_program != NULL) free (m_program);
}

int encodeInteger(char *text, int col, unsigned int val)
{
  unsigned int i;
  if (val == 0)
  {
    text[col++] = '0';
    return col;
  };
  for (i=1000000000; i>0; i/=10)
  {
    if (val>=i) break;
  }
  for (; i>0; i/=10)
  {
    text[col++] = (char)(val/i + '0');
    val %= i;
  };
  return col;
}

int encodeColumn(char *text, int col, int column)
{
  switch (column%3)
  {
  case 0:
    text[col++] = 'S'; break;
  case 1:
    text[col++] = 'C'; break;
  case 2:
    text[col++] = 'T'; break;
  };
  return encodeInteger(text, col, column/3);
}

int encodeAbsTarget(char *text, int col, int target)
{
  LOCATIONREL locr;
  LOCATIONABS loca;
  locr.Integer(target);
  loca = locr;
  col = encodeInteger(text, col, loca.l);
  text[col++] = '(';
  col = encodeInteger(text, col, loca.x);
  text[col++] = ',';
  col = encodeInteger(text, col, loca.y);
  text[col++] = ')';
  if (loca.p != 0) text[col++] = "NESW"[loca.p];
  return col;
}

CString DSAAction::EncodeM(int &index, int curState)
{
  DSAmessageCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSAmessageCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'M';
  switch (pCmd->Delay())
  {
  case 0: break;
  case 1: text[col++] = 'X'; break;
  case 2: text[col++] = 'Y'; break;
  case 3: 
    col = encodeInteger(text,col,m_program[index++]); 
    break;
  };
  switch (pCmd->MsgType())
  {
  case MSG_NULL:   text[col++] = 'N'; break;
  case MSG_SET:    text[col++] = 'S'; break;
  case MSG_CLEAR:  text[col++] = 'C'; break;
  case MSG_TOGGLE: text[col++] = 'T'; break;
  default:
    Strange ("unknown message type");
    break;
  };
  switch (pCmd->Target())
  {
  case TARGET_A: break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    col = encodeAbsTarget(text, col, m_program[index++]);
    break;
  case TARGET_GEAR: text[col++] = '*'; break;
  default: Strange("Unknown target type"); break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeM32(int &index, int curState)
{
  DSAmessageCmd *pCmd;
  int newState, integerTarget;
  char text[20];
  int col = 0;
  pCmd = (DSAmessageCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'M';
  switch (pCmd->Delay())
  {
  case 0: break;
  case 1: text[col++] = 'X'; break;
  case 2: text[col++] = 'Y'; break;
  case 3: 
    col = encodeInteger(text,col,m_program[index++]); 
    break;
  };
  switch (pCmd->MsgType())
  {
  case MSG_NULL:   text[col++] = 'N'; break;
  case MSG_SET:    text[col++] = 'S'; break;
  case MSG_CLEAR:  text[col++] = 'C'; break;
  case MSG_TOGGLE: text[col++] = 'T'; break;
  default:
    Strange ("unknown message type");
    break;
  };
  switch (pCmd->Target())
  {
  case TARGET_A: break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    integerTarget = m_program[index++];
    integerTarget |= m_program[index++] << 16;
    col = encodeAbsTarget(text, col, integerTarget);
    break;
  case TARGET_GEAR: text[col++] = '*'; break;
  default: Strange("Unknown target type"); break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeL(int &index, int curState)
{
  DSAloadCmd *pCmd;
  int newState;
  unsigned int where;
  char text[20];
  int col = 0;
  pCmd = (DSAloadCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'L';
  where = pCmd->Where();
  if (where == LOAD_INTEGER)
  {
    col = encodeInteger(text,col,m_program[index++]); 
  }
  else if (where == LOAD_INTEGER32)
  {
    unsigned int bigInt = m_program[index++];
    bigInt |= m_program[index++] << 16;
    col = encodeInteger(text,col,bigInt); 
  }
  else if (where == LOAD_ABS16)
  {
    col = encodeAbsTarget(text, col, m_program[index++]);
  }
  else if (where == LOAD_ABS32)
  {
    unsigned int intTarget = m_program[index++];
    intTarget |= m_program[index++] << 16;
    col = encodeAbsTarget(text, col, intTarget);
  }
  else if (where == LOAD_$)
  {
    text[col++] = '$';
  }
  else
  {
    text[col++] = (char)(where + 'A');
  };
  return CString(text, col);
}

CString DSAAction::EncodeS(int &index, int curState)
{
  DSAstoreCmd *pCmd;
  int newState;
  unsigned int where;
  char text[20];
  int col = 0;
  pCmd = (DSAstoreCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'S';
  where = pCmd->Where();
  text[col++] = (char)(where + 'A');
  return CString(text, col);
}

CString DSAAction::EncodeO(int &index, int curState)
{
  DSAoverrideCmd *pCmd;
  int newState;
  unsigned value;
  char text[20];
  int col = 0;
  pCmd = (DSAoverrideCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'O';
  switch (pCmd->What())
  {
  case 1: text[col++] = 'P'; break;
  default: Strange("Illegal 'what' in override comman");
    break;
  };
  value = pCmd->Value();
  if (value == 7) value = m_program[index++];
  if (value != 0) col = encodeInteger(text, col, value);
  return CString(text, col);
}

CString DSAAction::EncodeN(int &index, int curState)
{
  DSAnoopCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSAnoopCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'N';
  return CString(text, col);
}

CString DSAAction::EncodeEqual(int &index, int curState)
{
  DSAequalCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSAequalCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = '=';
  text[col++] = '=';
  return CString(text, col);
}

struct AMPERSANDOP
{
  char *name;
  STKOP subop;
};

AMPERSANDOP ampersandOPs[] = 
{
  {"ROLL"           ,STKOP_Roll},
  {"-ROLL"          ,STKOP_MinusRoll},
  {"ROT"            ,STKOP_Rot},
  {"-ROT"           ,STKOP_MinusRot},
  {"PICK"           ,STKOP_Pick},
  {"2PICK"          ,STKOP_2Pick},
  {"+"              ,STKOP_Plus},
  {"NEG"            ,STKOP_Neg},
  {"="              ,STKOP_Equal},
  {"!="             ,STKOP_NotEqual},
  {"POKE"           ,STKOP_Poke},
  {"DROP"           ,STKOP_Drop},
  {"TYPE"           ,STKOP_Type},
  {"DEL"            ,STKOP_Del},
  {"ADD"            ,STKOP_Add},
  {"MOVE"           ,STKOP_Move},
  {"DUP"            ,STKOP_Dup},
  {"1-"             ,STKOP_1Minus},
  {"1+"             ,STKOP_1Plus},
  {"SWAP"           ,STKOP_Swap},
  {"OVER"           ,STKOP_Over},
  {"AND"            ,STKOP_And},
  {"XOR"            ,STKOP_Xor},
  {"SHIFT"          ,STKOP_Shift},
  {"RSHIFT"         ,STKOP_RShift},
  {"COMP"           ,STKOP_Comp},
  {"OR"             ,STKOP_Or},
  {"2DUP"           ,STKOP_2Dup},
  {"*"              ,STKOP_Gear},
  {"/"              ,STKOP_Slash},
  {"%"              ,STKOP_Percent},
  {"SETNEWSTATE"    ,STKOP_SetNewState},
  {"<"              ,STKOP_Less},
  {"U<"             ,STKOP_ULess},
  {"2DROP"          ,STKOP_2Drop},
  {"NOT"            ,STKOP_Not},
  {"FALSEPIT"       ,STKOP_FalsePit},
  {"GENERATORDELAY!",STKOP_GeneratorDelayStore},
  {"OVERLAY"        ,STKOP_Overlay},
  {"PALETTE"        ,STKOP_Palette},
  {"DISABLESAVES"   ,STKOP_DisableSaves},
  {"@"              ,STKOP_Fetch},
  {"!"              ,STKOP_Store},
  {"PARAM@"         ,STKOP_ParamFetch},
  {"PARAM!"         ,STKOP_ParamStore},
  {"MESSAGE"        ,STKOP_Message},
  {"CAST"           ,STKOP_Cast},
  {"ECF@"           ,STKOP_FetchExCellFlg},
  {"ECF!"           ,STKOP_StoreExCellFlg},
  {"CHPOSS"         ,STKOP_ChPoss},
  {"MONPOSS"        ,STKOP_MonPoss},
  {"SAY"            ,STKOP_Say},
  {"LOC2ABSCOORD"   ,STKOP_Loc2AbsCoord},
  {"MASTERY"        ,STKOP_Mastery},
  {"SETCURSE"       ,STKOP_SetCurse},
  {"GETCURSE"       ,STKOP_GetCurse},
  {"SETCHARGES"     ,STKOP_SetCharges},
  {"GETCHARGES"     ,STKOP_GetCharges},
  {"SETBROKEN"      ,STKOP_SetBroken},
  {"GETBROKEN"      ,STKOP_GetBroken},
  {"GETPOISONED"    ,STKOP_GetPoisoned},
  {"SETPOISONED"    ,STKOP_SetPoisoned},
  {"CELL@"          ,STKOP_CellFetch},
  {"CELL!"          ,STKOP_CellStore},
  {"GLOBAL@"        ,STKOP_GlobalFetch},
  {"MONSTER@"       ,STKOP_MonsterFetch},
  {"MONSTER!"       ,STKOP_MonsterStore},
  {"THROW"          ,STKOP_Throw},
  {"TELEPORTPARTY"  ,STKOP_TeleportParty},
  {"PARTY@"         ,STKOP_PartyFetch},
  {"CHAR@"          ,STKOP_CharFetch},
  {"CHAR!"          ,STKOP_CharStore},
  {"RAND"           ,STKOP_Random},
  {"CREATECLOUD"    ,STKOP_CreateCloud},
  {"SOUND"          ,STKOP_Sound},
  {"MONBLK"         ,STKOP_MonBlk},
  {"DESCRIBE"       ,STKOP_Describe},
  {"COPY"           ,STKOP_Copy},
  {"%DEL"           ,STKOP_I_Del},
  {"%ADD"           ,STKOP_I_Add},
  {"%CREATECLOUD"   ,STKOP_I_CreateCloud},
  {"%CAST"          ,STKOP_I_Cast},
  {"%TELEPORTPARTY" ,STKOP_I_TeleportParty},
  {"%MONSTER!"      ,STKOP_I_MonsterStore},
  {"%CHAR!"         ,STKOP_I_CharStore},
  {"%MOVE"          ,STKOP_I_Move},
  {"%COPY"          ,STKOP_I_Copy},
  {"%CELL!"         ,STKOP_I_CellStore},
  {"%THROW"         ,STKOP_I_Throw},
  {"%INDIRECT"      ,STKOP_I_Indirect},
  {"%DELAY"         ,STKOP_I_Delay},
  {"%DELMON"        ,STKOP_I_DelMon},
  {"%INSMON"        ,STKOP_I_InsMon},
  {"DELMON"         ,STKOP_DelMon},
  {"INSMON"         ,STKOP_InsMon},
  {"TIME@"          ,STKOP_TimeFetch},
  {"J*"             ,STKOP_JumpGear},
  {"G*"             ,STKOP_GosubGear},
  {"GENERATORDELAY@",STKOP_GeneratorDelayFetch},
  {"MISSILEINFO@"   ,STKOP_MissileInfoFetch},
  {"MISSILEINFO!"   ,STKOP_MissileInfoStore},
  {"TEXT@"          ,STKOP_TextFetch},
  {"TEXTSAY"        ,STKOP_TextSay},
  {"MONL&D"         ,STKOP_MonLandD},
  {"COUNTINJURY"    ,STKOP_CountInjury},
  {"NEIGHBORS"      ,STKOP_Neighbors},
  {"THISCELL"       ,STKOP_ThisCell},
  {"BITCOUNT"       ,STKOP_BitCount},
  {"CAUSEPOISON"    ,STKOP_CausePoison},
  {"%CAUSEPOISON"   ,STKOP_I_CausePoison},
  {"MULTIPLIER@"    ,STKOP_MultiplierFetch},
  {"EXPERIENCE+"    ,STKOP_ExperiencePlus},
};

#define numAmpersandOp (sizeof(ampersandOPs)/sizeof(ampersandOPs[0]))

CString DSAAction::EncodeAmpersand(int &index, int curState)
{
  DSAampersandCmd *pCmd;
  char *pName;
  int newState;
  int i, j;
  STKOP subOp;
  char text[20];
  int col = 0;
  pCmd = (DSAampersandCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = '&';
  subOp = pCmd->SubCode();
  for (i=0; i<numAmpersandOp; i++)
  {
    if (ampersandOPs[i].subop != subOp) continue;
    pName = ampersandOPs[i].name;
    for (j=0; pName[j]!=0; j++) text[col++] = pName[j];
    return CString(text, col);
  };
  pDoc->Warning ("Illegal Ampersand Subop");
  return CString(text,col);
}

CString DSAAction::EncodeVariableFetch(int &index, int curState)
{
  DSAvariableFetchCmd *pCmd;
  int col=0, newState, idx;
  char text[20];
  pCmd = (DSAvariableFetchCmd *)(m_program+index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'V';
  idx = pCmd->Index();
  col = encodeInteger(text,col,idx);
  text[col++] = '@';
  return CString(text, col);
}

CString DSAAction::EncodeVariableStore(int &index, int curState)
{
  DSAvariableStoreCmd *pCmd;
  int col=0, newState, idx;
  char text[20];
  pCmd = (DSAvariableStoreCmd *)(m_program+index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'V';
  idx = pCmd->Index();
  col = encodeInteger(text,col,idx);
  text[col++] = '!';
  return CString(text, col);
}

CString DSAAction::EncodeGlobalFetch(int &index, int curState)
{
  DSAglobalFetchCmd *pCmd;
  int col=0, newState, idx;
  char text[20];
  pCmd = (DSAglobalFetchCmd *)(m_program+index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'G';
  text[col++] = 'V';
  idx = pCmd->Index();
  col = encodeInteger(text,col,idx);
  text[col++] = '@';
  return CString(text, col);
}

CString DSAAction::EncodeGlobalStore(int &index, int curState)
{
  DSAglobalStoreCmd *pCmd;
  int col=0, newState, idx;
  char text[20];
  pCmd = (DSAglobalStoreCmd *)(m_program+index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'G';
  text[col++] = 'V';
  idx = pCmd->Index();
  col = encodeInteger(text,col,idx);
  text[col++] = '!';
  return CString(text, col);
}


CString DSAAction::EncodeF(int &index, int curState)
{
  DSAfetchCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSAfetchCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'F';
  return CString(text, col);
}

CString DSAAction::EncodeR(int &index, int curState)
{
  DSArandomCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSArandomCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'R';
  switch (pCmd->Value())
  {
  case 28:
    col = encodeInteger(text,col,m_program[index++]);
    break;
  case 29:
    text[col++] = 'A';
    break;
  case 30:
    text[col++] = 'B';
    break;
  case 31:
    text[col++] = '*';
    break;
  default:
    col = encodeInteger(text,col,pCmd->Value());
    break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeCT(int &index, int curState)
{
  DSAcopyTeleporterCmd *pCmd;
  int newState;
  char text[20];
  int col = 0;
  pCmd = (DSAcopyTeleporterCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'C';
  text[col++] = 'T';
  switch (pCmd->TargetFrom())
  {
  case TARGET_A: text[col++] = 'A'; break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    col = encodeAbsTarget(text, col, m_program[index++]);
    break;
  default: Strange("Unknown target type"); break;
  };
  switch (pCmd->TargetTo())
  {
  case TARGET_A: text[col++] = 'A'; break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    col = encodeAbsTarget(text, col, m_program[index++]);
    break;
  default: Strange("Unknown target type"); break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeCT32(int &index, int curState)
{
  DSAcopyTeleporterCmd *pCmd;
  int newState;
  unsigned int integerTarget;
  char text[20];
  int col = 0;
  pCmd = (DSAcopyTeleporterCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'C';
  text[col++] = 'T';
  switch (pCmd->TargetFrom())
  {
  case TARGET_A: text[col++] = 'A'; break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    integerTarget = m_program[index++];
    integerTarget |= m_program[index++];
    col = encodeAbsTarget(text, col, integerTarget);
    break;
  default: Strange("Unknown target type"); break;
  };
  switch (pCmd->TargetTo())
  {
  case TARGET_A: text[col++] = 'A'; break;
  case TARGET_B: text[col++] = 'B'; break;
  case TARGET_ABS:
    integerTarget = m_program[index++];
    integerTarget |= m_program[index++];
    col = encodeAbsTarget(text, col, integerTarget);
    break;
  default: Strange("Unknown target type"); break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeG(int &index, int curState)
{
  DSAgosubCmd *pCmd;
  int newState;
  unsigned int gosubRow, gosubColumn;
  char text[20];
  int col = 0;
  pCmd = (DSAgosubCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'G';
  gosubRow = pCmd->Row();
  if (gosubRow == 63) gosubRow = m_program[index++];
  if (gosubRow != (unsigned)curState)
  {
    col = encodeInteger(text, col, gosubRow);
  };
  if (pCmd->Column() != 0)
  {
    gosubColumn = m_program[index++];
    col = encodeColumn(text, col, gosubColumn);
  };
  return CString(text, col);
}

CString DSAAction::EncodeJ(int &index, int curState)
{
  DSAjumpCmd *pCmd;
  int newState;
  unsigned int jumpRow, jumpColumn;
  char text[20];
  int col = 0;
  pCmd = (DSAjumpCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curState+newState);
  };
  text[col++] = 'J';
  jumpRow = pCmd->Row();
  if (jumpRow == 63) jumpRow = m_program[index++];
  if (jumpRow != (unsigned)curState)
  {
    col = encodeInteger(text, col, jumpRow);
  };
  if (pCmd->Column() != 0)
  {
    jumpColumn = m_program[index++];
    col = encodeColumn(text, col, jumpColumn);
  };
  return CString(text, col);
}

CString DSAAction::EncodeQuestion(int &index, int curstate)
{
  DSAquestionCmd *pCmd;
  int newState;
  int row;
  char text[20];
  int col = 0;
  pCmd = (DSAquestionCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curstate+newState);
  };
  text[col++] = '?';
  switch (pCmd->IfCmd())
  {
  case 0: break;
  case 1:
    text[col++] = 'J';
    row = m_program[index++];
    if (row != curstate)
    {
      col = encodeInteger(text, col, row);
    };
    if (pCmd->IfColumn())
    {
      col = encodeColumn(text,col,m_program[index++]);
    };
    break;
  case 2:
    text[col++] = 'G';
    row = m_program[index++];
    if (row != curstate)
    {
      col = encodeInteger(text, col, row);
    };
    if (pCmd->IfColumn())
    {
      col = encodeColumn(text,col,m_program[index++]);
    };
    break;
  };
  switch (pCmd->ElseCmd())
  {
  case 0: break;
  case 1:
    text[col++] = ':';
    text[col++] = 'J';
    row = m_program[index++];
    if (row != curstate)
    {
      col = encodeInteger(text, col, row);
    };
    if (pCmd->ElseColumn())
    {
      col = encodeColumn(text,col,m_program[index++]);
    };
    break;
  case 2:
    text[col++] = ':';
    text[col++] = 'G';
    row = m_program[index++];
    if (row != curstate)
    {
      col = encodeInteger(text, col, row);
    };
    if (pCmd->ElseColumn())
    {
      col = encodeColumn(text,col,m_program[index++]);
    };
    break;
  };
  return CString(text, col);
}

CString DSAAction::EncodeCase(int &index, int curstate)
{
  DSAcaseCmd *pCmd;
  int newState;
  int row;
  CString result;
  char text[20];
  int col = 0, numCase, i, n, column;
  pCmd = (DSAcaseCmd *)(m_program + index);
  index++;
  if (pCmd->NextState() != 0)
  {
    if (pCmd->IsMaxState())
    {
      newState = (i16)m_program[index++];
    }
    else
    {
      newState = pCmd->NextState();
    };
    col = encodeInteger(text, col, curstate+newState);
  };
  text[col] = 0;
  result = text;
  result += "??{";
  numCase = m_program[index++];
  for (i=0; i<numCase; i++)
  {
    result += '(';
    n = m_program[index++];
    n |= m_program[index++] << 16;
    sprintf(text,"%d",n);
    result += text;
    result += ',';
    n = m_program[index++];
    n |= m_program[index++] << 16;
    row = n>>8;
    column = n&0xff;
    col=0;
    if (row!=curstate) col = encodeInteger(text, col, row);
    col = encodeColumn(text, col, column);
    text[col]=0;
    result += text;
    result += ')';
  };
  result += '}';
  return result;
}

CString DSAAction::EncodeToASCII(int curState)
{
  DSAgeneralCmd *pGeneral;
  DSACOMMAND commandCode;
  CString result;
  int index;
  if (m_numPgmWords == 0) return result;
  index = 0;
  while (index<m_numPgmWords)
  {
    pGeneral = (DSAgeneralCmd *)(m_program+index);
    commandCode = pGeneral->CmdCode();
    if (index != 0) result += ' ';
    switch (commandCode)
    {
    case DSACMD_FETCH:
      result += EncodeF(index, curState);
      break;
    case DSACMD_EQUAL:
      result += EncodeEqual(index, curState);
      break;
    case DSACMD_MESSAGE:
      result += EncodeM(index, curState);
      break;
    case DSACMD_MESSAGE32:
      result += EncodeM32(index, curState);
      break;
    case DSACMD_OVERRIDE:
      result += EncodeO(index, curState);
      break;
    case DSACMD_NOOP:
      result += EncodeN(index, curState);
      break;
    case DSACMD_COPYTELEPORTER:
      result += EncodeCT(index, curState);
      break;
    case DSACMD_COPYTELEPORTER32:
      result += EncodeCT32(index, curState);
      break;
    case DSACMD_GOSUB:
      result += EncodeG(index, curState);
      break;
    case DSACMD_JUMP:
      result += EncodeJ(index, curState);
      break;
    case DSACMD_LOAD:
      result += EncodeL(index, curState);
      break;
    case DSACMD_STORE:
      result += EncodeS(index, curState);
      break;
    case DSACMD_QUESTION:
      result += EncodeQuestion(index, curState);
      break;
    case DSACMD_CASE:
      result += EncodeCase(index, curState);
      break;
    case DSACMD_RANDOM:
      result += EncodeR(index, curState);
      break;
    case DSACMD_AMPERSAND:
      result += EncodeAmpersand(index, curState);
      break;
    case DSACMD_VARIABLEFETCH:
      result += EncodeVariableFetch(index, curState);
      break;
    case DSACMD_VARIABLESTORE:
      result += EncodeVariableStore(index, curState);
      break;
    case DSACMD_GLOBALFETCH:
      result += EncodeGlobalFetch(index, curState);
      break;
    case DSACMD_GLOBALSTORE:
      result += EncodeGlobalStore(index, curState);
      break;
    default:
      Strange("Unknown DSA command code");
      return CString("");
    };
  };
  return result;
}

bool decodeInteger(const char* &pC, unsigned int &result)
{ //returns true if integer encountered
  char c;
  result = 0;
  bool digitEncountered = false;
  for (;;)
  {
    c = *pC;
    if ( (c>='0') && (c<='9') )
    {
      pC++;
      result = result*10 + c - '0';
      digitEncountered = true;
      continue;
    }
    else return digitEncountered;
  };
  //return digitEncountered;
}

void decodeTarget(const char* &pC, 
                 TARGET &target)
{
  // <target> = <empty> | A | B | <abs location>
  const char *saveInput;
  unsigned int level, x, y;
  LOCATIONABS loca;
  LOCATIONREL locr;
  saveInput = pC;
  for (;;) //To provide an easy error exit via 'break'
  {
    if ((*pC==' ')||(*pC==0)) break; //Use default
    switch (*pC)
    {
    case 'A': target.type = TARGET_A; pC++; return;
    case 'B': target.type = TARGET_B; pC++; return;
    case '*': target.type = TARGET_GEAR; pC++; return;
    };
    //Attempt to decode an <abs location>
    // == level(x,y)[pos]
    if(!decodeInteger(pC, level)) break;
    if (level > 63) break;
    target.target.l(level);
    if (*pC != '(') break;
    pC++;
    if (!decodeInteger(pC, x)) break;
    if (*pC != ',') break;
    pC++;
    if (!decodeInteger(pC, y)) break;
    if (*pC != ')') break;
    pC++;
    target.target.p(0); //Default
    switch(*pC)
    {
    case 'N': target.target.p(0); pC++; break;
    case 'E': target.target.p(1); pC++; break;
    case 'S': target.target.p(2); pC++; break;
    case 'W': target.target.p(3); pC++; break;
    default:  target.target.p(0); break;
    };
    loca.l = level;
    loca.x = x;
    loca.y = y;
    locr = loca;
    if (locr.l() < 0) break;
    target.type = TARGET_ABS;
    target.target.l(locr.l());
    target.target.x(locr.x());
    target.target.y(locr.y());
    return;
  };
  // Return the default
  target.type = TARGET_A;  // 'A' = default
  target.target.x(0);
  target.target.y(0);
  target.target.l(0);
  target.target.p(0);
  pC = saveInput;
}

bool decodeRowCol(const char * &pC, 
                  unsigned int &row, 
                  unsigned int &column,
                  int curstate)
{
  //First is optional row.
  if (!decodeInteger(pC, row))
  {
    //Assume the row is the current row
    row = curstate;
  };
  //Next is optional ,column
  switch (*pC)
  {
  case 'S': column = 0; break;
  case 'C': column = 1; break;
  case 'T': column = 2; break;
  default: column = 0; return true;
  };
  pC++;
  switch (*pC)
  {
  case '0': column += 0; break;
  case '1': column += 3; break;
  case '2': column += 6; break;
  case '3': column += 9; break;
  default: return false;
  };
  pC++;
  return true;
}

bool DSAAction::DecodeM(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  unsigned int delay, delayType;
  unsigned int integerTarget;
  MESSAGETYPE msgType;
  DSAmessageCmd32 *pCmd;
  TARGET target;
  // Standard Message
  // Next optional part is <delay>
  delayType = 0; //Default is zero delay.
  delay = 0; //Just to avoid compiler warning.
  if (*pC != 0)
  {
    switch (*pC)
    {
    case 'X': delayType = 1; pC++; break;
    case 'Y': delayType = 2; pC++; break;
    default:
      if (!decodeInteger(pC, delay))
      {
        delayType = 0;
        delay = 0;
      }
      else
      {
        if (delay == 0) delayType = 0;
        else delayType = 3;
      };
    };
  };
  // Next necessary part is <message type>
  switch (*pC)
  {
  case 'N': msgType = MSG_NULL;   pC++; break;
  case 'S': msgType = MSG_SET;    pC++; break;
  case 'C': msgType = MSG_CLEAR;  pC++; break;
  case 'T': msgType = MSG_TOGGLE; pC++; break;
  default: return false;
  };
  // Next optional part is <target>
  decodeTarget(pC, target);
  if ( (*pC != 0) && (*pC != ' ') ) return false;
  // Now we have to pack the information
  // The max size is 5 words (cmd, state, delay, target)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 5), 
                              MALLOC047);
  pCmd = (DSAmessageCmd32 *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->Delay(delayType);
  if (delayType == 3) m_program[m_numPgmWords++] = (ui16)delay;
  pCmd->Target(target.type);
  if (target.type == TARGET_ABS)
  {
    integerTarget = target.target.Integer();
    m_program[m_numPgmWords++] = (ui16)(integerTarget & 0xffff);
    m_program[m_numPgmWords++] = (ui16)((integerTarget>>16)&0xffff);
  };
  pCmd->CmdCode();
  pCmd->MsgType(msgType);
  return true;
}

bool DSAAction::DecodeO(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  DSAoverrideCmd *pCmd;
  TARGET target;
  unsigned what, value;
  // Override position, etc.
  // Next necessary part is <what to override>
  if (*pC == 0) return false;
  switch (*pC)
  {
  case 'P': what = 1; pC++; break;
  default:
    return false;
  };
  // Next optional part is <value>
  if (!decodeInteger(pC, value))
  {
    value = 0;
  };
  // Now we have to pack the information
  // The max size is 4 words (cmd, state, delay, target)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 4), 
                              MALLOC048);
  pCmd = (DSAoverrideCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  pCmd->What(what);
  if (value > 6)
  {
    pCmd->Value(7);
    m_program[m_numPgmWords++] = (ui16)value;
  }
  else
  {
    pCmd->Value(value);
  };
  return true;
}

bool DSAAction::DecodeL(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  DSAloadCmd *pCmd;
  TARGET target;
  unsigned where;
  const char *oldPC;
  char c;
  unsigned int result=0;
  // Load value onto stack
  // Next necessary part is <value>
  oldPC =pC;
  c = *pC;
  if ((c>='A') && (c<='Z'))
  {
    pC++;
    where = c-'A';
  }
  else if (c=='$')
  {
    pC++;
    where = LOAD_$;
  }
  else
  {
    decodeTarget(pC, target);
    if (pC == oldPC)
    {
      // Perhaps it is an integer.
      decodeInteger(pC, result);
      if (pC == oldPC) return false;
      where = LOAD_INTEGER;
      if ((result & 0xffff8000) != 0)
      {
        where = LOAD_INTEGER32;
      };
    }
    else
    {
      if (target.type != TARGET_ABS) return false;
      result = target.target.Integer();
      if ((result & 0xffff8000)!=0)
      {
        where = LOAD_ABS32;
      }
      else
      {
        where = LOAD_ABS16;
      };
    };
  };
  // Now we have to pack the information
  // The max size is 4 words (cmd, value, state)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 4), 
                              MALLOC058);
  pCmd = (DSAloadCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  if (where == LOAD_INTEGER)
  {
    m_program[m_numPgmWords++] = (ui16)result;
    pCmd->Where(where);
  }
  else if (where == LOAD_INTEGER32)
  {
    m_program[m_numPgmWords++] = (ui16)(result & 0xffff);
    m_program[m_numPgmWords++] = (ui16)((result>>16) & 0xffff);
    pCmd->Where(where);
  }
  else if(where == LOAD_ABS16)
  {
    pCmd->Where(where);
    m_program[m_numPgmWords++] = (ui16)result;
  }
  else if (where == LOAD_ABS32)
  {
    pCmd->Where(where);
    m_program[m_numPgmWords++] = (ui16)(result & 0xffff);
    m_program[m_numPgmWords++] = (ui16)((result>>16) & 0xffff);
  }
  else if (where == LOAD_$)
  {
    pCmd->Where(where);
  }
  else
  {
    pCmd->Where(where);
  };
  pCmd->CmdCode();
  return true;
}

bool DSAAction::DecodeV(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  DSAvariableFetchCmd *pCmd; // Also used for DSAvariableStoreCmd.  They are identical.
  DSACOMMAND command;
  const char *oldPC;
  char c;
  unsigned int result=0;
  // Load value onto stack
  // Next necessary part is <index>
  oldPC =pC;
  c = *pC;
  // It better be an integer.
  decodeInteger(pC, result);
  if (pC == oldPC) return false;
  if (result > 99) return false;
  // Now check for '@' or '!'
  switch (*(pC++))
  {
  case '@': command = DSACMD_VARIABLEFETCH; break;
  case '!': command = DSACMD_VARIABLESTORE; break;
  default: return false;
  };
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC058);
  pCmd = (DSAvariableFetchCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->Index(result); // the index
  pCmd->CmdCode(command);
  return true;
}


bool DSAAction::DecodeGV(const char* &pC, 
                         int relstate)
{ //Add command to program.  Return true if all is well.
  DSAglobalFetchCmd *pCmd; // Also used for DSAglobalStoreCmd.  They are identical.
  DSACOMMAND command;
  const char *oldPC;
  char c;
  unsigned int result=0;
  // Load value onto stack
  // Next necessary part is <index>
  oldPC =pC;
  c = *pC;
  // It better be an integer.
  decodeInteger(pC, result);
  if (pC == oldPC) return false;
  if (result > 99) return false;
  // Now check for '@' or '!'
  switch (*(pC++))
  {
  case '@': command = DSACMD_GLOBALFETCH; break;
  case '!': command = DSACMD_GLOBALSTORE; break;
  default: return false;
  };
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC058);
  pCmd = (DSAglobalFetchCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->Index(result); // the index
  pCmd->CmdCode(command);
  return true;
}



bool DSAAction::DecodeS(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  DSAstoreCmd *pCmd;
  TARGET target;
  unsigned where;
  const char *oldPC;
  char c;
  // Store value from stack
  // Next necessary part is <where>
  oldPC =pC;
  c = *pC;
  if ((c>='A') && (c<='Z'))
  {
    pC++;
    where = c-'A';
  }
  else return false;
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC058);
  pCmd = (DSAstoreCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
    pCmd->Where(where);
  pCmd->CmdCode();
  return true;
}

bool DSAAction::DecodeG(const char* &pC, 
                        int relstate,
                        int curstate)
{ //Add command to program.  Return true if all is well.
  DSAgosubCmd *pCmd;
  unsigned int gosubRow, gosubColumn;
  if (!decodeRowCol(pC, gosubRow, gosubColumn,curstate)) return false;
  // Next mandatory part is gosubRow[column]
  // Now we have to pack the information
  // The max size is 4 words (cmd, state, delay, target)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 4), 
                              MALLOC056);
  pCmd = (DSAgosubCmd *)(m_program + m_numPgmWords);
  pCmd->CmdCode();
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  if (gosubRow > 62)
  {
    m_program[m_numPgmWords++] = (ui16)gosubRow;
    pCmd->Row(63);
  }
  else
  {
    pCmd->Row(gosubRow);
  };
  if (gosubColumn > 0)
  {
    m_program[m_numPgmWords++] = (ui16)gosubColumn;
    pCmd->Column(1);
  }
  else
  {
    pCmd->Column(0);
  };
  return true;
}

bool DSAAction::DecodeJ(const char* &pC, 
                        int relstate,
                        int curstate)
{ //Add command to program.  Return true if all is well.
  DSAjumpCmd *pCmd;
  unsigned int jumpRow, jumpColumn;
  if (!decodeRowCol(pC, jumpRow, jumpColumn,curstate)) return false;
  // Next mandatory part is jumpRow[column]
  // Now we have to pack the information
  // The max size is 4 words (cmd, state, delay, target)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 4), 
                              MALLOC056);
  pCmd = (DSAjumpCmd *)(m_program + m_numPgmWords);
  pCmd->CmdCode();
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  if (jumpRow > 62)
  {
    m_program[m_numPgmWords++] = (ui16)jumpRow;
    pCmd->Row(63);
  }
  else
  {
    pCmd->Row(jumpRow);
  };
  if (jumpColumn > 0)
  {
    m_program[m_numPgmWords++] = (ui16)jumpColumn;
    pCmd->Column(1);
  }
  else
  {
    pCmd->Column(0);
  };
  return true;
}

bool DSAAction::DecodeN(const char*  & /* pC */, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  //
  // Now we have to pack the information
  // The max size is 4 words (cmd, state, delay, target)
  DSAnoopCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC052);
  pCmd = (DSAnoopCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  return true;
}

bool DSAAction::DecodeR(const char*  &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  //
  DSArandomCmd *pCmd;
  unsigned int value;
  int vType;
  if (!decodeInteger(pC, value))
  {
    switch (*pC)
    {
    case '*': vType = 31; break;
    case 'A': vType = 29; break;
    case 'B': vType = 30; break;
    default: return false;
    };
    pC++;
  }
  else
  {
    if (value<28) vType = value;
    else vType = 28;
  };
  // Now we have to pack the information
  // The max size is 2 words (cmd, state, value)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 3), 
                              MALLOC061);
  pCmd = (DSArandomCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  pCmd->Value(vType);
  if (vType == 28) m_program[m_numPgmWords++] = (ui16)value;
  return true;
}

bool DSAAction::DecodeF(const char*  & /* pC */, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  //
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  DSAfetchCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC059);
  pCmd = (DSAfetchCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  return true;
}

bool decodeJG(const char * &pC,
              unsigned int &state,
              unsigned int &column,
              unsigned int &command,
              int curstate)
{
  switch (*pC)
  {
  case 'G':
    command = 2;
    break;
  case 'J':
    command = 1;
    break;
  default:
    return false;
  };
  pC++;
  if (!decodeRowCol(pC, state, column, curstate)) return false;
  return true;
}

bool DSAAction::DecodeQuestion(const char*  &pC , 
                               int relstate,
                               int curstate)
{ //Add command to program.  Return true if all is well.
  //
  unsigned int ifstate, ifcol, ifCMD;
  unsigned int elsestate, elsecol, elseCMD;
  if (*pC != ':') // 'if' part missing
  {
    if (!decodeJG(pC, ifstate, ifcol, ifCMD,curstate)) return false;
  }
  else
  { 
    ifstate = 0;
    ifcol = 0;
    ifCMD = 0;
  };
  switch (*pC)
  {
  case ':':
    pC++;
    if (!decodeJG(pC, elsestate, elsecol, elseCMD,curstate)) return false;
    break;
  case 0: 
  case ' ':
    elseCMD = 0;
    elsestate = 0;
    elsecol = 0;
    break;
  default:
    return false;
  };
  // Now we have to pack the information
  // The max size is 6 words (cmd, state, 
  //                          ifstate, ifcol,
  //                          elsestate, elsecol)
  DSAquestionCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 6), 
                              MALLOC060);
  pCmd = (DSAquestionCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  pCmd->IfCmd(ifCMD);
  pCmd->IfColumn(ifcol != 0);
  pCmd->ElseCmd(elseCMD);
  pCmd->ElseColumn(elsecol != 0);
  if (ifCMD != 0)
  {
    m_program[m_numPgmWords++] = (ui16)ifstate;
    if (ifcol != 0) m_program[m_numPgmWords++] = (ui16)ifcol;
  };
  if (elseCMD != 0)
  {
    m_program[m_numPgmWords++] = (ui16)elsestate;
    if (elsecol != 0) m_program[m_numPgmWords++] = (ui16)elsecol;
  };
  return true;
}

bool DSAAction::DecodeCase(const char*  &pC , 
                           int relstate,
                           int curstate)
{ //Add command to program.  Return true if all is well.
  //
  // '??' (Case command) has the form:
  // ??{(value,newstate/column)(value,newstate/column)....}
  // Program looks like this:
  //   command code
  //   # of cases
  // and repeated pairs:
  //   32-bit value
  //   32-bit state/column
  //
  TEMPORARY_MEMORY newPgm;//Collect the value/target pairs here
                   // then sort them and add to m_program
  i32 numCase = 0;
  ui32 temp;
  int i;
  unsigned int value, row, col;
  ui32 *pPgm;
  bool swap;
  if (*pC != '{') return false;
  pC++;
  while ( *pC != '}')
  { //compile  single "(value,target)"
    if (*pC != '(') return false;
    pC++;
    if (!decodeInteger(pC, value)) return false;
    if (*pC != ',') return false;
    pC++;
    if (!decodeRowCol(pC, row, col, curstate)) return false;
    if (*pC != ')') return false;
    pC++;
    numCase++;
    newPgm.m = (char *)realloc(newPgm.m, 8*numCase, MALLOC092);
    pPgm = (ui32 *)newPgm.m;
    pPgm[2*(numCase-1)] = value;
    pPgm[2*(numCase-1)+1] = (row<<8) + col;
  };
  pC++; //Skip over the '}'
  // All seems well.  Now we sort the cases for easy searching.
  pPgm = (ui32 *)newPgm.m;
  do
  {
    swap = false;
    for (i=0; i<numCase-1; i++)
    {
      if (pPgm[2*i] <= pPgm[2*i+2]) continue;
      temp        = pPgm[2*i];
      pPgm[2*i]   = pPgm[2*i+2];
      pPgm[2*i+2] = temp;
      temp        = pPgm[2*i+1];
      pPgm[2*i+1] = pPgm[2*i+3];
      pPgm[2*i+3] = temp;
      swap = true;
    }
  } while (swap);
  // Now we can add the new command to m_program;
  DSAcaseCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2*m_numPgmWords + 8*numCase + 6, 
                              MALLOC093);
  pCmd = (DSAcaseCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  m_program[m_numPgmWords++] = (ui16)numCase;
  pPgm = (ui32 *)newPgm.m;
  for (i=0; i<numCase; i++)
  {
    m_program[m_numPgmWords++] = (ui16)(pPgm[2*i] & 0xffff);
    m_program[m_numPgmWords++] = (ui16)((pPgm[2*i]>>16) & 0xffff);
    m_program[m_numPgmWords++] = (ui16)(pPgm[2*i+1] & 0xffff);
    m_program[m_numPgmWords++] = (ui16)((pPgm[2*i+1]>>16) & 0xffff);
  };
  return true;
}

bool DSAAction::DecodeEqual(const char*  & pC, 
                            int relstate)
{ //Add command to program.  Return true if all is well.
  //
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  if (*pC != '=') return false;
  pC++;
  DSAequalCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC059);
  pCmd = (DSAequalCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  return true;
}

bool DSAAction::DecodeAmpersand(const char*  & pC, 
                                int relstate)
{ //Add command to program.  Return true if all is well.
  //
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  const char *pAscii;
  char *pName;
  int len, i, j;
  DSAampersandCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC064);
  pCmd = (DSAampersandCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  pAscii = pC;
  while ( (*pC != ' ') && (*pC != 0)) pC++;
  len = pC - pAscii;
  for (i=0; i<numAmpersandOp; i++)
  {
    pName = ampersandOPs[i].name;
    for (j=0; j<len; j++)
    {
      if (pName[j] != pAscii[j]) break;
    };
    if ( (j!=len)||(pName[j]!=0) ) continue;
    pCmd->SubCode(ampersandOPs[i].subop);
    return true;
  };
  return false;
}


/*
bool DSAAction::DecodeVariableFetch(const char*  & pC, 
                                    int relstate)
{ //Add command to program.  Return true if all is well.
  //
  // Now we have to pack the information
  // The max size is 2 words (cmd, state)
  const char *pAscii;
  char *pName;
  int len, i, j;
  DSAvariableFetchCmd *pCmd;
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 2), 
                              MALLOC064);
  pCmd = (DSAvariableFetchCmd *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->CmdCode();
  pAscii = pC;
  NotImplemented();
  while ( (*pC != ' ') && (*pC != 0)) pC++;
  len = pC - pAscii;
  for (i=0; i<numAmpersandOp; i++)
  {
    pName = ampersandOPs[i].name;
    for (j=0; j<len; j++)
    {
      if (pName[j] != pAscii[j]) break;
    };
    if ( (j!=len)||(pName[j]!=0) ) continue;
    pCmd->SubCode(ampersandOPs[i].subop);
    return true;
  };
  return false;
}
*/

bool DSAAction::DecodeCT(const char* &pC, 
                        int relstate)
{ //Add command to program.  Return true if all is well.
  DSAcopyTeleporterCmd32 *pCmd;
  ui32 integerTarget;
  TARGET from;
  TARGET to;
  // Next necessary part is <from>
  if ((*pC==0)||(*pC==' ')) return false;
  decodeTarget(pC, from);
  // Next necessary part is <to>.
  if ((*pC==0)||(*pC==' ')) return false;
  decodeTarget(pC, to);
  // Now we have to pack the information
  // The max size is 6 words (cmd, from, to, state)
  m_program = (ui16 *)realloc(m_program, 
                              2 * (m_numPgmWords + 6), 
                              MALLOC054);
  pCmd = (DSAcopyTeleporterCmd32 *)(m_program + m_numPgmWords);
  m_numPgmWords++; //The command itself.
  if (pCmd->StateFits(relstate))
  {
    pCmd->NextState(relstate);
  }
  else
  {
    pCmd->SetMaxState();
    m_program[m_numPgmWords++] = (ui16)relstate;
  };
  pCmd->TargetFrom(from.type);
  if (from.type == TARGET_ABS)
  {
    integerTarget = from.target.Integer();
    m_program[m_numPgmWords++] = (ui16)(integerTarget& 0xffff);
    m_program[m_numPgmWords++] = (ui16)((integerTarget>>16) & 0xffff);
  };
  pCmd->TargetTo(to.type);
  if (to.type == TARGET_ABS)
  {
    integerTarget = to.target.Integer();
    m_program[m_numPgmWords++] = (ui16)(integerTarget&0xffff);
    m_program[m_numPgmWords++] = (ui16)((integerTarget>>16)&0xffff);
  };
  pCmd->CmdCode();
  return true;
}

int DSAAction::DecodeFromASCII(const CString& pgm,
                               int curState)
{ //If any error occurs then the original
  //program is left unchanged.
  //Returns error column (or -1)
  unsigned int newState;
  char cmd;
  int ecol; //Error column
  ui16 *originalPgm = m_program;
  int  originalPgmLength = m_numPgmWords;
  int result;
  const char *pC;
  const char *cPgm = (LPCTSTR)pgm;
  m_numPgmWords = 0;
  m_program = NULL;
  for (pC=cPgm; *pC!=0; pC++) 
  {
    if (*pC != ' ') break;
  };
  if (*pC == 0) 
  {
    if (m_program != NULL) free(m_program);
    m_numPgmWords = 0;
    return -1;//Empty program.  No problem.
  };
  pC = cPgm;
  result = -1; //Assume that all is well.
  while (*pC != 0)
  { //Decode one command.
    ecol = pC-cPgm; //If error then this is column of command in error.
    //Skip any leading blanks
    while (*pC == ' ') pC++;
    if (*pC == 0) break;
    //All messages start with integer 'new state'
    if (!decodeInteger(pC, newState)) newState = curState;
    if (newState > 255) {result = ecol; break;};
    if (*pC == 0) 
    {
      result = ecol; //command is required
      break;
    };
    cmd = *(pC++);
    switch (cmd)
    {
    case '?':
      if (*pC == '?') //Is it a '??' (CASE command)
      {
        pC++;
        if (!DecodeCase(pC,newState-curState,curState)) result = ecol;
        break;
      };
      if (!DecodeQuestion(pC,newState-curState,curState)) result = ecol;
      break;
    case '=':
      if (!DecodeEqual(pC, newState-curState)) result = ecol;
      break;
    case '&':
      if (!DecodeAmpersand(pC, newState-curState)) result = ecol;
      break;
    case 'V':
      if (!DecodeV(pC, newState-curState)) result = ecol;
      break;
    case 'C': //Copy
      if (*pC == 0)
      {
        result = ecol;
        break;
      };
      cmd = *(pC++);
      switch (cmd)
      {
      case 'T':  //Copy teleporters
        if (!DecodeCT(pC, newState-curState)) result = ecol;
        break;
      default: result = ecol;
      };
      break;
    case 'F':
      if (!DecodeF(pC, newState-curState)) result = ecol;
      break;
    case 'G':
      if (*pC != 'V')
      {
        if (!DecodeG(pC, newState-curState, curState)) result = ecol;
      }
      else
      {
        pC++;
        if (!DecodeGV(pC, newState-curState)) result = ecol;
      };
      break;
    case 'J':
      if (!DecodeJ(pC, newState-curState, curState))result = ecol;
      break;
    case 'L':
      if (!DecodeL(pC, newState-curState)) result = ecol;
      break;
    case 'M':
      if (!DecodeM(pC, newState-curState)) result = ecol;
      break;
    case 'N':
      if (!DecodeN(pC, newState-curState)) result = ecol;
      break;
    case 'O':
      if (!DecodeO(pC, newState-curState)) result = ecol;
      break;
    case 'R':
      if (!DecodeR(pC, newState-curState)) result = ecol;
      break;
    case 'S':
      if (!DecodeS(pC, newState-curState)) result = ecol;
      break;
    default: result = ecol; break;
    };
    if ((*pC != 0) && (*pC!=' ')) result=ecol;
    if (result >= 0) break;
  };
  if (result >= 0)
  {
    if (m_program != NULL) free(m_program);
    m_program = originalPgm;
    m_numPgmWords = originalPgmLength;
  }
  else
  {
    if (originalPgm != NULL) free(originalPgm);
  };
  return result;
}

void DSAAction::Write(void)
{
  pDoc->WCS(&m_column);
  pDoc->WCS(&m_numPgmWords);
  pDoc->WCS(m_program, m_numPgmWords);
}

void DSAAction::Export(FILE *f, int state)
{
  CString ascii;
  ascii = EncodeToASCII(state);
  fprintf(f,"%s = %s\n",colName[m_column],(LPCSTR)ascii);
}

void DSAAction::Read(void)
{
  pDoc->RCS(&m_column);
  pDoc->RCS(&m_numPgmWords);
  m_program = (ui16 *)malloc(
           m_numPgmWords * sizeof (ui16),
           MALLOC051);
  pDoc->RCS(m_program, m_numPgmWords);
}

DSAState::DSAState(void)
{
  m_numAction = 0;
  m_pActions = NULL;
}

DSAState::~DSAState(void)
{
  int i;
  for (i=0; i<m_numAction; i++)
  {
    delete m_pActions[i];
    m_pActions[i] = NULL;
  };
  if (m_pActions != NULL) free (m_pActions);
  m_pActions = NULL;
  m_numAction = 0;
}

DSAState& DSAState::operator =(DSAState& state)
{
  int i;
  for (i=0; i<m_numAction; i++)
  {
    delete m_pActions[i];
  };
  if (m_pActions != NULL) free(m_pActions);
  m_pActions = NULL;
  m_numAction = state.m_numAction;
  if (m_numAction != 0)
  {
    m_pActions = (DSAAction **) malloc(
                      m_numAction * sizeof (m_pActions[0]),
                      MALLOC045);
  };
  for (i=0; i<m_numAction; i++)
  {
    m_pActions[i] = new DSAAction;
    *m_pActions[i] = *state.m_pActions[i];
  };
  return *this;
}

bool DSAState::operator != (DSAState& ds)
{
  int i, j;
  char check[12];
  DSAAction emptyAction;
  memset(check, 0, 12);
  for (i=0; i<m_numAction; i++)
  {
    for (j=0; j<ds.m_numAction; j++)
    {
      if (ds.m_pActions[j]->m_column != m_pActions[i]->m_column) continue;
      if (m_pActions[i] != ds.m_pActions[j]) return true;
      check[m_pActions[i]->m_column] = 1;
      break;
    };
    if (check[m_pActions[i]->m_column] == 0)
    {
      if (*m_pActions[i] != emptyAction) return true;
    };
  };
  for (i=0; i<ds.m_numAction; i++)
  {
    if (check[ds.m_pActions[i]->m_column] != 0) continue;
    if (*ds.m_pActions[i] != emptyAction) return true;
  };
  return false;
}

void DSAState::compress(void)
{
  bool deletion;
  DSAAction emptyAction;
  int i;
  for (i=0; i<m_numAction; i++)
  {
    m_pActions[i]->compress();
  };
  do
  {
    deletion = false;
    for (i=0; i<m_numAction; i++)
    {
      if (*m_pActions[i] != emptyAction) continue;
      DeleteAction(m_pActions[i]->m_column);
      deletion = true;
      break;
    };
  } while (deletion);
}

void DSAState::AddAction(int column)
{
  int i;
  for (i=0; i<m_numAction; i++)
  {
    if (m_pActions[i]->Column() == column) return;
  };
  m_numAction++;
  m_pActions = (DSAAction **)realloc(
                    m_pActions,
                    m_numAction * sizeof (m_pActions[0]),
                    MALLOC043);
  m_pActions[m_numAction-1] = new DSAAction;
  m_pActions[m_numAction-1]->Column(column);
}

void DSAState::DeleteAction(int column)
{
  int i;
  for (i=0; i<m_numAction; i++)
  {
    if (m_pActions[i]->Column() == column)
    {
      delete m_pActions[i];
      m_numAction--;
      m_pActions[i] = m_pActions[m_numAction];
      m_pActions[m_numAction] = NULL;
    };
  };
}

CString DSAState::Pgm(int msgIdx, int curState)
{
  int i;
  for (i=0; i<m_numAction; i++)
  {
    if (m_pActions[i]->Column() == msgIdx)
    {
      return m_pActions[i]->EncodeToASCII(curState);
    };
  };
  return CString("");
}

int DSAState::Pgm(int msgIdx, const CString& pgm, int state)
{ //Returns error column ( or -1 )
  int i;
  if (pgm == "")
  {
    DeleteAction(msgIdx);
    return -1;
  };
  AddAction(msgIdx);
  for (i=0; i<m_numAction; i++)
  {
    if (m_pActions[i]->Column() == msgIdx)
    {
      return m_pActions[i]->DecodeFromASCII(pgm, state);
    };
  };
  InternalError();
  return false;
}
